# Katherine Cordwell, kcordwel@andrew.cmu.edu, 15824
# The file "TarskiOutput1.txt" contains the output from running Christopher Brown's tool Tarski on a set of benchmarks from Platzer et al.  This code turns that output into the format of Mathematica queries.
# The file TarskiOutputOnEngland.txt contains the output from running Tarski on a set of benchmarks from Mulligan et al, freely available at https://zenodo.org/record/1226892#.XAmScRNKgXo. This code turns that output into the format of Mathematica queries.

# File IO for England benchmarks
#readOutputs = open("TarskiOutputOnEngland.txt", "r");
#writeOutputs = open("TarskiParseEngland_Formulas.txt","w");
#writeNames = open("TarskiParseEngland_Names.txt", "w");
# these will be in the format we need to run FormulaConvert on our heuristics
#writeOutputs2 = open("TarskiParseEngland_FormulasForHeuristics.txt", "w");

# File IO for KeYmaera 3 benchmarks 
readOutputs = open("TarskiOutput1.txt", "r");                                   
writeOutputs = open("TarskiParse_Formulas.txt","w");                              
writeNames = open("TarskiParse_Names.txt", "w");                                 
# these will be in the format we need to run FormulaConvert on our heuristics            
writeOutputs2 = open("TarskiParse_FormulasForHeuristics.txt", "w");   

lineIndex = 0;

num = 0;
prevLine = ""

for line in readOutputs:
    if line[0:9] == "> (def F " :
        prevLine = line;
    elif (line[0:9] != "> (def F " and line[0:10] != "> (syntax " and line != "> \n" and line != "\"In evaluating second argument to \'def\', received error - \"Could not interpret as Tarski Formula! Only constants are allowed in denominators!\":err\":err\n" and line != ":void\n" and line != "\"Symbol \'F\' not found!\":err\n"):
        line = line[1:-6] + "\n";
        charLoc = 0;
        while charLoc < len(line) - 2:
            if (line[charLoc].isalnum() and line[charLoc + 1] == " " and line[charLoc + 2].isalpha()):
                line = line[0:charLoc+1] + "*" + line[charLoc+2:];
            charLoc = charLoc + 1;
        VarSet = [];
        if (line[0:6] != "ForAll"):
            index = 0
            while index < len(line):
                if line[index].isalpha():
                    endword = index;
                    while (line[endword].isalnum()):
                        endword = endword + 1;
                    if not(line[index:endword] in VarSet):
                        VarSet.append(line[index:endword])
                    index = endword;
                else:
                    index = index + 1;
            variableNames = "";
            if VarSet != []:
                for var in VarSet:
                    variableNames = variableNames + var + ", ";
        #print(variableNames[:-2]);
                writeOutputs.write("Timing[Resolve[ForAll[{" + variableNames[:-2] + "}, Not[" + line[:-1] + "]], Reals]]\n");
                writeNames.write(prevLine);
                writeOutputs2.write("Timing[FormulaCallHeuristics[Not[" + line[:-1] + "]]]\n");
                num = num + 1;
readOutputs.close();
writeOutputs.close();
writeNames.close();
writeOutputs2.close();



