(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 11.3' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    272093,       6875]
NotebookOptionsPosition[    243003,       6454]
NotebookOutlinePosition[    243356,       6470]
CellTagsIndexPosition[    243313,       6467]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Katherine", " ", "Cordwell"}], ",", " ", 
   RowBox[{
    RowBox[{"kcordwel", "@", "andrew"}], ".", "cmu", ".", "edu"}], ",", " ", 
   RowBox[{"15824", " ", "Final", " ", "Project"}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.740931079362235*^9, 3.7409310898548927`*^9}, 
   3.740931169994019*^9, {3.74093121755904*^9, 3.7409312823497667`*^9}, {
   3.7409319028056393`*^9, 3.740931904016082*^9}, {3.740931967596468*^9, 
   3.740932053937847*^9}, {3.740932092447441*^9, 3.740932097572769*^9}, {
   3.741013602999791*^9, 3.741013604270997*^9}, {3.74109529411825*^9, 
   3.741095304324551*^9}, 3.741095338929515*^9, {3.7410953758536367`*^9, 
   3.7410953831603928`*^9}, {3.747610751408567*^9, 3.747610755211852*^9}, {
   3.75130701340471*^9, 3.7513070152022047`*^9}, {3.751307302184263*^9, 
   3.751307307500491*^9}, {3.751557754158008*^9, 3.751557901775791*^9}, 
   3.751558069724279*^9, {3.7515798776246223`*^9, 3.751579904049253*^9}, {
   3.751580190592668*^9, 3.7515802742262993`*^9}, {3.7515803171366673`*^9, 
   3.751580382711977*^9}, {3.75158041407806*^9, 3.7515804558331547`*^9}, {
   3.751580496533926*^9, 3.7515804970910587`*^9}, {3.751581590655303*^9, 
   3.751581614414394*^9}, {3.7515819427439003`*^9, 3.7515819831632013`*^9}, {
   3.7525907865500927`*^9, 3.752590787858944*^9}, {3.753115499157947*^9, 
   3.753115500245294*^9}},
 Background->GrayLevel[
  1],ExpressionUUID->"c6c9569f-523c-4502-aab1-b5e17bd4af93"],

Cell[CellGroupData[{

Cell["Discriminant Algorithm", "Section",
 CellChangeTimes->{{3.753115490103717*^9, 
  3.7531154936150846`*^9}},ExpressionUUID->"73da1ffb-786b-4873-ae85-\
aa93422db4d5"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Helper", " ", "function", " ", "for", " ", "DiscAlg"}], " ", 
   "*)"}], 
  RowBox[{
   RowBox[{
    RowBox[{"DiscAlgHelper", "[", 
     RowBox[{"poly_", ",", " ", "ineq_", ",", " ", "coeff_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "vList", ",", " ", "i", ",", " ", "newPoly", ",", " ", "evalList", ",",
         " ", "eVal", ",", " ", "varsCoeff", ",", " ", "coeffVal", ",", " ", 
        "evalCoeff", ",", " ", "newCoeff"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"newPoly", " ", "=", " ", "poly"}], ";", "\[IndentingNewLine]", 
       RowBox[{"newCoeff", " ", "=", " ", "coeff"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"vList", " ", "=", " ", 
        RowBox[{"Variables", "[", "newPoly", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"varsCoeff", " ", "=", " ", 
        RowBox[{"Variables", "[", "coeff", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
        "Test", " ", "the", " ", "polynomial", " ", "at", " ", "a", " ", 
         "point"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"evalList", " ", "=", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"#", "\[Rule]", "1"}], ")"}], " ", "&"}], " ", "/@", " ", 
         "vList"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"eVal", " ", "=", " ", 
        RowBox[{"newPoly", " ", "/.", " ", "evalList"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "We", " ", "need", " ", "the", " ", "leading", " ", "coefficient", 
         " ", "to", " ", "be", " ", "nonzero"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", "varsCoeff", "]"}], " ", ">", "0"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"evalCoeff", " ", "=", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"#", "\[Rule]", "1"}], ")"}], " ", "&"}], " ", "/@", 
            " ", "varsCoeff"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"coeffVal", " ", "=", " ", 
           RowBox[{"newCoeff", " ", "/.", " ", "evalCoeff"}]}], ";"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"coeffVal", " ", "=", " ", "newCoeff"}], ";"}]}], "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"ineq", " ", "\[Equal]", " ", "\"\<>\>\""}], " ", "&&", " ", 
          RowBox[{"coeffVal", " ", "\[NotEqual]", " ", "0"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"eVal", " ", "<=", " ", "0"}], ",", " ", 
            RowBox[{"Return", "[", "0", "]"}]}], "]"}], ";"}], ",", " ", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"eVal", " ", "\[GreaterEqual]", " ", "0"}], ",", 
           RowBox[{"Return", "[", "0", "]"}]}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Check", " ", "if", " ", "any", " ", "variable", " ", "has", " ", 
         "odd", " ", "degree"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"For", "[", " ", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "<=", " ", 
          RowBox[{"Length", "[", "vList", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Mod", "[", 
             RowBox[{
              RowBox[{"Exponent", "[", 
               RowBox[{"newPoly", ",", " ", 
                RowBox[{"vList", "[", 
                 RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", "2"}], "]"}], 
            " ", "\[Equal]", " ", "1"}], ",", " ", 
           RowBox[{"Return", "[", "0", "]"}]}], "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"If", " ", "the", " ", "fancy", " ", "checks", " ", 
          RowBox[{"don", "'"}], "t", " ", "engage"}], ",", " ", 
         RowBox[{"return", " ", "1", " ", "as", " ", 
          RowBox[{"default", ".", " ", "Note"}], " ", "that", " ", 
          "\"\<1\>\"", " ", 
          RowBox[{"doesn", "'"}], "t", " ", "so", " ", "much", " ", "mean", 
          " ", "\"\<true\>\"", " ", "as", " ", "\"\<maybe true\>\""}], ",", 
         " ", 
         RowBox[{
         "or", " ", "\"\<not enough information to conclude false\>\""}]}], 
        " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "1", "]"}], ";"}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.7531155416253633`*^9, 3.7531155538288183`*^9}, {
  3.753140763168976*^9, 3.753140764027912*^9}},
 Background->GrayLevel[0.85],
 CellLabel->
  "In[331]:=",ExpressionUUID->"42234e34-4281-4e5f-942b-2eea32f77a2b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
           "A", " ", "heuristic", " ", "for", " ", "quantifier", " ", 
            "elimination", " ", "on", " ", "polynomials", " ", "f", " ", "in",
             " ", "the", " ", 
            RowBox[{"fragment", " ", "\\", "forall"}], " ", "x_", "1"}], " ", 
           "..."}], " ", "\\", "forall"}], " ", "x_k", " ", "f"}], " ", ">", 
        " ", 
        RowBox[{"0", " ", 
         RowBox[{"or", "  ", "\\", "forall"}], " ", "x_", "1"}]}], " ", 
       "..."}], " ", "\\", "forall"}], " ", "x_k", " ", "f"}], " ", "<", " ", 
    
    RowBox[{
    "0.", "  ", "The", " ", "main", " ", "idea", " ", "is", " ", "to", " ", 
     "try", " ", "to", " ", "find", " ", "whether", " ", "f", " ", "has", " ",
      "zeros", " ", "as", " ", "quickly", " ", "as", " ", 
     RowBox[{"possible", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Call", " ", "with", " ", "ineq"}], " ", "=", " ", 
     RowBox[{
      RowBox[{"\"\<>\>\"", " ", "if", " ", "testing"}], " ", ">"}]}], ",", 
    " ", 
    RowBox[{"ineq", " ", "=", " ", 
     RowBox[{
      RowBox[{"\"\<<\>\"", " ", "if", " ", "testing"}], " ", "<"}]}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "A", " ", "return", " ", "value", " ", "of", " ", "0", " ", "means", " ", 
     "\"\<definitely false\>\""}], ";", " ", 
    RowBox[{
    "a", " ", "return", " ", "value", " ", "of", " ", "1", " ", "means", " ", 
     "\"\<inconclusive\>\""}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"DiscAlg", "[", 
     RowBox[{"poly_", ",", " ", "ineq_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "varList", ",", " ", "degInVar", ",", " ", "nextPoly", ",", " ", 
        "nextIneq", ",", " ", "nextCoeff"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"nextIneq", " ", "=", " ", "ineq"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"nextPoly", " ", "=", " ", 
        RowBox[{"Simplify", "[", "poly", "]"}]}], ";", "\[IndentingNewLine]", 
       
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{"1", " ", "\[Equal]", " ", "1"}], ",", " ", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"varList", " ", "=", " ", 
           RowBox[{"Variables", "[", "nextPoly", "]"}]}], ";", " ", 
          "\[IndentingNewLine]", 
          RowBox[{"nextCoeff", " ", "=", " ", 
           RowBox[{"Coefficient", "[", 
            RowBox[{"nextPoly", ",", "  ", 
             RowBox[{"varList", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", "\[IndentingNewLine]", 
             RowBox[{"Exponent", "[", 
              RowBox[{"nextPoly", ",", " ", 
               RowBox[{"varList", "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "varList", "]"}], "\[Equal]", "1"}], ",", 
            " ", 
            RowBox[{"Return", "[", 
             RowBox[{"DiscAlgHelper", "[", 
              RowBox[{"nextPoly", ",", "ineq", ",", " ", "nextCoeff"}], "]"}],
              "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"DiscAlgHelper", "[", 
              RowBox[{"nextPoly", ",", "ineq", ",", " ", "nextCoeff"}], "]"}],
              " ", "\[Equal]", " ", "0"}], ",", " ", 
            RowBox[{"Return", "[", "0", "]"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"degInVar", " ", "=", " ", 
           RowBox[{"Exponent", "[", 
            RowBox[{"nextPoly", ",", " ", 
             RowBox[{"varList", "[", 
              RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"nextPoly", " ", "=", " ", 
           RowBox[{"Simplify", "[", 
            RowBox[{"Discriminant", "[", 
             RowBox[{"nextPoly", ",", " ", 
              RowBox[{"varList", "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], "]"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"degInVar", " ", "%", " ", "4"}], " ", "\[Equal]", " ", 
             "0"}], ",", " ", 
            RowBox[{"nextIneq", " ", "=", " ", "\"\<<\>\""}], ",", " ", 
            RowBox[{"nextIneq", " ", "=", " ", "\"\<>\>\""}]}], "]"}], 
          ";"}]}], "\[IndentingNewLine]", "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->CompressedData["
1:eJwdxT1IAgEABtBTCkIdKrKiQXQQxUyDCiwHvVIqgsBosbrArAaTJLCIhkiI
/hWVCCKoQFCzBrU0aUmEGnKxIUmCrIgcDEIC26r7bng80YRtaIpNEEQTDQfV
d67ufJEcbW/wYOmjK4F7TjtvcJWy/h7bDYVnPK6m3vHIb/gTc3zujIV+N3nG
nLGmn/ChLp7HpZptYoZ+OMatxAEli4+1BT0z39GlxM2kndkfND/gPSrD3GeJ
Gaz00asvZr8ssoEJE3cTZ8UDbrwk7/Dg5bmoZJZeZktK8X629YX3XSTHcqY3
LGRZ9ev0oenbQUxJNGbMUxQn8UKbaguzjU7mxeuY0Eu/EqgWYU5trwR/CCLM
mgNfC06kdVoc8p6HsSy1eolV8+IsrrO/5vAFW1DGa3/yHxw/cRwZy0XS0l86
xo2UQrtDn6pwkvgffSzkFA==
  "],
 Background->GrayLevel[0.85],
 CellLabel->
  "In[332]:=",ExpressionUUID->"f0e9f1b9-bd8f-4c9b-803f-7f5a8a153e67"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{
   RowBox[{"Interesting", " ", "test", " ", 
    RowBox[{"case", " ", "--"}], " ", "here", " ", "it", " ", "seem", " ", 
    "to", " ", "get", " ", "lucky", " ", "because", " ", "the", " ", 
    "discriminant", " ", "wrt", " ", "y", " ", "is", " ", "quickly", " ", 
    RowBox[{"computed", ".", "  ", "\[IndentingNewLine]", "Calculating"}], 
    " ", "the", " ", "discriminant", " ", "wrt", " ", "x", " ", "seems", " ", 
    "to", " ", "take", " ", "a", " ", "long", " ", "time"}], ",", " ", 
   RowBox[{"as", " ", "does", " ", 
    RowBox[{
     RowBox[{"Reduce", "[", 
      RowBox[{"Resolve", "[", " ", "]"}], "]"}], "."}]}]}], " ", 
  "*)"}]], "Input",
 CellChangeTimes->{{3.751307085023897*^9, 3.751307088223954*^9}, {
  3.751307127093403*^9, 3.7513071794944153`*^9}, {3.751579924400949*^9, 
  3.751579928546782*^9}, {3.751581817221559*^9, 3.751581841648258*^9}},
 Background->RGBColor[
  0.94, 0.91, 0.88],ExpressionUUID->"b37b6d27-a336-4a0e-be93-bd0da57c1a8d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DiscAlg", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"12", "*", 
     RowBox[{"z", "^", "10"}]}], " ", "-", " ", 
    RowBox[{
     RowBox[{"y", "^", "6"}], " ", "*", 
     RowBox[{"x", "^", "2"}], "*", "z"}], " ", "+", 
    RowBox[{"5", 
     RowBox[{"y", "^", "2"}]}], " ", "+", "1000", " ", "+", 
    RowBox[{
     RowBox[{"x", "^", "150"}], "*", 
     RowBox[{"y", "^", "5"}]}]}], ",", " ", "\"\<>\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.751579936800269*^9, 3.7515799500334997`*^9}, {
  3.751581531216515*^9, 3.751581551440654*^9}, {3.751581604423677*^9, 
  3.751581606741346*^9}, {3.7531407856660852`*^9, 3.753140786262393*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[345]:=",ExpressionUUID->"dfe71456-fe1a-4542-b985-677931b99d54"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.7515799409764223`*^9, 3.751579968603812*^9}, 
   3.7515802887140408`*^9, {3.75158042186405*^9, 3.751580459320792*^9}, 
   3.7515805008890953`*^9, {3.751581070068964*^9, 3.751581083643236*^9}, 
   3.751581119211516*^9, {3.751581365298745*^9, 3.7515813935255833`*^9}, {
   3.751581531976552*^9, 3.751581571745881*^9}, {3.7515816023964977`*^9, 
   3.751581627372139*^9}, 3.751581989793509*^9, 3.7530370923973827`*^9, {
   3.7531407812809753`*^9, 3.753140789393619*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[345]=",ExpressionUUID->"9496bc22-3621-4a46-b4df-ee4f914b2d39"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Discriminant", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"12", "*", 
     RowBox[{"z", "^", "10"}]}], " ", "-", " ", 
    RowBox[{
     RowBox[{"y", "^", "6"}], " ", "*", 
     RowBox[{"x", "^", "2"}], "*", "z"}], " ", "+", 
    RowBox[{"5", 
     RowBox[{"y", "^", "2"}]}], " ", "+", "1000", " ", "+", 
    RowBox[{
     RowBox[{"x", "^", "150"}], "*", 
     RowBox[{"y", "^", "5"}]}]}], ",", " ", "x"}], "]"}]], "Input",
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->"In[91]:=",ExpressionUUID->"7f7789dd-e6f8-40d6-b043-cf31549c0cfc"],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.7515817852683687`*^9, 3.751581996067898*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->"Out[91]=",ExpressionUUID->"74748014-22e1-45e8-b48b-71099b03ccfd"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Timing", "[", 
  RowBox[{"Reduce", "[", 
   RowBox[{"Resolve", "[", 
    RowBox[{"ForAll", "[", 
     RowBox[{"y", ",", " ", 
      RowBox[{"ForAll", "[", 
       RowBox[{"z", ",", " ", 
        RowBox[{"ForAll", "[", 
         RowBox[{"x", ",", 
          RowBox[{
           RowBox[{
            RowBox[{"12", "*", 
             RowBox[{"z", "^", "10"}]}], " ", "-", " ", 
            RowBox[{
             RowBox[{"y", "^", "6"}], " ", "*", 
             RowBox[{"x", "^", "2"}], "*", "z"}], " ", "+", 
            RowBox[{"5", 
             RowBox[{"y", "^", "2"}]}], " ", "+", "1000", " ", "+", " ", 
            RowBox[{
             RowBox[{"x", "^", "150"}], "*", 
             RowBox[{"y", "^", "5"}]}]}], " ", ">", "0"}]}], "]"}]}], "]"}]}],
      "]"}], "]"}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.751581324461596*^9, 3.751581343190906*^9}, {
  3.7515817742059298`*^9, 3.751581775320342*^9}},
 Background->RGBColor[
  1, 0.9, 1],ExpressionUUID->"c03d8c25-be73-4169-aa1b-b92d876ba8b6"],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.751307316188909*^9, 3.7515813193363867`*^9, 
  3.75158135971201*^9, 3.751581488893157*^9, 3.751581595599798*^9},
 Background->RGBColor[1, 0.9, 1],
 CellLabel->"Out[72]=",ExpressionUUID->"784b97f3-40cd-40c7-b8d5-6ad8cdc1b799"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Polynomial Algorithms", "Section",
 CellChangeTimes->{{3.753115514012466*^9, 
  3.7531155289876957`*^9}},ExpressionUUID->"91303c72-3ec8-4974-83ad-\
4128180fff4e"],

Cell[CellGroupData[{

Cell["\<\
Now we implement the algorithms that correspond to the polynomial properties \
in the paper.  These are algorithms for quantifier elimination on polynomials \
f in the fragment \\forall x_1 ... \\forall x_k (f_1 ~ 0 | f_2 ~ 0 | ... | \
f_k ~ 0), where  ~ is either > or >=.  We especially care about the strict \
fragment (where all ~ are > ).\
\>", "Subsection",
 CellChangeTimes->{{3.753140662648046*^9, 3.753140695931293*^9}, {
  3.753145485865943*^9, 
  3.753145518372622*^9}},ExpressionUUID->"e18eb558-c750-457e-9749-\
bb85041d23ed"],

Cell[CellGroupData[{

Cell["Theorem 1", "Subsubsection",
 CellChangeTimes->{{3.7531414918164454`*^9, 
  3.753141494874878*^9}},ExpressionUUID->"4a0d087b-cc5b-41f5-aab7-\
55107a8c9666"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Helper", " ", "Method"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"LeadingCoefficient", "[", 
     RowBox[{"poly_", ",", " ", "var_"}], "]"}], " ", ":=", 
    "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"Return", " ", "[", 
       RowBox[{"Coefficient", "[", 
        RowBox[{"poly", ",", " ", "var", ",", " ", 
         RowBox[{"Exponent", "[", 
          RowBox[{"poly", ",", " ", "var"}], "]"}]}], "]"}], "]"}]}], "]"}]}],
    ";"}]}]], "Input",
 CellChangeTimes->{{3.75314913770245*^9, 3.7531491709754553`*^9}},
 Background->GrayLevel[0.85],
 CellLabel->
  "In[250]:=",ExpressionUUID->"17029327-a032-43c5-ad2d-6f424510f684"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Test", " ", "Cases"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"LeadingCoefficient", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"2", "*", "y", "*", "z", "*", 
       RowBox[{"x", "^", "2"}]}], " ", "+", " ", "y", "+", " ", "5"}], ",", 
     " ", "x"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"LeadingCoefficient", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"2", "*", "y", "*", "z", "*", 
       RowBox[{"x", "^", "2"}]}], " ", "+", " ", 
      RowBox[{"x", "^", "7"}], "+", " ", "y", "+", " ", "5"}], ",", " ", 
     "x"}], "]"}], "\[IndentingNewLine]", 
   RowBox[{"LeadingCoefficient", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"2", "*", "y", "*", "z", "*", 
       RowBox[{"x", "^", "2"}]}], " ", "+", " ", 
      RowBox[{"x", "^", "2"}], " ", "+", " ", "y", "+", " ", "5"}], ",", " ", 
     "x"}], "]"}]}]}]], "Input",
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[251]:=",ExpressionUUID->"ec290281-6991-47a2-bef4-d1ae1abaaab1"],

Cell[BoxData[
 RowBox[{"2", " ", "y", " ", "z"}]], "Output",
 CellChangeTimes->{3.7531491726618567`*^9, 3.753149245725738*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[251]=",ExpressionUUID->"663bee42-97ef-4373-abe4-0ea16d1ad498"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.7531491726618567`*^9, 3.753149245753015*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[252]=",ExpressionUUID->"b9e8ca0b-c4d7-49c7-8fca-e4089d42b0cd"],

Cell[BoxData[
 RowBox[{"1", "+", 
  RowBox[{"2", " ", "y", " ", "z"}]}]], "Output",
 CellChangeTimes->{3.7531491726618567`*^9, 3.753149245768862*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[253]=",ExpressionUUID->"ecbb4092-fb97-44d1-b1ec-66beca3a31ba"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Helper", " ", "method"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"AllVariables", "[", "polyList_", "]"}], " ", ":=", " ", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"varList", ",", " ", "i"}], "}"}], ",", "\[IndentingNewLine]", 
      
      RowBox[{
       RowBox[{"varList", " ", "=", " ", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", 
          RowBox[{"Length", "[", "polyList", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"varList", " ", "=", " ", 
           RowBox[{"Union", "[", 
            RowBox[{"varList", ",", " ", 
             RowBox[{"Variables", "[", 
              RowBox[{"polyList", "[", 
               RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "]"}]}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", " ", 
       RowBox[{"Return", "[", "varList", "]"}]}]}], "]"}]}], ";"}]}]], "Input",\

 Background->GrayLevel[0.85],
 CellLabel->
  "In[271]:=",ExpressionUUID->"e5d6f4e0-102f-43b7-8d6b-3c6fadef507e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AllVariables", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "^", "2"}], " ", "+", " ", "y"}], ",", " ", "z", ",", " ", 
    RowBox[{
     RowBox[{"w", "*", "q"}], " ", "+", " ", "5"}], ",", " ", 
    RowBox[{"w", "*", "x", "*", "y"}]}], "}"}], "]"}]], "Input",
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[272]:=",ExpressionUUID->"f348e3bc-b0f3-411d-81b1-24bf47c0072b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"q", ",", "w", ",", "x", ",", "y", ",", "z"}], "}"}]], "Output",
 CellChangeTimes->{3.7531498642875566`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[272]=",ExpressionUUID->"7a52755b-88ab-4207-bed2-a165c0b37ff7"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Helper", " ", "method"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"EvalListCheckSigns", "[", 
     RowBox[{"polyList_", ",", " ", "eValList_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "eVal", ",", " ", "allVars", ",", " ", "allNeg", ",", " ", "allSame", 
        ",", " ", "signPoly"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"allVars", " ", "=", " ", 
        RowBox[{"AllVariables", "[", "polyList", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"allSame", "=", " ", "1"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Check", " ", "the", " ", "sign", " ", "of", " ", "the", " ", "first",
          " ", "polynomial", " ", "at", " ", "eValList"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"eVal", " ", "=", " ", 
        RowBox[{
         RowBox[{"polyList", "[", 
          RowBox[{"[", "1", "]"}], "]"}], " ", "/.", "eValList"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", " ", 
        RowBox[{
         RowBox[{"eVal", "<", " ", "0"}], ",", " ", 
         RowBox[{"signPoly", " ", "=", " ", 
          RowBox[{"-", "1"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", " ", 
        RowBox[{
         RowBox[{"eVal", ">", " ", "0"}], ",", " ", 
         RowBox[{"signPoly", " ", "=", " ", "1"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", " ", 
        RowBox[{
         RowBox[{"eVal", "==", "0"}], ",", " ", 
         RowBox[{
          RowBox[{"allSame", " ", "=", " ", "0"}], ";"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Check", " ", "if", " ", "all", " ", "the", " ", "polynomials", " ", 
         "have", " ", "the", " ", "same", " ", "sign"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", 
          RowBox[{"Length", "[", "polyList", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", " ", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"eVal", " ", "=", " ", 
           RowBox[{
            RowBox[{"polyList", "[", 
             RowBox[{"[", "i", "]"}], "]"}], " ", "/.", "eValList"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"eVal", " ", ">=", " ", "0"}], " ", "&&", " ", 
             RowBox[{"signPoly", " ", "\[Equal]", " ", 
              RowBox[{"-", "1"}]}]}], " ", ",", " ", 
            RowBox[{"allSame", " ", "=", " ", "0"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"eVal", " ", "<=", " ", "0"}], " ", "&&", " ", 
             RowBox[{"signPoly", " ", "\[Equal]", "1"}]}], ",", " ", 
            RowBox[{"allSame", " ", "=", " ", "0"}]}], "]"}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"allSame", " ", "\[Equal]", " ", "1"}], ",", " ", 
         RowBox[{"Return", "[", "1", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "0", "]"}], ";"}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.7531481706376123`*^9, 3.753148187485964*^9}, {
  3.753148752491395*^9, 3.7531487546094217`*^9}, {3.753148871235248*^9, 
  3.753149104146822*^9}, {3.7531492821748133`*^9, 3.753149290159218*^9}, {
  3.7531493475042353`*^9, 3.7531493618571777`*^9}, {3.7531495009246883`*^9, 
  3.753149504499716*^9}, {3.7531506508441477`*^9, 3.7531506822178307`*^9}, {
  3.753150807573078*^9, 3.753150808375134*^9}, {3.753162089173251*^9, 
  3.7531621283368196`*^9}},
 Background->GrayLevel[
  0.85],ExpressionUUID->"8b91fa4a-2c2b-462b-be5d-c60a3980157d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Test", " ", "Cases"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"EvalListCheckSigns", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", "^", "2"}], ",", " ", 
      RowBox[{"y", "^", "3"}], ",", 
      RowBox[{"z", "^", "5"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", "->", "1"}], ",", " ", 
      RowBox[{"y", "->", "2"}], ",", " ", 
      RowBox[{"z", "->", "3"}]}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.753149451122367*^9, 3.753149470926491*^9}, {
  3.753149530496563*^9, 3.753149530631239*^9}, {3.753150018803267*^9, 
  3.753150022196372*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[286]:=",ExpressionUUID->"0a11d514-4a1c-4f44-a4a8-0d72c952592a"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.753149461360284*^9, 3.753149471264194*^9}, {
   3.7531495062773314`*^9, 3.753149530942347*^9}, 3.7531506858961782`*^9, 
   3.753150794211624*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[286]=",ExpressionUUID->"79c6b550-fa5e-40a8-b66d-415e32da3c7a"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EvalListCheckSigns", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "^", "2"}], ",", " ", 
     RowBox[{"y", "^", "3"}], ",", 
     RowBox[{"z", "^", "5"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "\[Rule]", 
      RowBox[{"-", "1"}]}], ",", " ", 
     RowBox[{"y", "->", "2"}], ",", " ", 
     RowBox[{"z", "->", "3"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7531494800239553`*^9, 3.753149481116514*^9}, {
  3.753149528278002*^9, 3.753149528886636*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[266]:=",ExpressionUUID->"9f68365c-7ef4-44a6-ade1-62c99acc3e2c"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.753149481615067*^9, 3.753149529270855*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[266]=",ExpressionUUID->"e292524b-8f62-471e-a7a2-e153f53b5c9e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EvalListCheckSigns", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "^", "2"}], ",", " ", 
     RowBox[{
      RowBox[{"y", "^", "3"}], "*", "x"}], ",", 
     RowBox[{"z", "^", "5"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "->", "1"}], ",", " ", 
     RowBox[{"y", "\[Rule]", 
      RowBox[{"-", "2"}]}], ",", " ", 
     RowBox[{"z", "->", "3"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753149485139957*^9, 3.7531494873157673`*^9}, {
  3.75314953198693*^9, 3.753149532161388*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[287]:=",ExpressionUUID->"6a5629e4-6048-423a-be95-632c4b6334f1"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.753149487866069*^9, 3.7531495325306797`*^9}, 
   3.753150796666175*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[287]=",ExpressionUUID->"4a1161aa-a8f3-47b1-a664-9b858831904e"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Return", " ", "value", " ", "of", " ", "0", " ", "means", " ", 
     "\"\<definitely false\>\""}], ",", " ", 
    RowBox[{"return", " ", "value", " ", "of", " ", "1", " ", "means", " ", 
     RowBox[{"inconclusive", ".", "  ", "Corresponds"}], " ", "to", " ", 
     "Theorem", " ", "1", " ", "in", " ", "the", " ", 
     RowBox[{"paper", ".", "\[IndentingNewLine]", "Right"}], " ", "now", " ", 
     "this", " ", "is", " ", "somewhat", " ", "heuristic", " ", "because"}], 
    ",", " ", 
    RowBox[{
    "if", " ", "some", " ", "variable", " ", "has", " ", "odd", " ", 
     "degree"}], ",", " ", 
    RowBox[{
    "it", " ", "only", " ", "tests", " ", "whether", " ", "the", " ", 
     "leading", " ", "coefficients", " ", "have", " ", "consistent", " ", 
     "signs", " ", "at", " ", 
     RowBox[{"(", 
      RowBox[{"1", ",", " ", "...", ",", " ", "1"}], ")"}]}], ",", " ", 
    RowBox[{"so", " ", "there", " ", "is", " ", "room", " ", "for", " ", 
     RowBox[{"improvement", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"OddDegree", "[", 
     RowBox[{"polyList_", ",", " ", "ineqList_"}], "]"}], " ", ":=", " ", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "varList", ",", " ", "i", ",", " ", "hasOddDegree", ",", " ", "j", ",",
         " ", "eValList", ",", " ", "newPolyList", ",", " ", "allSigns"}], 
       "}"}], ",", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"varList", " ", "=", " ", 
        RowBox[{"AllVariables", "[", "polyList", "]"}]}], ";", 
       "\[IndentingNewLine]", "hasOddDegree", ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", 
          RowBox[{"Length", "[", "varList", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", " ", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
          "Check", " ", "if", " ", "the", " ", "ith", " ", "variable", " ", 
           "has", " ", "odd", " ", "degree", " ", "in", " ", "every", " ", 
           "polynomial"}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"hasOddDegree", " ", "=", " ", "1"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"j", " ", "=", " ", "1"}], ",", " ", 
            RowBox[{"j", "\[LessEqual]", " ", 
             RowBox[{"Length", "[", "polyList", "]"}]}], ",", " ", 
            RowBox[{"j", "++"}], ",", " ", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Mod", "[", 
                 RowBox[{
                  RowBox[{"Exponent", "[", 
                   RowBox[{
                    RowBox[{"polyList", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], ",", " ", 
                    RowBox[{"varList", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}], ",", " ", "2"}], 
                 "]"}], " ", "\[Equal]", " ", "0"}], ",", " ", 
               RowBox[{"hasOddDegree", " ", "=", " ", "0"}]}], "]"}], ";"}]}],
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{"If", " ", "so"}], ",", " ", 
            RowBox[{
            "make", " ", "a", " ", "list", " ", "of", " ", "the", " ", 
             "leading", " ", "coefficients", " ", "of", " ", "the", " ", 
             "polynomial"}]}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"hasOddDegree", " ", "\[Equal]", " ", "1"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"newPolyList", " ", "=", " ", 
              RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"For", "[", 
              RowBox[{
               RowBox[{"j", " ", "=", " ", "1"}], ",", " ", 
               RowBox[{"j", "\[LessEqual]", " ", 
                RowBox[{"Length", "[", "polyList", "]"}]}], ",", " ", 
               RowBox[{"j", "++"}], ",", " ", 
               RowBox[{
                RowBox[{"newPolyList", " ", "=", " ", 
                 RowBox[{"Append", "[", 
                  RowBox[{"newPolyList", ",", " ", 
                   RowBox[{"LeadingCoefficient", "[", 
                    RowBox[{
                    RowBox[{"polyList", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], ",", 
                    RowBox[{"varList", "[", 
                    RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], "]"}]}], 
                ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"eValList", " ", "=", " ", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"#", "\[Rule]", "1"}], ")"}], " ", "&"}], " ", "/@", 
               " ", "varList"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"EvalListCheckSigns", "[", 
                 RowBox[{"newPolyList", ",", " ", "eValList"}], "]"}], 
                "\[Equal]", "1"}], ",", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"allSigns", " ", "=", " ", 
                 RowBox[{
                  RowBox[{"newPolyList", "[", 
                   RowBox[{"[", "1", "]"}], "]"}], " ", "/.", "eValList"}]}], 
                ";", "\[IndentingNewLine]", 
                RowBox[{"If", "[", 
                 RowBox[{
                  RowBox[{"allSigns", ">", " ", "0"}], ",", " ", 
                  RowBox[{
                   RowBox[{"Print", "[", 
                    RowBox[{"\"\<Witness: \>\"", ",", " ", 
                    RowBox[{"varList", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", " ", 
                    "\"\< is -infty, all other variables are 1\>\""}], "]"}], 
                   ";"}], ",", 
                  RowBox[{
                   RowBox[{"Print", "[", 
                    RowBox[{"\"\<Witness: \>\"", ",", " ", 
                    RowBox[{"varList", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", " ", 
                    "\"\< is infty, all other variables are 1\>\""}], "]"}], 
                   ";"}]}], " ", "]"}], ";", " ", 
                RowBox[{"Return", "[", "0", "]"}]}]}], "]"}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "1", "]"}]}]}], "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.7531481894974003`*^9, 3.753148225167651*^9}, {
  3.7531493656865883`*^9, 3.753149366024057*^9}, {3.7531495526161222`*^9, 
  3.7531495573362617`*^9}, {3.753149822417012*^9, 3.753149836565165*^9}, {
  3.7531500005624723`*^9, 3.7531500162051764`*^9}, {3.753150094963258*^9, 
  3.753150191034841*^9}, {3.753150332105153*^9, 3.753150460934236*^9}, {
  3.753150496667886*^9, 3.753150524809355*^9}, {3.753150554918952*^9, 
  3.753150584967803*^9}, {3.7531508130215397`*^9, 3.753150845472671*^9}, {
  3.7531511791992273`*^9, 3.753151227392064*^9}, {3.753162145595861*^9, 
  3.753162313521435*^9}, {3.7531623728006687`*^9, 3.753162484814227*^9}, {
  3.753162665838613*^9, 3.7531626884989758`*^9}, {3.753162749801693*^9, 
  3.753162750203589*^9}, {3.753163774968379*^9, 3.7531637812030983`*^9}},
 Background->GrayLevel[0.85],
 CellLabel->
  "In[2527]:=",ExpressionUUID->"e483c76d-4ef6-4c23-a0c3-86d4c5ada03e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Test", " ", "Cases"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"OddDegree", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"x", "^", "3"}], "*", "5", 
       RowBox[{"z", "^", "8"}]}], ",", " ", 
      RowBox[{"x", " ", "+", " ", 
       RowBox[{"y", "^", "6"}]}]}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"\"\<>\>\"", ",", " ", "\"\<>\>\""}], "}"}]}], " ", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.753150601372819*^9, 3.753150626227139*^9}, {
  3.753150893405931*^9, 3.7531508969119062`*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[2528]:=",ExpressionUUID->"5f2ed719-ac0d-4d5b-8e19-564399c8d621"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\" is -infty, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`x, " is -infty, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.7531623829681883`*^9, 3.753162415944515*^9}, {
   3.753162464108067*^9, 3.7531624867537727`*^9}, 3.7531627609184237`*^9, 
   3.753163783597755*^9},
 CellLabel->
  "During evaluation of \
In[2528]:=",ExpressionUUID->"e7dc5b04-0014-4f3b-891c-ba9fbebe8aab"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.753150627850397*^9, 3.753150848562581*^9, {3.7531511847763243`*^9, 
   3.753151230415061*^9}, {3.7531622876690693`*^9, 3.753162317053605*^9}, {
   3.753162383254527*^9, 3.753162416015026*^9}, {3.753162464132327*^9, 
   3.753162486779167*^9}, 3.753162760939137*^9, 3.753163783614987*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[2528]=",ExpressionUUID->"bb6e0fcd-578c-4098-80ec-bb26b4da06b8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OddDegree", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "^", "3"}], "*", "5", 
      RowBox[{"z", "^", "8"}]}], ",", " ", 
     RowBox[{"x", " ", "-", " ", 
      RowBox[{"y", "^", "6"}]}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>\>\"", ",", " ", "\"\<>\>\""}], "}"}]}], " ", 
  "]"}]], "Input",
 CellChangeTimes->{{3.753150640131077*^9, 3.753150640352994*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3259]:=",ExpressionUUID->"c2fba67a-7bdf-4ba2-8f2b-a3ae081140ec"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\" is -infty, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`x, " is -infty, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.753162481983171*^9, 3.7531624880481243`*^9}, 
   3.7531627623489027`*^9, 3.75316378558847*^9, 3.753165481160331*^9},
 CellLabel->
  "During evaluation of \
In[3259]:=",ExpressionUUID->"e2a50457-0d38-41cb-aba6-c64baaaa1bc2"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.753150642135872*^9, 3.753150850022649*^9, 3.7531511860750017`*^9, {
   3.753151220077667*^9, 3.753151231544767*^9}, {3.7531624820002413`*^9, 
   3.753162488071972*^9}, 3.7531627623700953`*^9, 3.753163785604836*^9, 
   3.7531654811794977`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3259]=",ExpressionUUID->"3aa0a350-b3bb-48dd-8328-32e9c9167f8d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OddDegree", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"w", "^", "3"}], "*", "5", 
      RowBox[{"z", "^", "8"}]}], ",", " ", 
     RowBox[{"w", " ", "-", " ", 
      RowBox[{"y", "^", "6"}]}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>\>\"", ",", " ", "\"\<>\>\""}], "}"}]}], " ", 
  "]"}]], "Input",
 CellChangeTimes->{{3.753162573507422*^9, 3.753162575221016*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3260]:=",ExpressionUUID->"2d610d19-1613-45eb-922a-4a12fb8fc04e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "w", 
   "\[InvisibleSpace]", "\<\" is -infty, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`w, " is -infty, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753162492568707*^9, 3.753162575606847*^9, 
  3.753162764481668*^9, 3.753163786789035*^9, 3.7531654825234127`*^9},
 CellLabel->
  "During evaluation of \
In[3260]:=",ExpressionUUID->"6bf39099-ff89-4ce4-bd66-28d5dede9751"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7531508006645517`*^9, 3.753150851956519*^9, 
  3.753151241825667*^9, 3.753162492583104*^9, 3.753162575638611*^9, 
  3.753162764502511*^9, 3.753163786804161*^9, 3.753165482552268*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3260]=",ExpressionUUID->"da0771ef-72e9-4df8-b422-f29582882b8c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OddDegree", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"w", "^", "3"}]}], "+", 
      RowBox[{"5", 
       RowBox[{"z", "^", "8"}]}]}], ",", " ", 
     RowBox[{"w", " ", "-", " ", 
      RowBox[{"y", "^", "6"}]}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>\>\"", ",", " ", "\"\<>\>\""}], "}"}]}], " ", 
  "]"}]], "Input",
 CellChangeTimes->{{3.7531638190093803`*^9, 3.753163826385292*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[2533]:=",ExpressionUUID->"d09c631f-1bef-4630-adba-8b0c250aced1"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.753163827738947*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[2533]=",ExpressionUUID->"2c2e3eda-3c3e-4506-aff5-955226487378"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OddDegree", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"w", "^", "3"}]}], "+", 
      RowBox[{"5", 
       RowBox[{"z", "^", "8"}]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "6"}], "*", "w"}], " ", "-", " ", 
      RowBox[{"y", "^", "6"}]}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>\>\"", ",", " ", "\"\<>\>\""}], "}"}]}], " ", 
  "]"}]], "Input",
 CellChangeTimes->{{3.753163832184195*^9, 3.753163835241136*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[2536]:=",ExpressionUUID->"654cf777-94b7-43b4-9b5e-3a2143245a62"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "w", 
   "\[InvisibleSpace]", "\<\" is infty, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`w, " is infty, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.753163836147168*^9, 3.75316385622933*^9}},
 CellLabel->
  "During evaluation of \
In[2536]:=",ExpressionUUID->"2dcfff8c-0d3c-4627-8de1-011c8cfc9290"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.753163836159545*^9, 3.753163856247827*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[2536]=",ExpressionUUID->"74dd6a84-9d25-4715-bac3-85128e73246e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OddDegree", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "^", "3"}], "*", "5", 
      RowBox[{"z", "^", "8"}]}], ",", " ", 
     RowBox[{
      RowBox[{"x", "^", "2"}], " ", "-", " ", 
      RowBox[{"y", "^", "6"}]}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>\>\"", " ", ",", " ", "\"\<>\>\""}], "}"}]}], " ", 
  "]"}]], "Input",
 CellChangeTimes->{{3.753150859740992*^9, 3.753150859912369*^9}, {
  3.753162632534273*^9, 3.7531626377220783`*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[2531]:=",ExpressionUUID->"472001e1-360d-4238-ab6b-d30c8c031ef5"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.753150860342802*^9, 3.753151254527787*^9, 3.753162494639297*^9, 
   3.753162579857192*^9, {3.753162633441966*^9, 3.753162638455153*^9}, 
   3.7531627665518093`*^9, 3.75316378912372*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[2531]=",ExpressionUUID->"ec6bf211-f42a-404a-90f4-50587ca8a078"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OddDegree", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"w", "^", "3"}], "*", "5", 
      RowBox[{"z", "^", "8"}]}], ",", " ", 
     RowBox[{
      RowBox[{"w", "^", "2"}], " ", "-", " ", 
      RowBox[{"y", "^", "6"}], " ", "+", " ", 
      RowBox[{"w", "^", 
       RowBox[{"(", "150", ")"}]}], " ", "-", " ", 
      RowBox[{"z", "^", 
       RowBox[{"(", "200", ")"}]}]}], ",", " ", 
     RowBox[{"w", " ", "+", " ", 
      RowBox[{"y", "^", "8"}], "+", "5"}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>\>\"", ",", " ", "\"\<>=\>\"", ",", " ", "\"\<>\>\""}], 
    "}"}]}], " ", "]"}]], "Input",
 CellChangeTimes->{{3.753150866608198*^9, 3.753150889655781*^9}, {
  3.75316250272114*^9, 3.753162509483364*^9}, {3.7531625435867567`*^9, 
  3.753162544244732*^9}, {3.753162626865712*^9, 3.753162630219269*^9}, {
  3.753162703336959*^9, 3.7531627085622168`*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3261]:=",ExpressionUUID->"052a07e9-ad70-4a44-9262-60556ba67560"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.753150875874158*^9, 3.753150890173491*^9}, 
   3.753151257301332*^9, {3.753162496591814*^9, 3.753162511493018*^9}, {
   3.753162544733301*^9, 3.75316254990591*^9}, 3.753162582008605*^9, {
   3.753162630875537*^9, 3.753162640657158*^9}, {3.7531626936443853`*^9, 
   3.7531627091999893`*^9}, {3.753162754738287*^9, 3.7531627685579433`*^9}, 
   3.753163790193515*^9, 3.753165485957177*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3261]=",ExpressionUUID->"cd09b692-9d42-403d-b6c3-090861dc94cc"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Because", " ", "we", " ", "are", " ", "only", " ", "testing", " ", "the",
      " ", "signs", " ", "of", " ", "the", " ", "leading", " ", 
     "coefficients", " ", "at", " ", 
     RowBox[{"(", 
      RowBox[{"1", ",", " ", "...", ",", " ", "1"}], ")"}]}], ",", " ", 
    RowBox[{
    "this", " ", "should", " ", "return", " ", "1", " ", "even", " ", 
     "though", " ", "it", " ", "\"\<could\>\"", " ", "return", " ", 
     "false"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"OddDegree", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"x", "^", "3"}], "*", "5", 
       RowBox[{"z", "^", "8"}]}], ",", " ", 
      RowBox[{
       RowBox[{"x", "^", "2"}], " ", "-", " ", 
       RowBox[{"y", "^", "6"}], " ", "+", " ", 
       RowBox[{"x", "^", 
        RowBox[{"{", "150", "}"}]}], " ", "-", " ", 
       RowBox[{"z", "^", 
        RowBox[{"{", "200", "}"}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "y"}], "*", "x"}], " ", "+", " ", 
       RowBox[{"y", "^", "8"}], "+", "5"}]}], "}"}], ",", " ", 
    RowBox[{"{", 
     RowBox[{"\"\<>\>\"", ",", " ", "\"\<>\>\""}], "}"}]}], " ", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.75315104511067*^9, 3.753151089407639*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[2462]:=",ExpressionUUID->"7d4b7f62-15e5-493a-a0ff-bd645a1c72fe"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.753151091486971*^9, 3.753151146104529*^9, 
  3.753151260213662*^9, 3.753162770677668*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[2462]=",ExpressionUUID->"2ba30283-dfaa-4c91-bc02-0af6ba3e0551"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Theorem 2", "Subsubsection",
 CellChangeTimes->{{3.753141484045833*^9, 
  3.75314148710275*^9}},ExpressionUUID->"860ecf3f-126c-4242-b0a0-\
a43539d30056"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Helper", " ", "function", " ", "for", " ", "OneVarZero"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"SetOneVarZero", "[", 
     RowBox[{"polyList_", ",", " ", "var_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"eVal", ",", " ", "newPolyList"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"newPolyList", " ", "=", " ", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", 
          RowBox[{"Length", "[", "polyList", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", " ", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"eVal", " ", "=", " ", 
           RowBox[{
            RowBox[{"polyList", "[", 
             RowBox[{"[", "i", "]"}], "]"}], " ", "/.", " ", 
            RowBox[{"{", 
             RowBox[{"var", " ", "\[Rule]", " ", "0"}], "}"}]}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"newPolyList", " ", "=", " ", 
           RowBox[{"Append", "[", 
            RowBox[{"newPolyList", ",", 
             RowBox[{"Simplify", "[", "eVal", "]"}]}], "]"}]}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "newPolyList", "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.7531455620412407`*^9, 3.753145588280423*^9}, {
  3.753145731445252*^9, 3.7531458867228193`*^9}, {3.753145958686243*^9, 
  3.753145982727271*^9}, {3.753146033359152*^9, 3.753146058988056*^9}, {
  3.753146679016868*^9, 3.753146682902471*^9}},
 Background->GrayLevel[0.85],
 CellLabel->
  "In[176]:=",ExpressionUUID->"93b204ca-4e4c-4a2e-ba0b-2ac46e1c29bc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Test", " ", "Cases"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"SetOneVarZero", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"x", "^", "2"}], " ", "+", " ", 
       RowBox[{"5", "x"}], " ", "+", " ", "y", " ", "+", " ", "z"}], ",", " ", 
      RowBox[{"x", "^", "5"}]}], "}"}], ",", " ", "x"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.75314601929368*^9, 3.753146024495965*^9}, {
  3.753146128462928*^9, 3.753146132875622*^9}, {3.753147429059391*^9, 
  3.7531474310903177`*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3262]:=",ExpressionUUID->"762982a6-4495-44df-a9b7-2241abbd5e97"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"y", "+", "z"}], ",", "0"}], "}"}]], "Output",
 CellChangeTimes->{
  3.75314579868321*^9, {3.753145948421637*^9, 3.7531459845727587`*^9}, {
   3.753146021837557*^9, 3.753146024864451*^9}, 3.7531460959480143`*^9, 
   3.753146127135584*^9, 3.753147431500716*^9, 3.753165488446699*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3262]=",ExpressionUUID->"daa01937-22dd-45f6-8713-9a41f7286038"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"EvalList", " ", "--"}], " ", "returns", " ", "true", " ", "if",
       " ", "it", " ", "finds", " ", "a", " ", "value", " ", "for", " ", 
      "which", " ", "all", " ", "polynomials", " ", "are"}], " ", 
     "\[LessEqual]", " ", "0"}], ",", " ", 
    RowBox[{"false", " ", 
     RowBox[{"otherwise", ".", "  ", "This"}], " ", "is", " ", "somewhat", 
     " ", "heuristic", " ", "currently"}], ",", " ", 
    RowBox[{
    "because", " ", "it", " ", "just", " ", "tests", " ", "setting", " ", 
     "all", " ", "variables", " ", "to", " ", "1"}], ",", " ", 
    RowBox[{"so", " ", "there", " ", "is", " ", "room", " ", "for", " ", 
     RowBox[{"improvement", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"EvaluateList", "[", 
     RowBox[{"polyList_", ",", " ", "ineqList_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "eVal", ",", " ", "allVars", ",", " ", "allNeg", ",", " ", 
        "eValList"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"allVars", " ", "=", " ", 
        RowBox[{"AllVariables", "[", "polyList", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"allNeg", " ", "=", " ", "1"}], ";", "\[IndentingNewLine]", 
       RowBox[{"eValList", " ", "=", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"#", "\[Rule]", "1"}], ")"}], " ", "&"}], " ", "/@", " ", 
         "allVars"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", 
          RowBox[{"Length", "[", "polyList", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", " ", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"eVal", " ", "=", " ", 
           RowBox[{
            RowBox[{"polyList", "[", 
             RowBox[{"[", "i", "]"}], "]"}], " ", "/.", "eValList"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"eVal", " ", ">", " ", "0"}], " ", "&&", " ", 
             RowBox[{
              RowBox[{"ineqList", "[", 
               RowBox[{"[", "i", "]"}], "]"}], " ", "\[Equal]", " ", 
              "\"\<>\>\""}]}], " ", ",", " ", 
            RowBox[{"allNeg", " ", "=", " ", "0"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"eVal", " ", ">=", " ", "0"}], " ", "&&", " ", 
             RowBox[{
              RowBox[{"ineqList", "[", 
               RowBox[{"[", "i", "]"}], "]"}], " ", "\[Equal]", " ", 
              "\"\<>=\>\""}]}], " ", ",", " ", 
            RowBox[{"allNeg", " ", "=", " ", "0"}]}], "]"}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"allNeg", " ", "\[Equal]", " ", "1"}], ",", " ", 
         RowBox[{"Return", "[", "1", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "0", "]"}], ";"}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.753146597396254*^9, 3.753146609360258*^9}, {
   3.753146641077227*^9, 3.7531466419632607`*^9}, 3.753146686805231*^9, 
   3.753146736096097*^9, {3.753146773384111*^9, 3.7531467975127897`*^9}, {
   3.753146828554881*^9, 3.753146951298685*^9}, {3.753146981872827*^9, 
   3.75314702721436*^9}, 3.753147209457822*^9, {3.753147459328374*^9, 
   3.753147463509248*^9}, {3.753147582059519*^9, 3.753147619300004*^9}, {
   3.753147700102619*^9, 3.753147700178399*^9}, {3.753147859433515*^9, 
   3.753147891845842*^9}, {3.753162845008195*^9, 3.753162878061397*^9}},
 Background->GrayLevel[0.85],
 CellLabel->
  "In[2464]:=",ExpressionUUID->"8a4990e6-7b16-4404-839b-cd0eef7fe16b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EvaluateList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "^", "3"}], " ", "-", " ", "5"}], "}"}], ",", " ", 
   RowBox[{"{", "\"\<>\>\"", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753146997593843*^9, 3.753147038779087*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3263]:=",ExpressionUUID->"71b91590-dc4b-4b7f-90cd-0b560168978e"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.753147525951779*^9, 3.753147583997678*^9, 
  3.753162880728737*^9, 3.7531654907350473`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3263]=",ExpressionUUID->"d550fea5-dc95-445f-88d7-002d6e8d3ada"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EvaluateList", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"-", " ", "5"}], "}"}], ",", " ", 
   RowBox[{"{", "\"\<>=\>\"", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753147501888891*^9, 3.753147527732583*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3264]:=",ExpressionUUID->"cd262e54-f586-415d-85b7-84867466dbe8"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.753147506319085*^9, 3.753147528816949*^9}, 
   3.753147585184166*^9, 3.753162881875482*^9, 3.75316549200803*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3264]=",ExpressionUUID->"2c77722b-3f26-4608-979e-efbeab6ecb06"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Corresponds", " ", "to", " ", "Theorem", " ", "2", " ", "in", " ", "the",
      " ", 
     RowBox[{"paper", ".", "  ", "Return"}], " ", "value", " ", "of", " ", 
     "0", " ", "means", " ", "definitely", " ", "false"}], ",", " ", 
    RowBox[{"1", " ", "is", " ", 
     RowBox[{"inconclusive", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"OneVarZero", "[", 
     RowBox[{"polyList_", ",", " ", "ineqList_"}], "]"}], " ", ":=", " ", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"allVars", ",", " ", "i", ",", " ", "polyListSetZero"}], "}"}],
       " ", ",", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"allVars", " ", "=", " ", 
        RowBox[{"AllVariables", "[", "polyList", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", 
          RowBox[{"Length", "[", "allVars", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", " ", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"polyListSetZero", " ", "=", " ", 
           RowBox[{"SetOneVarZero", "[", 
            RowBox[{"polyList", ",", " ", 
             RowBox[{"allVars", "[", 
              RowBox[{"[", "i", "]"}], "]"}]}], "]"}]}], ";", " ", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"EvaluateList", "[", 
              RowBox[{"polyListSetZero", ",", " ", "ineqList"}], "]"}], " ", 
             "\[Equal]", " ", "1"}], ",", " ", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{"\"\<Witness: \>\"", ",", " ", 
               RowBox[{"allVars", "[", 
                RowBox[{"[", "i", "]"}], "]"}], ",", " ", 
               "\"\< is 0, all other variables are 1\>\""}], "]"}], ";", " ", 
             
             RowBox[{"Return", "[", "0", "]"}]}]}], "]"}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "1", "]"}]}]}], "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.753145590546929*^9, 3.7531456075613127`*^9}, {
  3.753145754122205*^9, 3.7531457548825607`*^9}, {3.75314606388804*^9, 
  3.7531460651950083`*^9}, {3.753146371843244*^9, 3.7531463733513403`*^9}, {
  3.7531464620361023`*^9, 3.753146567659216*^9}, {3.75314664388055*^9, 
  3.753146649999999*^9}, {3.753146740275238*^9, 3.753146746781941*^9}, {
  3.753146781128854*^9, 3.7531468257768087`*^9}, {3.753147077751288*^9, 
  3.7531471461353292`*^9}, {3.75314719973765*^9, 3.7531472041216288`*^9}, {
  3.7531475098269453`*^9, 3.75314751124192*^9}, {3.753147574320135*^9, 
  3.753147574624851*^9}, {3.753147646409514*^9, 3.753147654510376*^9}, {
  3.753147690105446*^9, 3.753147690693345*^9}, {3.753147967474023*^9, 
  3.7531479739364023`*^9}, {3.753162815471443*^9, 3.753162916391334*^9}, {
  3.753163746294691*^9, 3.753163749035077*^9}},
 Background->GrayLevel[0.85],
 CellLabel->
  "In[2520]:=",ExpressionUUID->"a50f631a-f109-4c7d-ac2f-31f1d76e94a6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OneVarZero", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "^", "3"}], " ", "-", " ", "5"}], "}"}], ",", " ", 
   RowBox[{"{", "\"\<>\>\"", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753147113042756*^9, 3.7531471227648907`*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[2521]:=",ExpressionUUID->"89e31cdc-02ea-48ef-8286-20bb5b682d86"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`x, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{{3.753162914278294*^9, 3.753162918086008*^9}, 
   3.7531637519664*^9},
 CellLabel->
  "During evaluation of \
In[2521]:=",ExpressionUUID->"172f5acb-637c-4bfa-991d-9b3bc258d1fd"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.753147123280241*^9, 3.7531471579644012`*^9}, {
   3.7531472070699778`*^9, 3.753147219050398*^9}, {3.75314747234595*^9, 
   3.753147513498673*^9}, {3.7531475763666143`*^9, 3.7531475881337223`*^9}, 
   3.753147694006221*^9, {3.753162890505636*^9, 3.7531629181101913`*^9}, 
   3.753163751986785*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[2521]=",ExpressionUUID->"3e27ad04-7391-4f4a-b553-8bceb4ca6e33"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OneVarZero", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "^", "3"}], " ", "+", " ", "5"}], "}"}], ",", " ", 
   RowBox[{"{", "\"\<>=\>\"", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753147707171934*^9, 3.753147710981205*^9}, {
  3.753147747084141*^9, 3.753147747897875*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[2523]:=",ExpressionUUID->"85b1a89a-1b9c-4081-8f6f-1d3a3768563b"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.753147707902649*^9, 3.753147711343442*^9}, {
   3.7531628918950243`*^9, 3.753162920222134*^9}, 3.753163757733252*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[2523]=",ExpressionUUID->"c7bfa07d-5b3d-4ae7-b0f0-a2f4df8c580c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OneVarZero", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"y", "^", "3"}], ",", " ", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"x", "^", "2"}]}], " ", "+", " ", "y"}]}], " ", "}"}], ",", 
   " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>\>\"", ",", " ", "\"\<>\>\""}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753147714465589*^9, 3.753147723958437*^9}, {
  3.7531640821872587`*^9, 3.75316409952918*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3265]:=",ExpressionUUID->"da6ccecd-1ccb-4d2b-9089-2161dd059aca"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "y", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`y, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.7531640998889723`*^9, 3.753165495213678*^9},
 CellLabel->
  "During evaluation of \
In[3265]:=",ExpressionUUID->"a20a5599-0df7-4685-8947-ad6a17647950"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.753147716986126*^9, 3.753147724342415*^9}, 
   3.7531629219888983`*^9, 3.7531637564167767`*^9, {3.7531640830119753`*^9, 
   3.753164099901511*^9}, 3.753165495229745*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3265]=",ExpressionUUID->"4c695fdf-3813-4216-99e4-d800d017d691"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OneVarZero", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "^", "3"}], "  ", "-", " ", 
     RowBox[{"y", "^", "2"}]}], "}"}], ",", " ", 
   RowBox[{"{", "\"\<>\>\"", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753147731810586*^9, 3.7531477360537643`*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3266]:=",ExpressionUUID->"373b4774-e5d9-429b-8643-d3ff7b17ed71"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`x, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.75316292406701*^9, 3.753163758963715*^9, 
  3.7531654974539013`*^9},
 CellLabel->
  "During evaluation of \
In[3266]:=",ExpressionUUID->"38863f96-80c2-457e-a014-0ab6b61ce362"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.7531477364544764`*^9, 3.753162924081376*^9, 
  3.75316375898563*^9, 3.753165497471106*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3266]=",ExpressionUUID->"97676747-c329-490f-a4b7-d533941debcf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OneVarZero", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "^", "3"}], " ", "+", " ", "5"}], ",", " ", 
     RowBox[{
      RowBox[{"x", "^", "3"}], " ", "-", " ", 
      RowBox[{"y", "^", "2"}]}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>=\>\"", ",", "  ", "\"\<>\>\""}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753147752431614*^9, 3.75314776296145*^9}, {
  3.75314782438437*^9, 3.7531478284371862`*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3267]:=",ExpressionUUID->"55f9687f-9a66-45b4-a589-3a0903b19e58"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.7531478071607113`*^9, 3.7531478289409447`*^9}, 
   3.753162927159079*^9, 3.753163763572083*^9, 3.7531654986417627`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3267]=",ExpressionUUID->"f2d7c2d4-ffee-418d-b346-31419c8467c0"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OneVarZero", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "^", "3"}], " ", ",", " ", 
     RowBox[{
      RowBox[{"x", "^", "3"}], " ", "-", " ", 
      RowBox[{"y", "^", "2"}]}], ",", " ", 
     RowBox[{
      RowBox[{"x", "^", "3"}], " ", "-", " ", "5"}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>\>\"", ",", " ", "\"\<>=\>\"", ",", " ", "\"\<>\>\""}], 
    "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753147767002056*^9, 3.753147820730159*^9}, {
  3.753147852997491*^9, 3.753147853689542*^9}, {3.7531478980736647`*^9, 
  3.753147903754099*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3268]:=",ExpressionUUID->"488559eb-3ae1-45ff-8044-0c2f5a84fe96"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`x, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.7531629321487703`*^9, 3.753163761996999*^9, 
  3.753165500059309*^9},
 CellLabel->
  "During evaluation of \
In[3268]:=",ExpressionUUID->"a43e2be4-84eb-4126-99ab-c21cdfd44fbe"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.753147776420226*^9, 3.7531478212532263`*^9}, {
   3.7531478540427647`*^9, 3.753147905807541*^9}, 3.7531629321671257`*^9, 
   3.7531637620182133`*^9, 3.753165500072576*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3268]=",ExpressionUUID->"f9bb61d2-9379-44b1-8645-4ffd189c2558"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Theorem 3", "Subsubsection",
 CellChangeTimes->{{3.7531414305806923`*^9, 
  3.7531414315039883`*^9}},ExpressionUUID->"01b4bb29-53a2-4119-9569-\
29e2d947f1da"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"INPUT", ":", " ", 
     RowBox[{"a", " ", "list", " ", "of", " ", 
      RowBox[{"(", "simplified", ")"}], " ", "f_", "1"}]}], ",", " ", "...", 
    ",", " ", 
    RowBox[{
    "f_k", " ", "and", " ", "a", " ", "list", " ", "of", " ", "inequalities", 
     " ", 
     RowBox[{"(", 
      RowBox[{"each", " ", "\"\<>\>\"", " ", "or", " ", "\"\<>=\>\""}], 
      ")"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "A", " ", "return", " ", "value", " ", "of", " ", "0", " ", "means", " ", 
     "\"\<definitely false\>\""}], ";", " ", 
    RowBox[{
    "a", " ", "return", " ", "value", " ", "of", " ", "1", " ", "means", " ", 
     "\"\<inconclusive\>\""}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
   "Corresponds", " ", "to", " ", "Theorem", " ", "3", " ", "in", " ", "the", 
    " ", "paper"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"HighestDegMonomial", "[", 
     RowBox[{"polyList_", ",", " ", "ineqList_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "i", ",", " ", "poly", ",", "ineq", ",", "vList", ",", " ", "eList", 
        ",", " ", "eVal", ",", " ", "coeff", ",", " ", 
        "allLeadingCoeffsNeg"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"allLeadingCoeffsNeg", " ", "=", " ", "1"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", 
          RowBox[{"Length", "[", "polyList", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"poly", " ", "=", " ", 
           RowBox[{"polyList", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"ineq", " ", "=", " ", 
           RowBox[{"ineqList", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"vList", " ", "=", " ", 
           RowBox[{"Variables", "[", "poly", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"eList", " ", "=", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"(", 
              RowBox[{"#", "\[Rule]", 
               RowBox[{"vList", "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], ")"}], " ", "&"}], " ", "/@",
             " ", "vList"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"eVal", " ", "=", 
           RowBox[{"Simplify", "[", " ", 
            RowBox[{"poly", " ", "/.", " ", "eList"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"LeadingCoefficient", "[", 
               RowBox[{"eVal", ",", " ", 
                RowBox[{"vList", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "]"}], " ", ">", " ", 
              "0"}], "  ", "&&", " ", 
             RowBox[{"ineq", " ", "==", " ", "\"\<>\>\""}]}], ",", " ", 
            RowBox[{"allLeadingCoeffsNeg", "=", " ", "0"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"LeadingCoefficient", "[", 
               RowBox[{"eVal", ",", " ", 
                RowBox[{"vList", "[", 
                 RowBox[{"[", "1", "]"}], "]"}]}], "]"}], " ", ">=", " ", 
              "0"}], "  ", "&&", " ", 
             RowBox[{"ineq", " ", "==", " ", "\"\<>=\>\""}]}], ",", " ", 
            RowBox[{"allLeadingCoeffsNeg", "=", " ", "0"}]}], "]"}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"allLeadingCoeffsNeg", " ", "\[Equal]", " ", "1"}], ",", " ", 
         RowBox[{
          RowBox[{
          "Print", "[", 
           "\"\<Witness: All variables are infty (i.e. set all variables \
equal and sufficiently large)\>\"", "]"}], ";", " ", 
          RowBox[{"Return", " ", "[", "0", "]"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Return", " ", "[", "1", "]"}], ";"}]}], "\[IndentingNewLine]",
      "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.753140331087968*^9, 3.753140378538221*^9}, {
  3.753162965370463*^9, 3.753162970071855*^9}, {3.7531630112434053`*^9, 
  3.75316301882176*^9}, {3.753163320458507*^9, 3.753163400704858*^9}, {
  3.753163472966955*^9, 3.753163493205983*^9}, {3.753163729883967*^9, 
  3.7531637310243177`*^9}},
 Background->GrayLevel[0.85],
 CellLabel->
  "In[2515]:=",ExpressionUUID->"ae6d1712-9449-4af9-8ff0-701e5d9c6cf4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Test", " ", "Cases"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"HighestDegMonomial", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", "^", "2"}], " ", "+", " ", 
      RowBox[{"y", " ", "*", "z"}], " ", "-", " ", 
      RowBox[{"z", "^", "3"}], "+", " ", "1"}], "}"}], ",", " ", 
    RowBox[{"{", "\"\<>\>\"", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.753140193765438*^9, 3.7531401984280443`*^9}, {
  3.753140240100237*^9, 3.753140258564909*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3269]:=",ExpressionUUID->"e80b25bf-be87-46e4-8d6b-f2805c2fc3ca"],

Cell[BoxData["\<\"Witness: All variables are infty (i.e. set all variables \
equal and sufficiently large)\"\>"], "Print",
 CellChangeTimes->{3.7531629726061983`*^9, 3.753163021275692*^9, 
  3.7531637337356358`*^9, 3.753165503255826*^9},
 CellLabel->
  "During evaluation of \
In[3269]:=",ExpressionUUID->"43e50b40-636d-4a62-8679-fb818e06df3c"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.753140186708209*^9, 3.753140203155034*^9}, {
   3.753140242009618*^9, 3.753140258839044*^9}, 3.75314029527067*^9, 
   3.75316297262283*^9, 3.753163021298959*^9, 3.7531637337549477`*^9, 
   3.753165503274437*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3269]=",ExpressionUUID->"2f97db09-887e-4e0a-b602-5bd94c5e86aa"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HighestDegMonomial", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", "^", "2"}], " ", "-", 
     RowBox[{
      RowBox[{"x", "^", "2"}], "*", "y", " ", "*", "z"}], " ", "+", " ", 
     RowBox[{"z", "^", "3"}], "+", " ", "1"}], "}"}], ",", " ", 
   RowBox[{"{", "\"\<>\>\"", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753140264655555*^9, 3.7531402675913143`*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3270]:=",ExpressionUUID->"ba39d844-12fa-4cc5-bfd8-7e88db5a3871"],

Cell[BoxData["\<\"Witness: All variables are infty (i.e. set all variables \
equal and sufficiently large)\"\>"], "Print",
 CellChangeTimes->{3.753162974284422*^9, 3.753163023715746*^9, 
  3.75316373543909*^9, 3.7531655045892487`*^9},
 CellLabel->
  "During evaluation of \
In[3270]:=",ExpressionUUID->"88013eff-5401-4729-b1b5-074a9fe2b59f"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.753140268083539*^9, 3.753140296215962*^9}, 
   3.753162974327518*^9, 3.7531630237408133`*^9, 3.7531637354589863`*^9, 
   3.753165504604965*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3270]=",ExpressionUUID->"24967988-7847-4607-8738-c94784426738"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HighestDegMonomial", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"x", "^", "2"}]}], " ", "+", 
     RowBox[{"x", "*", "y", " ", "*", "z"}], " ", "-", " ", 
     RowBox[{"z", "^", "3"}], "+", " ", "1"}], "}"}], ",", " ", 
   RowBox[{"{", "\"\<>\>\"", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753140272823372*^9, 3.753140276560075*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3271]:=",ExpressionUUID->"fa875534-47fd-4938-8502-0db2e68e8019"],

Cell[BoxData["\<\"Witness: All variables are infty (i.e. set all variables \
equal and sufficiently large)\"\>"], "Print",
 CellChangeTimes->{3.753162975584675*^9, 3.753163025249069*^9, 
  3.753163737051322*^9, 3.753165505841905*^9},
 CellLabel->
  "During evaluation of \
In[3271]:=",ExpressionUUID->"d1137427-ea64-481a-8679-5357c52e380f"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.7531402787560062`*^9, 3.753140297326433*^9}, 
   3.753162975602848*^9, 3.753163025268157*^9, 3.753163737072138*^9, 
   3.753165505856279*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3271]=",ExpressionUUID->"3d927edf-0988-44f3-8b63-2ce05b99b2c4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HighestDegMonomial", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"x", "^", "2"}]}], " ", "+", 
     RowBox[{"2", "*", "x", "*", "y", " ", "*", "z"}], " ", "-", " ", 
     RowBox[{"z", "^", "3"}], "+", " ", "1"}], "}"}], ",", " ", 
   RowBox[{"{", "\"\<>\>\"", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.7531403019442663`*^9, 3.7531403023271008`*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3272]:=",ExpressionUUID->"cde14fed-c855-4c3c-8659-fa14e0cd7254"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.7531403030794067`*^9, 3.7531629779267473`*^9, 
  3.753163026761272*^9, 3.753165507014472*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3272]=",ExpressionUUID->"cc6088b7-16f9-4115-842e-70ebaec0337f"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"HighestDegMonomial", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "3"}], " ", "*", 
      RowBox[{"x", "^", "3"}]}], "-", 
     RowBox[{"29", "*", " ", 
      RowBox[{"x", "^", "5"}]}], "+", 
     RowBox[{"57", " ", "*", 
      RowBox[{"x", "^", "6"}]}], "-", 
     RowBox[{"18", " ", "*", 
      RowBox[{"x", "^", "8"}]}]}], "}"}], ",", " ", 
   RowBox[{"{", "\"\<>\>\"", "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753163266711481*^9, 3.75316329741155*^9}, {
  3.753163483577649*^9, 3.753163485248558*^9}},
 CellLabel->
  "In[2519]:=",ExpressionUUID->"c1b2f530-637b-4cb5-b512-e0e33eec058f"],

Cell[BoxData["\<\"Witness: All variables are infty (i.e. set all variables \
equal and sufficiently large)\"\>"], "Print",
 CellChangeTimes->{{3.7531632765860662`*^9, 3.753163298319277*^9}, 
   3.753163378139886*^9, {3.753163479612961*^9, 3.753163497848592*^9}, 
   3.75316373937072*^9},
 CellLabel->
  "During evaluation of \
In[2519]:=",ExpressionUUID->"252a63dd-7b29-4ae1-92fa-c17dd9d84e05"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.753163276603685*^9, 3.753163298448924*^9}, 
   3.753163378389175*^9, {3.753163479846332*^9, 3.753163497867944*^9}, 
   3.753163739389737*^9},
 CellLabel->
  "Out[2519]=",ExpressionUUID->"5b5d726f-5b87-4e8b-8d76-027997efa9e9"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Theorem 4", "Subsubsection",
 CellChangeTimes->{{3.7531415127301702`*^9, 
  3.7531415240390368`*^9}},ExpressionUUID->"ac3a1b25-ce81-4e99-b017-\
0fa0ade60710"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Helper", " ", "function", " ", "for", " ", "LeadingRealCoeff", 
     "\[IndentingNewLine]", "Return", " ", "1", " ", "means", " ", "true"}], 
    ",", " ", 
    RowBox[{"return", " ", "0", " ", "means", " ", "false"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"OnePolyLeadingRealCoeff", "[", 
     RowBox[{"poly_", ",", " ", "var_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "monomialList", ",", " ", "allEven", ",", " ", "vList", ",", " ", 
        "evalList", ",", " ", "eVal", ",", " ", "i", ",", " ", "j", ",", " ", 
        "pos"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"vList", " ", "=", " ", 
        RowBox[{"Variables", "[", "poly", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"MemberQ", "[", 
           RowBox[{"vList", ",", " ", "var"}], "]"}], " ", "\[Equal]", " ", 
          "0"}], ",", " ", 
         RowBox[{
          RowBox[{"Return", "[", "1", "]"}], ";"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"pos", " ", "=", " ", 
        RowBox[{"Position", "[", 
         RowBox[{"vList", ",", " ", "var"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"evalList", " ", "=", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{"#", "\[Rule]", "1"}], ")"}], " ", "&"}], " ", "/@", " ", 
         "vList"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"evalList", " ", "=", " ", 
        RowBox[{"Delete", "[", 
         RowBox[{"evalList", ",", " ", "pos"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"eVal", " ", "=", " ", 
        RowBox[{"Simplify", "[", 
         RowBox[{"poly", " ", "/.", " ", "evalList"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"LeadingCoefficient", "[", 
           RowBox[{"eVal", ",", " ", "var"}], "]"}], " ", "<", " ", "0"}], 
         ",", " ", 
         RowBox[{"Return", "[", "1", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "0", "]"}], ";"}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.753143084158209*^9, 3.753143086010634*^9}, {
   3.753143173110736*^9, 3.753143175320907*^9}, {3.753143401373382*^9, 
   3.75314340915724*^9}, {3.7531435219385033`*^9, 3.753143587840735*^9}, {
   3.753143682251189*^9, 3.753143857936261*^9}, {3.7531441375073557`*^9, 
   3.7531441530996017`*^9}, {3.7531446632098846`*^9, 3.753144683001329*^9}, 
   3.753145123234064*^9, {3.7531467039101877`*^9, 3.7531467061524897`*^9}},
 Background->GrayLevel[0.85],
 CellLabel->
  "In[144]:=",ExpressionUUID->"840f6230-eb7c-4297-8945-8ef6bc3c5858"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Test", " ", "Cases"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"OnePolyLeadingRealCoeff", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"x", "^", "2"}], " ", "+", " ", "y", "-", "z"}], ",", " ", "x"}],
    "]"}]}]], "Input",
 CellChangeTimes->{{3.75314352538964*^9, 3.75314353573311*^9}, {
  3.753143851485758*^9, 3.753143868050104*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3273]:=",ExpressionUUID->"86311cc8-305f-4a9b-b46d-a57903540653"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.7531437241789103`*^9, 3.753143775412368*^9}, {
   3.753143846152483*^9, 3.753143868598976*^9}, 3.753144667293346*^9, 
   3.753145125934092*^9, 3.753146708299026*^9, 3.753165510322193*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3273]=",ExpressionUUID->"203d2aa0-93bc-452b-b5ee-e89177dee268"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OnePolyLeadingRealCoeff", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"x", "^", "2"}]}], " ", "+", " ", "y", "-", "z"}], ",", " ", 
   "x"}], "]"}]], "Input",
 CellChangeTimes->{3.753143870723213*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3274]:=",ExpressionUUID->"e000156b-7381-4eca-bc4a-4533e6974666"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.75314387982619*^9, 3.753144669007105*^9, 
  3.753145127153213*^9, 3.75314670988374*^9, 3.753165511633523*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3274]=",ExpressionUUID->"8a32fa8f-0acf-4bde-bba7-54994bee5014"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OnePolyLeadingRealCoeff", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"x", "^", "2"}]}], " ", "+", " ", "y", "-", "z"}], ",", " ", 
   "z"}], "]"}]], "Input",
 CellChangeTimes->{{3.753143884694393*^9, 3.753143886440177*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3275]:=",ExpressionUUID->"ef6caa89-e97d-4d4c-aff0-ba0005abce38"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.753143887012155*^9, 3.753144670754387*^9, 
  3.753145129090138*^9, 3.7531467108972893`*^9, 3.753165512778153*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3275]=",ExpressionUUID->"ebf6321c-9ba0-411c-8102-d730d981dc78"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OnePolyLeadingRealCoeff", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"x", "^", "2"}]}], " ", "+", " ", "y", "-", "z"}], ",", " ", 
   "w"}], "]"}]], "Input",
 CellChangeTimes->{{3.7531441590492907`*^9, 3.7531441592848*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3276]:=",ExpressionUUID->"42637ec6-b32b-4abb-8b14-b5d367189808"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.7531441600259733`*^9, 3.753144672291779*^9, 
  3.753145130677837*^9, 3.753165514000552*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3276]=",ExpressionUUID->"86268a56-c88e-4c2e-905d-6c411d09cd81"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OnePolyLeadingRealCoeff", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x", "^", "2"}], " ", "+", " ", "y", "+", "z"}], ",", " ", "w"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.753145166250482*^9, 3.753145167754158*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3277]:=",ExpressionUUID->"4e76d178-352b-4b8c-852f-f0e7eadc4fac"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.753145168391403*^9, 3.753146712850676*^9, 
  3.7531655154528103`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3277]=",ExpressionUUID->"c30d5d52-1748-475e-b5b3-2e665bdfa015"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Corresponds", " ", "to", " ", "Theorem", " ", "4", " ", "in", " ", "the",
      " ", "paper", " ", "\[IndentingNewLine]", "Return", " ", "1", " ", 
     "means", " ", "inconclusive"}], ",", " ", 
    RowBox[{
    "return", " ", "0", " ", "means", " ", "definitely", " ", "false"}]}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"LeadingRealCoeff", "[", 
     RowBox[{"polyList_", ",", " ", "ineqList_"}], "]"}], " ", ":=", " ", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "allNeg", ",", " ", "i", ",", " ", "vList", ",", " ", "j", ",", " ", 
        "k", ",", " ", "allVars", ",", " ", "var"}], "}"}], ",", " ", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "This", " ", "theorem", " ", "only", " ", "works", " ", "on", " ", 
        "the", " ", "fully", " ", "strict", " ", "fragment"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"MemberQ", "[", 
          RowBox[{"ineqList", ",", " ", "\"\<>=\>\""}], "]"}], ",", " ", 
         RowBox[{"Return", "[", "1", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"allVars", " ", "=", " ", 
        RowBox[{"AllVariables", "[", "polyList", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", 
          RowBox[{"Length", "[", "allVars", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"allNeg", " ", "=", " ", "1"}], ";", "\[IndentingNewLine]", 
          
          RowBox[{"var", " ", "=", " ", 
           RowBox[{"allVars", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"For", "[", " ", 
           RowBox[{
            RowBox[{"j", " ", "=", " ", "1"}], ",", " ", 
            RowBox[{"j", " ", "\[LessEqual]", " ", 
             RowBox[{"Length", "[", "polyList", "]"}]}], ",", " ", 
            RowBox[{"j", "++"}], ",", " ", 
            RowBox[{
             RowBox[{"If", "[", " ", 
              RowBox[{
               RowBox[{
                RowBox[{"OnePolyLeadingRealCoeff", "[", 
                 RowBox[{
                  RowBox[{"polyList", "[", 
                   RowBox[{"[", "j", "]"}], "]"}], ",", " ", "var"}], "]"}], 
                " ", "\[Equal]", " ", "0"}], ",", " ", 
               RowBox[{"allNeg", " ", "=", " ", "0"}]}], "]"}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
           "If", " ", "all", " ", "polynomials", " ", "have", " ", "negative",
             " ", "leading", " ", "real", " ", "coefficient", " ", "for", " ",
             "a", " ", "particular", " ", "variable"}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"allNeg", " ", "\[Equal]", " ", "1"}], ",", " ", 
            RowBox[{
             RowBox[{"Print", "[", 
              RowBox[{
              "\"\<Witness: \>\"", ",", " ", "var", ",", " ", 
               "\"\< is infty, all other vars 1\>\""}], "]"}], ";", " ", 
             RowBox[{"Return", "[", "0", "]"}]}]}], "]"}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "1", "]"}], ";"}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.7531430875075483`*^9, 3.753143124855044*^9}, {
  3.753143199505165*^9, 3.753143220193719*^9}, {3.753143257585548*^9, 
  3.753143296436849*^9}, {3.753143908800456*^9, 3.753143923316082*^9}, {
  3.753143957085174*^9, 3.753144029966783*^9}, {3.753144186500662*^9, 
  3.7531442079256287`*^9}, {3.753144416515829*^9, 3.7531444240186453`*^9}, {
  3.753144520955282*^9, 3.7531445917234507`*^9}, {3.753144692301299*^9, 
  3.7531447570395317`*^9}, {3.753145221392005*^9, 3.753145224853651*^9}, {
  3.753163074791492*^9, 3.753163103307273*^9}, {3.753163702468568*^9, 
  3.7531637059960012`*^9}},
 Background->GrayLevel[0.85],
 CellLabel->
  "In[2513]:=",ExpressionUUID->"e6bbddd7-dab9-407a-98bb-2aaa7ca37c27"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Test", " ", "Cases"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"LeadingRealCoeff", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", 
        RowBox[{"x", "^", "2"}]}], " ", "+", " ", 
       RowBox[{"5", "*", "x"}], " ", "+", " ", 
       RowBox[{"z", "^", "8"}], " ", "+", " ", 
       RowBox[{"y", "*", 
        RowBox[{"z", "^", "5"}]}]}], ",", " ", 
      RowBox[{"x", "*", "y", "*", "z", "*", "w", "*", "v"}]}], " ", "}"}], 
    ",", " ", 
    RowBox[{"{", 
     RowBox[{"\"\<>=\>\"", ",", " ", "\"\<>\>\""}], "}"}]}], "]"}]}]], "Input",\

 CellChangeTimes->{{3.753145007070343*^9, 3.7531450452511873`*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3278]:=",ExpressionUUID->"c76ac05c-cb4a-4ae2-b68b-dcec709cc620"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.7531450457182617`*^9, 3.753145180841312*^9, 
  3.753145228313944*^9, 3.753163106192604*^9, 3.75316551852703*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3278]=",ExpressionUUID->"0d4b20bc-d566-4a21-b866-faad66ba1dd7"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LeadingRealCoeff", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"x", "^", "2"}]}], " ", "+", " ", 
      RowBox[{"5", "*", "x"}], " ", "+", " ", 
      RowBox[{"z", "^", "8"}], " ", "+", " ", 
      RowBox[{"y", "*", 
       RowBox[{"z", "^", "5"}]}]}], ",", " ", 
     RowBox[{
      RowBox[{"-", "x"}], "*", "y", "*", "z", "*", "w", "*", "v"}]}], " ", 
    "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>=\>\"", ",", " ", "\"\<>\>\""}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.7531450573388987`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3279]:=",ExpressionUUID->"512c0921-0b48-4b8b-8919-fc031f078b76"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.7531450579180927`*^9, 3.753145182066884*^9, 
  3.7531452294147*^9, 3.753163109798558*^9, 3.7531655196961393`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3279]=",ExpressionUUID->"0d6cd77c-eb11-496b-aa70-3103e48ac319"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LeadingRealCoeff", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", 
       RowBox[{"x", "^", "2"}]}], " ", "+", " ", 
      RowBox[{"5", "*", "x"}], " ", "+", " ", 
      RowBox[{"z", "^", "8"}], " ", "+", " ", 
      RowBox[{"y", "*", 
       RowBox[{"z", "^", "5"}]}]}], ",", " ", 
     RowBox[{
      RowBox[{"-", "x"}], "*", "y", "*", "z", "*", "w", "*", "v"}]}], " ", 
    "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>\>\"", ",", " ", "\"\<>\>\""}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.753145061738579*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3280]:=",ExpressionUUID->"807d530d-caa8-4b2e-b423-ac36781ca8c3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\" is infty, all other vars 1\"\>"}],
  SequenceForm["Witness: ", $CellContext`x, " is infty, all other vars 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753163111966406*^9, 3.753163710523929*^9, 
  3.753165520783383*^9},
 CellLabel->
  "During evaluation of \
In[3280]:=",ExpressionUUID->"891177dd-0158-4e5e-bf91-5b85ed6f4685"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{
  3.7531450621282263`*^9, {3.7531451832706127`*^9, 3.7531451849603043`*^9}, 
   3.753145231054474*^9, 3.753163111981881*^9, 3.753163710544215*^9, 
   3.753165520797851*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3280]=",ExpressionUUID->"9461b274-c8e6-444c-af2c-3557a96ba2b2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Theorem 5", "Subsubsection",
 CellChangeTimes->{{3.753141473741332*^9, 3.753141474658144*^9}, {
  3.7531415067007513`*^9, 
  3.753141524875958*^9}},ExpressionUUID->"52d75978-1899-4bfc-9e0e-\
4e52e654a5e2"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Helper", " ", "function", " ", "for", " ", "AllMonomialsEvenDeg"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"OnePolyAllMonomialsEvenDeg", "[", "poly_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "monomialList", ",", " ", "allEven", ",", " ", "vList", ",", " ", "i", 
        ",", " ", "j"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"allEven", " ", "=", " ", "1"}], ";", "\[IndentingNewLine]", 
       RowBox[{"vList", " ", "=", " ", 
        RowBox[{"Variables", "[", "poly", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"monomialList", " ", "=", " ", 
        RowBox[{"MonomialList", "[", "poly", "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "<=", " ", 
          RowBox[{"Length", "[", "monomialList", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"j", " ", "=", " ", "1"}], ",", " ", 
            RowBox[{"j", " ", "<=", " ", 
             RowBox[{"Length", "[", "vList", "]"}]}], ",", " ", 
            RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"Mod", "[", 
                 RowBox[{
                  RowBox[{"Exponent", "[", 
                   RowBox[{
                    RowBox[{"monomialList", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], ",", " ", 
                    RowBox[{"vList", "[", 
                    RowBox[{"[", "j", "]"}], "]"}]}], "]"}], " ", ",", " ", 
                  "2"}], "]"}], "\[Equal]", " ", "1"}], ",", " ", 
               RowBox[{
                RowBox[{"allEven", " ", "=", " ", "0"}], ";"}]}], 
              "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
           "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "allEven", "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.753141602976803*^9, 3.753141819777177*^9}, {
  3.753141851336561*^9, 3.7531418617068577`*^9}, {3.753141918638178*^9, 
  3.753141918864461*^9}, {3.7531420415348454`*^9, 3.753142093070075*^9}},
 Background->GrayLevel[0.85],
 CellLabel->"In[11]:=",ExpressionUUID->"6b8636c2-27c5-466f-804a-879e9efa61ea"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Test", " ", "Cases"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"OnePolyAllMonomialsEvenDeg", "[", 
   RowBox[{
    RowBox[{"x", "^", "2"}], " ", "+", " ", 
    RowBox[{
     RowBox[{"y", "^", "2"}], " ", "*", 
     RowBox[{"z", "^", "2"}]}], " ", "-", " ", 
    RowBox[{"z", "^", "4"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.753141936654366*^9, 3.7531419590287457`*^9}, {
  3.75314204907843*^9, 3.75314207567598*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3281]:=",ExpressionUUID->"e41e80f8-1c02-4c2c-bd50-82878f827e01"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{
  3.753141959497974*^9, {3.753142046268071*^9, 3.7531420601313972`*^9}, 
   3.753163133104014*^9, 3.753165523510004*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3281]=",ExpressionUUID->"e7a8989a-5e71-49bf-8525-4b9222a602a4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OnePolyAllMonomialsEvenDeg", "[", 
  RowBox[{
   RowBox[{"x", "^", "2"}], " ", "+", " ", 
   RowBox[{
    RowBox[{"y", "^", "2"}], " ", "*", 
    RowBox[{"z", "^", "2"}]}], " ", "-", " ", 
   RowBox[{"q", "*", 
    RowBox[{"z", "^", "4"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753142065208693*^9, 3.753142068796302*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3282]:=",ExpressionUUID->"378771e8-ce9e-4563-9887-d332ab879a9b"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.753142069341957*^9, 3.7531631343528357`*^9, 
  3.753165524620326*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3282]=",ExpressionUUID->"6083aa3d-20a2-4e04-93a8-78b322c1399d"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Corresponds", " ", "to", " ", "Theorem", " ", "5", " ", "in", " ", "the",
      " ", "paper", " ", "\[IndentingNewLine]", "Return", " ", "0", " ", 
     "means", " ", "inconclusive"}], ",", " ", 
    RowBox[{
    "return", " ", "1", " ", "means", " ", "definitely", " ", "true"}]}], " ",
    "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"AllMonomialsEvenDeg", "[", 
     RowBox[{"polyList_", ",", " ", "ineqList_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "i", ",", "poly", ",", " ", "ineq", ",", " ", "vList", ",", " ", 
        "evalList", ",", " ", "eVal"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", 
          RowBox[{"Length", "[", "polyList", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", " ", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"poly", " ", "=", " ", 
           RowBox[{"polyList", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"ineq", " ", "=", " ", 
           RowBox[{"ineqList", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"If", " ", "ineq", " ", "is"}], " ", "\[GreaterEqual]", 
             " ", 
             RowBox[{
             "and", " ", "all", " ", "monomials", " ", "have", " ", "even", 
              " ", "degree", " ", "in", " ", "all", " ", "variables"}]}], ",",
             " ", 
            RowBox[{"return", " ", "1"}]}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"OnePolyAllMonomialsEvenDeg", "[", "poly", "]"}], " ", 
              "\[Equal]", " ", "1"}], " ", "&&", " ", 
             RowBox[{"ineq", " ", "\[Equal]", "\"\<>=\>\""}]}], ",", " ", 
            RowBox[{
             RowBox[{"Return", "[", "1", "]"}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
             RowBox[{"If", " ", "ineq", " ", "is"}], " ", ">", " ", 
             RowBox[{
             "and", " ", "all", " ", "monomials", " ", "have", " ", "even", 
              " ", "degree", " ", "in", " ", "all", " ", "variables"}]}], ",",
             " ", 
            RowBox[{
            "check", " ", "the", " ", "sign", " ", "of", " ", "the", " ", 
             "constant", " ", 
             RowBox[{"term", ".", "  ", "If"}], " ", 
             RowBox[{"it", "'"}], "s", " ", "positive"}], ",", " ", 
            RowBox[{"return", " ", "1."}]}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"OnePolyAllMonomialsEvenDeg", "[", "poly", "]"}], " ", 
              "\[Equal]", " ", "1"}], " ", "&&", " ", 
             RowBox[{"ineq", " ", "\[Equal]", "\"\<>\>\""}]}], ",", " ", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"vList", " ", "=", " ", 
              RowBox[{"Variables", "[", "poly", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"evalList", " ", "=", " ", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"#", "\[Rule]", "0"}], ")"}], " ", "&"}], " ", "/@", 
               " ", "vList"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"eVal", " ", "=", " ", 
              RowBox[{"poly", " ", "/.", " ", "evalList"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"eVal", " ", ">", " ", "0"}], ",", 
               RowBox[{
                RowBox[{"Return", "[", "1", "]"}], ";"}]}], "]"}], ";"}]}], 
           "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "0", "]"}], ";"}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.753141581754109*^9, 3.753141596242877*^9}, {
  3.753142110522541*^9, 3.753142127717044*^9}, {3.753142526034782*^9, 
  3.753142603036957*^9}, {3.753142642902845*^9, 3.753142765875616*^9}, {
  3.753142926920883*^9, 3.753142930940295*^9}, {3.753144173681769*^9, 
  3.7531441830158653`*^9}, {3.753144762390731*^9, 3.753144772174243*^9}},
 Background->GrayLevel[0.85],
 CellLabel->"In[92]:=",ExpressionUUID->"2c842c0b-83aa-46cd-9933-5bf73fe15b3b"],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Test", " ", "Cases"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.753142769513548*^9, 
  3.753142772032007*^9}},ExpressionUUID->"b84c9e77-7fb6-4bdf-b04d-\
94d2fd1cbe48"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AllMonomialsEvenDeg", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "^", "2"}], " ", "+", " ", 
      RowBox[{"y", "^", "2"}]}], ",", " ", 
     RowBox[{"x", " ", "+", " ", 
      RowBox[{"2", "*", "y"}], " ", "-", " ", 
      RowBox[{"8", "*", 
       RowBox[{"v", "^", "3"}]}]}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>=\>\"", ",", " ", "\"\<>\>\""}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753142776581582*^9, 3.7531428103550386`*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3283]:=",ExpressionUUID->"330d843c-93e9-40d5-8e18-7d7ebd23fdcf"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.7531428108809357`*^9, 3.753142933682241*^9, 
  3.753165526817243*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3283]=",ExpressionUUID->"81ee5013-0772-44b8-b3ac-b0c84121bbe1"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AllMonomialsEvenDeg", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "^", "2"}], " ", "+", " ", 
      RowBox[{"y", "^", "2"}]}], ",", " ", 
     RowBox[{"x", " ", "+", " ", 
      RowBox[{"2", "*", "y"}], " ", "-", " ", 
      RowBox[{"8", "*", 
       RowBox[{"v", "^", "3"}]}]}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>\>\"", ",", " ", "\"\<>\>\""}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{3.753142897778517*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3284]:=",ExpressionUUID->"ae2864c2-c8e1-42d3-9c13-93ed9aede99f"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{3.753142898446649*^9, 3.753142935271385*^9, 
  3.7531655279373407`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3284]=",ExpressionUUID->"deeb6d05-8971-407d-9051-ac6e0ee4bf99"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AllMonomialsEvenDeg", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "^", "2"}], " ", "+", " ", 
      RowBox[{"y", "^", "2"}], " ", "+", " ", "5"}], ",", " ", 
     RowBox[{"x", " ", "+", " ", 
      RowBox[{"2", "*", "y"}], " ", "-", " ", 
      RowBox[{"8", "*", 
       RowBox[{"v", "^", "3"}]}]}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>\>\"", ",", " ", "\"\<>\>\""}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.75314293994109*^9, 3.75314294063892*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3285]:=",ExpressionUUID->"87ec2677-c3b4-4176-a32f-0da6291f5d51"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{3.753142944650917*^9, 3.7531655292365513`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3285]=",ExpressionUUID->"1e8b756c-0e08-4c92-9e21-9209f0e89403"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AllMonomialsEvenDeg", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"x", "^", "2"}], " ", "+", " ", 
      RowBox[{"y", "^", "4"}], " ", "+", " ", 
      RowBox[{"5", "*", 
       RowBox[{"z", "^", "4"}], "*", 
       RowBox[{"x", "^", "2"}], "*", 
       RowBox[{"w", "^", "6"}]}], " ", "+", " ", "1"}], ",", " ", 
     RowBox[{"x", " ", "+", " ", 
      RowBox[{"2", "*", "y"}], " ", "-", " ", 
      RowBox[{"8", "*", 
       RowBox[{"v", "^", "3"}]}]}]}], "}"}], ",", " ", 
   RowBox[{"{", 
    RowBox[{"\"\<>\>\"", ",", " ", "\"\<>\>\""}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.753142950215568*^9, 3.753142974094727*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3286]:=",ExpressionUUID->"122004cc-e8c6-461c-9577-e79553c57395"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.7531429598067923`*^9, 3.7531429744486847`*^9}, 
   3.753165531261561*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3286]=",ExpressionUUID->"d4a8e041-bd77-4011-8e30-5ba78aa2d59a"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["AlgorithmSet puts all of the algorithms together.", "Subsection",
 CellChangeTimes->{{3.7531405455168533`*^9, 
  3.7531405541917887`*^9}},ExpressionUUID->"64cceb59-ca82-4714-9dba-\
51f525342c58"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"INPUT", ":", " ", 
     RowBox[{"a", " ", "list", " ", "of", " ", 
      RowBox[{"(", "simplified", ")"}], " ", "f_", "1"}]}], ",", " ", "...", 
    ",", " ", 
    RowBox[{
    "f_k", " ", "and", " ", "a", " ", "list", " ", "of", " ", "inequalities", 
     " ", 
     RowBox[{"(", 
      RowBox[{"each", " ", "\"\<>\>\"", " ", "or", " ", "\"\<>=\>\""}], 
      ")"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "A", " ", "return", " ", "value", " ", "of", " ", "0", " ", "means", " ", 
     "\"\<definitely false\>\""}], ";", " ", 
    RowBox[{
    "a", " ", "return", " ", "value", " ", "of", " ", "1", " ", "means", " ", 
     "\"\<inconclusive\>\""}], " ", ";", "\[IndentingNewLine]", 
    RowBox[{
    "a", " ", "return", " ", "value", " ", "of", " ", "2", " ", "means", " ", 
     "\"\<definitely true\>\""}]}], "\[IndentingNewLine]", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"AlgorithmSet", "[", 
     RowBox[{"polyList_", ",", " ", "ineqList_"}], "]"}], " ", ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", " ", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "If", " ", "any", " ", "of", " ", "the", " ", "algorithms", " ", 
         "corresponding", " ", "to", " ", "the", " ", "first", " ", "four", 
         " ", "theorems", " ", "in", " ", "the", " ", "paper", " ", "return", 
         " ", "false"}], ",", " ", 
        RowBox[{
        "we", " ", "KNOW", " ", "the", " ", "decision", " ", "problem", " ", 
         "is", " ", "false"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"HighestDegMonomial", "[", 
           RowBox[{"polyList", ",", " ", "ineqList"}], "]"}], " ", "\[Equal]",
           " ", "0"}], ",", " ", 
         RowBox[{"Return", "[", "0", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"LeadingRealCoeff", "[", 
           RowBox[{"polyList", ",", " ", "ineqList"}], "]"}], " ", "\[Equal]",
           " ", "0"}], ",", " ", 
         RowBox[{"Return", "[", "0", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"OneVarZero", "[", 
           RowBox[{"polyList", ",", " ", "ineqList"}], "]"}], " ", "\[Equal]",
           " ", "0"}], ",", " ", 
         RowBox[{"Return", "[", "0", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"OddDegree", "[", 
           RowBox[{"polyList", ",", " ", "ineqList"}], "]"}], " ", "\[Equal]",
           " ", "0"}], ",", " ", 
         RowBox[{"Return", "[", "0", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{
         "If", " ", "AllMonomialsEvenDeg", " ", "returns", " ", "true"}], ",",
          " ", 
         RowBox[{
         "we", " ", "KNOW", " ", "the", " ", "decision", " ", "problem", " ", 
          "is", " ", "true"}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"AllMonomialsEvenDeg", "[", 
           RowBox[{"polyList", ",", " ", "ineqList"}], "]"}], " ", "\[Equal]",
           " ", "1"}], ",", " ", 
         RowBox[{"Return", "[", "2", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Otherwise", ",", " ", 
         RowBox[{"our", " ", "algorithms", " ", "are", " ", 
          RowBox[{"inconclusive", "."}]}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "1", "]"}], ";"}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.7531405614578648`*^9, 3.7531406217487698`*^9}, {
  3.753141569640336*^9, 3.753141578491982*^9}, {3.753142816778842*^9, 
  3.753142840765491*^9}, {3.753143019972929*^9, 3.753143037016954*^9}, {
  3.7531448080306683`*^9, 3.753144817177965*^9}, {3.753147983834949*^9, 
  3.7531479920325527`*^9}, {3.753148239849429*^9, 3.7531482850636063`*^9}},
 Background->GrayLevel[0.85],
 CellLabel->
  "In[2495]:=",ExpressionUUID->"98bdc290-09c0-4cd1-b681-2f4e6aac0108"]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Convert everything to CNF formula, parse things to give the correct input to \
call AlgorithmSet.\
\>", "Subsection",
 CellChangeTimes->{{3.753140472574727*^9, 
  3.753140501960074*^9}},ExpressionUUID->"63c6846a-3146-499b-a679-\
dd0e03554f91"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "Run", " ", "the", " ", "formula", " ", "through", " ", 
     "BooleanConvert"}], " ", ",", " ", 
    RowBox[{
    "pick", " ", "out", " ", "the", " ", "\"\<or\>\"", " ", "pieces"}], ",", 
    " ", 
    RowBox[{
    "simplify", " ", "into", " ", "format", " ", "that", " ", "can", " ", 
     "be", " ", "called", " ", "by", " ", "AlgorithmSet"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"FormulaConvert", "[", "decisionProb_", "]"}], " ", ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "decisionProbInCNF", ",", "decisionProbStr", ",", " ", "problemList", 
        ",", " ", "returnList", ",", " ", "returnListElement", ",", " ", 
        "polynomialList", ",", " ", "normalizeList", ",", " ", "polyStr1", 
        ",", " ", "polyStr2", ",", "i", ",", " ", "strLen", ",", " ", 
        "returnListSignAsgmtElt", ",", " ", "returnListSignAsgmt"}], "}"}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"Put", " ", "into", " ", "CNF"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"decisionProbInCNF", " ", "=", " ", 
        RowBox[{"BooleanConvert", "[", 
         RowBox[{"decisionProb", ",", " ", "\"\<CNF\>\""}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Surprisingly", ",", " ", 
         RowBox[{"this", " ", "can", " ", "happen"}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"decisionProbInCNF", " ", "\[Equal]", " ", "True"}], ",", 
         " ", 
         RowBox[{"Return", "[", "2", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"decisionProbInCNF", " ", "\[Equal]", " ", "False"}], ",", 
         " ", 
         RowBox[{"Return", "[", "0", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "Make", " ", "it", " ", "a", " ", "string", " ", "so", " ", "we", " ",
          "can", " ", "parse"}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"decisionProbStr", " ", "=", " ", 
        RowBox[{"ToString", "[", 
         RowBox[{"decisionProbInCNF", ",", " ", "InputForm"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"problemList", " ", "=", " ", 
        RowBox[{"StringSplit", "[", 
         RowBox[{"decisionProbStr", ",", " ", "\"\<&&\>\""}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"returnList", " ", "=", " ", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"returnListSignAsgmt", " ", "=", " ", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", 
          RowBox[{"Length", "[", "problemList", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"polynomialList", " ", "=", " ", 
           RowBox[{"StringSplit", "[", 
            RowBox[{
             RowBox[{"problemList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], ",", " ", "\"\<||\>\""}], 
            "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"returnListSignAsgmtElt", " ", "=", " ", 
           RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"returnListElement", " ", "=", " ", 
           RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"j", " ", "=", " ", "1"}], ",", " ", 
            RowBox[{"j", "\[LessEqual]", " ", 
             RowBox[{"Length", "[", "polynomialList", "]"}]}], ",", " ", 
            RowBox[{"j", "++"}], ",", " ", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
             "We", " ", "might", " ", "need", " ", "to", " ", "delete", " ", 
              "extra", " ", 
              RowBox[{"(", ",", " ", ")"}]}], "*)"}], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"polynomialList", "[", 
               RowBox[{"[", "j", "]"}], "]"}], " ", "=", " ", 
              RowBox[{"StringDelete", "[", 
               RowBox[{
                RowBox[{"polynomialList", "[", 
                 RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\< \>\""}], 
               "]"}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"strLen", " ", "=", " ", 
              RowBox[{"StringLength", "[", 
               RowBox[{"polynomialList", "[", 
                RowBox[{"[", "j", "]"}], "]"}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"StringCount", "[", 
                 RowBox[{
                  RowBox[{"polynomialList", "[", 
                   RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<(\>\""}], 
                 "]"}], " ", ">", " ", 
                RowBox[{"StringCount", "[", 
                 RowBox[{
                  RowBox[{"polynomialList", "[", 
                   RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<)\>\""}], 
                 "]"}]}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"polynomialList", "[", 
                  RowBox[{"[", "j", "]"}], "]"}], " ", "=", " ", 
                 RowBox[{"StringTake", "[", 
                  RowBox[{
                   RowBox[{"polynomialList", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], ",", " ", 
                   RowBox[{"{", 
                    RowBox[{"2", ",", "strLen"}], "}"}]}], "]"}]}], ";"}]}], 
              "]"}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"StringCount", "[", 
                 RowBox[{
                  RowBox[{"polynomialList", "[", 
                   RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<)\>\""}], 
                 "]"}], " ", ">", " ", 
                RowBox[{"StringCount", "[", 
                 RowBox[{
                  RowBox[{"polynomialList", "[", 
                   RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<(\>\""}], 
                 "]"}]}], ",", 
               RowBox[{
                RowBox[{
                 RowBox[{"polynomialList", "[", 
                  RowBox[{"[", "j", "]"}], "]"}], " ", "=", " ", 
                 RowBox[{"StringTake", "[", 
                  RowBox[{
                   RowBox[{"polynomialList", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], ",", " ", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", " ", 
                    RowBox[{"strLen", "-", "1"}]}], "}"}]}], "]"}]}], ";"}]}],
               "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{"Take", " ", "care", " ", "of"}], " ", "\[NotEqual]"}],
               " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"StringContainsQ", "[", 
                RowBox[{
                 RowBox[{"polynomialList", "[", 
                  RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<!=\>\""}], 
                "]"}], ",", " ", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"normalizeList", " ", "=", " ", 
                 RowBox[{"StringSplit", "[", 
                  RowBox[{
                   RowBox[{"polynomialList", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<!=\>\""}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"polyStr1", " ", "=", " ", 
                 RowBox[{"StringJoin", "[", 
                  RowBox[{
                   RowBox[{"normalizeList", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", "\"\<-(\>\"", 
                   ",", " ", 
                   RowBox[{"normalizeList", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", " ", "\"\<)\>\""}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"returnListElement", "  ", "=", " ", 
                 RowBox[{"Append", "[", 
                  RowBox[{"returnListElement", ",", " ", 
                   RowBox[{"Simplify", "[", 
                    RowBox[{"ToExpression", "[", "polyStr1", "]"}], "]"}]}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"returnListSignAsgmtElt", "=", " ", 
                 RowBox[{"Append", "[", 
                  RowBox[{"returnListSignAsgmtElt", ",", " ", "\"\<>\>\""}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"polyStr2", " ", "=", " ", 
                 RowBox[{"StringJoin", "[", 
                  RowBox[{
                   RowBox[{"normalizeList", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", " ", "\"\<-(\>\"", 
                   ",", " ", 
                   RowBox[{"normalizeList", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", "\"\<)\>\""}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"returnListElement", "  ", "=", " ", 
                 RowBox[{"Append", "[", 
                  RowBox[{"returnListElement", ",", " ", 
                   RowBox[{"Simplify", "[", 
                    RowBox[{"ToExpression", "[", "polyStr2", "]"}], "]"}]}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"returnListSignAsgmtElt", " ", "=", " ", 
                 RowBox[{"Append", "[", 
                  RowBox[{"returnListSignAsgmtElt", ",", " ", "\"\<>\>\""}], 
                  "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{"Take", " ", "care", " ", "of"}], " ", ">"}], " ", 
              "*)"}], "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"StringContainsQ", "[", 
                 RowBox[{
                  RowBox[{"polynomialList", "[", 
                   RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<>\>\""}], 
                 "]"}], " ", "&&", " ", 
                RowBox[{"!", 
                 RowBox[{"StringContainsQ", "[", 
                  RowBox[{
                   RowBox[{"polynomialList", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<>=\>\""}], 
                  "]"}]}]}], " ", ",", " ", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"normalizeList", " ", "=", " ", 
                 RowBox[{"StringSplit", "[", 
                  RowBox[{
                   RowBox[{"polynomialList", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<>\>\""}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"polyStr1", " ", "=", " ", 
                 RowBox[{"StringJoin", "[", 
                  RowBox[{
                   RowBox[{"normalizeList", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", "\"\<-(\>\"", 
                   ",", " ", 
                   RowBox[{"normalizeList", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", " ", "\"\<)\>\""}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"returnListElement", "  ", "=", " ", 
                 RowBox[{"Append", "[", 
                  RowBox[{"returnListElement", ",", " ", 
                   RowBox[{"Simplify", "[", 
                    RowBox[{"ToExpression", "[", "polyStr1", "]"}], "]"}]}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"returnListSignAsgmtElt", "=", " ", 
                 RowBox[{"Append", "[", 
                  RowBox[{"returnListSignAsgmtElt", ",", " ", "\"\<>\>\""}], 
                  "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{"Take", " ", "care", " ", "of"}], " ", "<"}], " ", 
              "*)"}], "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{
                RowBox[{"StringContainsQ", "[", 
                 RowBox[{
                  RowBox[{"polynomialList", "[", 
                   RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<<\>\""}], 
                 "]"}], " ", "&&", " ", 
                RowBox[{"!", 
                 RowBox[{"StringContainsQ", "[", 
                  RowBox[{
                   RowBox[{"polynomialList", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<<=\>\""}], 
                  "]"}]}]}], ",", " ", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"normalizeList", " ", "=", " ", 
                 RowBox[{"StringSplit", "[", 
                  RowBox[{
                   RowBox[{"polynomialList", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<<\>\""}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"polyStr1", " ", "=", " ", 
                 RowBox[{"StringJoin", "[", 
                  RowBox[{
                   RowBox[{"normalizeList", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", " ", "\"\<-(\>\"", 
                   ",", " ", 
                   RowBox[{"normalizeList", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", "\"\<)\>\""}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"returnListElement", "  ", "=", " ", 
                 RowBox[{"Append", "[", 
                  RowBox[{"returnListElement", ",", " ", 
                   RowBox[{"Simplify", "[", 
                    RowBox[{"ToExpression", "[", "polyStr1", "]"}], "]"}]}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"returnListSignAsgmtElt", "=", " ", 
                 RowBox[{"Append", "[", 
                  RowBox[{"returnListSignAsgmtElt", ",", " ", "\"\<>\>\""}], 
                  "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{"Take", " ", "care", " ", "of"}], " ", 
               "\[LessEqual]"}], " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"StringContainsQ", "[", 
                RowBox[{
                 RowBox[{"polynomialList", "[", 
                  RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<<=\>\""}], 
                "]"}], ",", " ", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"normalizeList", " ", "=", " ", 
                 RowBox[{"StringSplit", "[", 
                  RowBox[{
                   RowBox[{"polynomialList", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<<=\>\""}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"polyStr1", " ", "=", " ", 
                 RowBox[{"StringJoin", "[", 
                  RowBox[{
                   RowBox[{"normalizeList", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", " ", "\"\<-(\>\"", 
                   ",", " ", 
                   RowBox[{"normalizeList", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", "\"\<)\>\""}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"returnListElement", "  ", "=", " ", 
                 RowBox[{"Append", "[", 
                  RowBox[{"returnListElement", ",", " ", 
                   RowBox[{"Simplify", "[", 
                    RowBox[{"ToExpression", "[", "polyStr1", "]"}], "]"}]}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"returnListSignAsgmtElt", " ", "=", " ", 
                 RowBox[{"Append", "[", 
                  RowBox[{"returnListSignAsgmtElt", ",", " ", "\"\<>=\>\""}], 
                  "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{"Take", " ", "care", " ", "of"}], " ", ">="}], " ", 
              "*)"}], "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"StringContainsQ", "[", 
                RowBox[{
                 RowBox[{"polynomialList", "[", 
                  RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<>=\>\""}], 
                "]"}], ",", " ", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"normalizeList", " ", "=", " ", 
                 RowBox[{"StringSplit", "[", 
                  RowBox[{
                   RowBox[{"polynomialList", "[", 
                    RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<>=\>\""}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"polyStr1", " ", "=", " ", 
                 RowBox[{"StringJoin", "[", 
                  RowBox[{
                   RowBox[{"normalizeList", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", " ", "\"\<-(\>\"", 
                   ",", " ", 
                   RowBox[{"normalizeList", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], " ", ",", " ", 
                   "\"\<)\>\""}], "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"returnListElement", "  ", "=", " ", 
                 RowBox[{"Append", "[", 
                  RowBox[{"returnListElement", ",", " ", 
                   RowBox[{"Simplify", "[", 
                    RowBox[{"ToExpression", "[", "polyStr1", "]"}], "]"}]}], 
                  "]"}]}], ";", "\[IndentingNewLine]", 
                RowBox[{"returnListSignAsgmtElt", " ", "=", " ", 
                 RowBox[{"Append", "[", 
                  RowBox[{"returnListSignAsgmtElt", ",", " ", "\"\<>=\>\""}], 
                  "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{"We", " ", "do", " ", "not", " ", "handle"}], " ", 
               "\[Equal]", " ", 
               RowBox[{"in", " ", "our", " ", "heuristics"}]}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"StringContainsQ", "[", 
                RowBox[{
                 RowBox[{"polynomialList", "[", 
                  RowBox[{"[", "j", "]"}], "]"}], ",", " ", "\"\<==\>\""}], 
                "]"}], ",", " ", "\[IndentingNewLine]", 
               RowBox[{"Return", "[", "Null", "]"}]}], "\[IndentingNewLine]", 
              "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"returnList", " ", "=", " ", 
           RowBox[{"Append", "[", 
            RowBox[{"returnList", ",", " ", "returnListElement"}], "]"}]}], 
          ";", "\[IndentingNewLine]", 
          RowBox[{"returnListSignAsgmt", " ", "=", " ", 
           RowBox[{"Append", "[", 
            RowBox[{
            "returnListSignAsgmt", ",", " ", "returnListSignAsgmtElt"}], 
            "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"Return", "[", 
        RowBox[{"{", 
         RowBox[{"returnList", ",", " ", "returnListSignAsgmt"}], "}"}], 
        "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.75313000768853*^9, 3.753130129560589*^9}, {
   3.753130166117041*^9, 3.7531302057622433`*^9}, {3.7531302748560343`*^9, 
   3.7531305480754557`*^9}, {3.753130583164494*^9, 3.753130595947135*^9}, {
   3.753130646752239*^9, 3.753130653373068*^9}, {3.7531307195056458`*^9, 
   3.753130720841826*^9}, {3.753130757623687*^9, 3.753130783737576*^9}, {
   3.7531309426246357`*^9, 3.7531309493491096`*^9}, {3.753130981609198*^9, 
   3.753130992274431*^9}, {3.753131031444765*^9, 3.753131033868984*^9}, {
   3.753131139376495*^9, 3.753131379486154*^9}, {3.75313146117585*^9, 
   3.753131467184205*^9}, {3.753131514049828*^9, 3.75313152699555*^9}, {
   3.753131588481642*^9, 3.753131663404248*^9}, {3.7531317051666307`*^9, 
   3.753131734948159*^9}, {3.753131766010487*^9, 3.753131831066309*^9}, {
   3.753131909666852*^9, 3.753132148880024*^9}, {3.75313219495638*^9, 
   3.753132235921308*^9}, {3.75313227413791*^9, 3.753132331558158*^9}, {
   3.753132734401045*^9, 3.7531327734672318`*^9}, {3.7531328424923277`*^9, 
   3.753132862154747*^9}, {3.753132898288247*^9, 3.753132934498322*^9}, {
   3.753133006902602*^9, 3.753133029528976*^9}, {3.753133095108004*^9, 
   3.75313311293664*^9}, {3.753133149861889*^9, 3.753133154959056*^9}, {
   3.7531332441154823`*^9, 3.753133274583449*^9}, {3.753133306274591*^9, 
   3.753133307799576*^9}, {3.7531333544279118`*^9, 3.753133362745491*^9}, {
   3.7531335251373177`*^9, 3.753133547311792*^9}, {3.753133669806396*^9, 
   3.753133711676025*^9}, {3.7531338926406813`*^9, 3.753134085287442*^9}, {
   3.75313415525321*^9, 3.7531342512074213`*^9}, {3.753134285293745*^9, 
   3.753134288508123*^9}, {3.753134330619565*^9, 3.753134333033204*^9}, {
   3.753134412442648*^9, 3.753134489835932*^9}, {3.753134522953781*^9, 
   3.7531345574816017`*^9}, {3.7531346201942596`*^9, 3.753134724546224*^9}, {
   3.753134756605113*^9, 3.753134960389048*^9}, {3.753135017163409*^9, 
   3.7531350496416187`*^9}, {3.753135086509377*^9, 3.7531350961633787`*^9}, {
   3.753135132738566*^9, 3.753135200751577*^9}, {3.7531352874338903`*^9, 
   3.7531352972256203`*^9}, {3.753135717838634*^9, 3.753135723655982*^9}, {
   3.753135754538059*^9, 3.7531358323810062`*^9}, {3.753135892376791*^9, 
   3.7531359425187597`*^9}, {3.753135987960989*^9, 3.7531360401705313`*^9}, 
   3.753136081701336*^9, {3.753136118000967*^9, 3.753136121922811*^9}, {
   3.753136158878091*^9, 3.7531361622250013`*^9}, {3.7531363038719053`*^9, 
   3.753136331456645*^9}, {3.753136362871037*^9, 3.753136379235209*^9}, {
   3.753139485107333*^9, 3.7531395035748367`*^9}, {3.7531395690631933`*^9, 
   3.753139582159212*^9}, {3.7531405080930567`*^9, 3.753140517739499*^9}, {
   3.7531517347341757`*^9, 3.75315173515744*^9}, {3.753156744666615*^9, 
   3.753156796574615*^9}, {3.753156851288579*^9, 3.753156885312505*^9}, {
   3.753157518471559*^9, 3.753157545485752*^9}, {3.753157594127059*^9, 
   3.753157594284223*^9}, {3.753157864399723*^9, 3.753157864702408*^9}},
 Background->GrayLevel[0.85],
 CellLabel->
  "In[1693]:=",ExpressionUUID->"ccafa8d0-6bf2-4c60-9f6a-608a9f17b69b"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Test", " ", "Cases"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"BooleanConvert", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x", " ", ">", " ", "0"}], " ", "&&", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"y", "^", "2"}], " ", "+", " ", 
         RowBox[{"5", "*", "y"}]}], " ", ">", " ", "0"}]}], " ", ")"}], " ", "||",
      " ", 
     RowBox[{
      RowBox[{"z", "*", "x"}], " ", ">", " ", "0"}]}], "]"}], 
   "\[IndentingNewLine]", 
   RowBox[{"FormulaConvert", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"x", " ", ">", " ", "0"}], " ", "&&", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"y", "^", "2"}], " ", "+", " ", 
         RowBox[{"5", "*", "y"}]}], " ", ">", " ", "0"}]}], " ", ")"}], " ", "||",
      " ", 
     RowBox[{
      RowBox[{"z", "*", "x"}], " ", ">", " ", "0"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.753130174136104*^9, 3.753130189733533*^9}, 
   3.753130550017169*^9, {3.7531306167091923`*^9, 3.7531306333810577`*^9}, 
   3.753138551451529*^9, {3.753139444253683*^9, 3.7531394748761053`*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3287]:=",ExpressionUUID->"076596a0-bf76-4d42-bacf-85e506d0537a"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"x", ">", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"5", " ", "y"}], "+", 
      SuperscriptBox["y", "2"]}], ">", "0"}]}], ")"}], "||", 
  RowBox[{
   RowBox[{"x", " ", "z"}], ">", "0"}]}]], "Output",
 CellChangeTimes->{{3.753130535360015*^9, 3.753130552342341*^9}, 
   3.753130599200142*^9, {3.753130633782218*^9, 3.753130657405036*^9}, 
   3.7531307265358343`*^9, 3.75313078736889*^9, 3.7531312849415493`*^9, 
   3.753131338064003*^9, 3.7531318367443733`*^9, {3.7531319154453993`*^9, 
   3.753131933090919*^9}, 3.753132336701778*^9, 3.7531328666026917`*^9, 
   3.753132908470128*^9, 3.753132938688242*^9, {3.753133017103559*^9, 
   3.7531330355125523`*^9}, 3.753133119294867*^9, 3.7531331591623583`*^9, 
   3.753133277784234*^9, 3.753133311794869*^9, 3.753133690847886*^9, 
   3.7531340893900557`*^9, 3.753134162067243*^9, {3.7531342427671337`*^9, 
   3.7531342549323072`*^9}, 3.7531342999715433`*^9, 3.753134966834077*^9, 
   3.7531350542939663`*^9, 3.753135101551579*^9, {3.753135148312766*^9, 
   3.753135172686924*^9}, 3.753135206503995*^9, 3.7531353050526876`*^9, 
   3.753135730349453*^9, 3.753135841215982*^9, 3.753135896151887*^9, {
   3.7531359291086483`*^9, 3.753135951740552*^9}, 3.753138554085814*^9, 
   3.753139476977522*^9, 3.753139510642952*^9, 3.75315155684258*^9, 
   3.753151773368916*^9, 3.7531568984148617`*^9, 3.753163143979903*^9, 
   3.753165535320691*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3287]=",ExpressionUUID->"4d34cd75-a0e2-4f4a-949d-cd70c22874c7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"x", " ", "z"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"y", " ", 
        RowBox[{"(", 
         RowBox[{"5", "+", "y"}], ")"}]}], ",", 
       RowBox[{"x", " ", "z"}]}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\<\">\"\>", ",", "\<\">\"\>"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.753130535360015*^9, 3.753130552342341*^9}, 
   3.753130599200142*^9, {3.753130633782218*^9, 3.753130657405036*^9}, 
   3.7531307265358343`*^9, 3.75313078736889*^9, 3.7531312849415493`*^9, 
   3.753131338064003*^9, 3.7531318367443733`*^9, {3.7531319154453993`*^9, 
   3.753131933090919*^9}, 3.753132336701778*^9, 3.7531328666026917`*^9, 
   3.753132908470128*^9, 3.753132938688242*^9, {3.753133017103559*^9, 
   3.7531330355125523`*^9}, 3.753133119294867*^9, 3.7531331591623583`*^9, 
   3.753133277784234*^9, 3.753133311794869*^9, 3.753133690847886*^9, 
   3.7531340893900557`*^9, 3.753134162067243*^9, {3.7531342427671337`*^9, 
   3.7531342549323072`*^9}, 3.7531342999715433`*^9, 3.753134966834077*^9, 
   3.7531350542939663`*^9, 3.753135101551579*^9, {3.753135148312766*^9, 
   3.753135172686924*^9}, 3.753135206503995*^9, 3.7531353050526876`*^9, 
   3.753135730349453*^9, 3.753135841215982*^9, 3.753135896151887*^9, {
   3.7531359291086483`*^9, 3.753135951740552*^9}, 3.753138554085814*^9, 
   3.753139476977522*^9, 3.753139510642952*^9, 3.75315155684258*^9, 
   3.753151773368916*^9, 3.7531568984148617`*^9, 3.753163143979903*^9, 
   3.7531655353425303`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3288]=",ExpressionUUID->"01a2739d-c3f4-4844-a5b3-f344fb65d173"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"BooleanConvert", "[", 
  RowBox[{"Not", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"v3", "*", "v7"}], "+", 
      RowBox[{"v1", "*", "v5"}], "-", "v4"}], "\[Equal]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"v3", "*", "v8"}], "+", 
      RowBox[{"v2", "*", "v6"}], "-", "v4"}], "\[Equal]", "0"}], "&&", 
    RowBox[{
     RowBox[{"v5", "-", "1"}], "\[Equal]", "0"}], "&&", 
    RowBox[{
     RowBox[{"v6", "-", "1"}], "\[Equal]", "0"}], "&&", 
    RowBox[{"v7", "<", "0"}], "&&", 
    RowBox[{"v8", ">", "0"}], "&&", 
    RowBox[{"v4", ">", "0"}]}], "]"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"FormulaConvert", "[", 
  RowBox[{"Not", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"v3", "*", "v7"}], "+", 
      RowBox[{"v1", "*", "v5"}], "-", "v4"}], "\[Equal]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"v3", "*", "v8"}], "+", 
      RowBox[{"v2", "*", "v6"}], "-", "v4"}], "\[Equal]", "0"}], "&&", 
    RowBox[{
     RowBox[{"v5", "-", "1"}], "\[Equal]", "0"}], "&&", 
    RowBox[{
     RowBox[{"v6", "-", "1"}], "\[Equal]", "0"}], "&&", 
    RowBox[{"v7", "<", "0"}], "&&", 
    RowBox[{"v8", ">", "0"}], "&&", 
    RowBox[{"v4", ">", "0"}]}], "]"}], "]"}]}], "Input",
 CellChangeTimes->{{3.753130840613318*^9, 3.753130851068508*^9}, {
  3.7531395155237503`*^9, 3.75313951972217*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3289]:=",ExpressionUUID->"dc90296a-565b-42fb-8a9f-e9c88abe70f1"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"-", "1"}], "+", "v5"}], "\[NotEqual]", "0"}], "||", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "1"}], "+", "v6"}], "\[NotEqual]", "0"}], "||", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "v4"}], "+", 
    RowBox[{"v1", " ", "v5"}], "+", 
    RowBox[{"v3", " ", "v7"}]}], "\[NotEqual]", "0"}], "||", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "v4"}], "+", 
    RowBox[{"v2", " ", "v6"}], "+", 
    RowBox[{"v3", " ", "v8"}]}], "\[NotEqual]", "0"}], "||", 
  RowBox[{"v7", "\[GreaterEqual]", "0"}], "||", 
  RowBox[{"v4", "\[LessEqual]", "0"}], "||", 
  RowBox[{"v8", "\[LessEqual]", "0"}]}]], "Output",
 CellChangeTimes->{
  3.753130853470676*^9, 3.7531312926970587`*^9, {3.753131341101314*^9, 
   3.753131382205913*^9}, {3.7531319403718853`*^9, 3.7531319636985693`*^9}, 
   3.753132339811283*^9, 3.7531333213589783`*^9, 3.7531343405853577`*^9, {
   3.753134481169075*^9, 3.753134493098112*^9}, 3.753135955410708*^9, {
   3.753135999359445*^9, 3.753136044479775*^9}, 3.753136125066586*^9, 
   3.753136166772992*^9, 3.753136337516069*^9, {3.753136368166189*^9, 
   3.753136382637203*^9}, 3.753139520222807*^9, 3.753151559235105*^9, 
   3.7531517754863777`*^9, 3.753156889890101*^9, 3.753165537010605*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3289]=",ExpressionUUID->"4ea4a444-837b-4337-aff8-957a0ccf6de4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "v4"}], "+", 
       RowBox[{"v1", " ", "v5"}], "+", 
       RowBox[{"v3", " ", "v7"}]}], ",", 
      RowBox[{"v4", "-", 
       RowBox[{"v1", " ", "v5"}], "-", 
       RowBox[{"v3", " ", "v7"}]}], ",", 
      RowBox[{
       RowBox[{"-", "v4"}], "+", 
       RowBox[{"v2", " ", "v6"}], "+", 
       RowBox[{"v3", " ", "v8"}]}], ",", 
      RowBox[{"v4", "-", 
       RowBox[{"v2", " ", "v6"}], "-", 
       RowBox[{"v3", " ", "v8"}]}], ",", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "v5"}], ",", 
      RowBox[{"1", "-", "v5"}], ",", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "v6"}], ",", 
      RowBox[{"1", "-", "v6"}], ",", "v7", ",", 
      RowBox[{"-", "v8"}], ",", 
      RowBox[{"-", "v4"}]}], "}"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>", 
      ",", "\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>", 
      ",", "\<\">\"\>", ",", "\<\">=\"\>", ",", "\<\">=\"\>", 
      ",", "\<\">=\"\>"}], "}"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.753130853470676*^9, 3.7531312926970587`*^9, {3.753131341101314*^9, 
   3.753131382205913*^9}, {3.7531319403718853`*^9, 3.7531319636985693`*^9}, 
   3.753132339811283*^9, 3.7531333213589783`*^9, 3.7531343405853577`*^9, {
   3.753134481169075*^9, 3.753134493098112*^9}, 3.753135955410708*^9, {
   3.753135999359445*^9, 3.753136044479775*^9}, 3.753136125066586*^9, 
   3.753136166772992*^9, 3.753136337516069*^9, {3.753136368166189*^9, 
   3.753136382637203*^9}, 3.753139520222807*^9, 3.753151559235105*^9, 
   3.7531517754863777`*^9, 3.753156889890101*^9, 3.7531655370291767`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3290]=",ExpressionUUID->"67411bca-9af4-4fd3-ab72-96f5eacd4d0d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"BooleanConvert", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x", " ", "==", " ", "0"}], " ", "&&", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"y", "^", "2"}], " ", "+", " ", 
       RowBox[{"5", "*", "y"}]}], " ", ">", " ", "0"}]}], " ", ")"}], " ", "||",
    " ", 
   RowBox[{
    RowBox[{"z", "*", "x"}], " ", ">", " ", "0"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"FormulaConvert", "[", 
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"x", " ", "==", " ", "0"}], " ", "&&", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"y", "^", "2"}], " ", "+", " ", 
       RowBox[{"5", "*", "y"}]}], " ", ">", " ", "0"}]}], " ", ")"}], " ", "||",
    " ", 
   RowBox[{
    RowBox[{"z", "*", "x"}], " ", ">", " ", "0"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.753156837974155*^9, 3.7531568383606873`*^9}, {
  3.753156905975316*^9, 3.753156906201859*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3291]:=",ExpressionUUID->"a4d8e181-29c5-4f0f-a75f-2669d6a5c9b8"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"x", "\[Equal]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"5", " ", "y"}], "+", 
      SuperscriptBox["y", "2"]}], ">", "0"}]}], ")"}], "||", 
  RowBox[{
   RowBox[{"x", " ", "z"}], ">", "0"}]}]], "Output",
 CellChangeTimes->{{3.753156906735961*^9, 3.753156910980695*^9}, 
   3.753165539032866*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3291]=",ExpressionUUID->"a5b185e5-1464-4406-a79a-d9b124913113"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FormulaConvert", "[", 
  RowBox[{"Not", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"nuscore2dollarskuscore2", "-", "N"}], "\[LessEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], 
      RowBox[{"(", 
       RowBox[{"xuscore2dollarskuscore2", "-", 
        RowBox[{"nuscore2dollarskuscore2", "^", "3"}]}], ")"}]}], "\[Equal]", 
     "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], 
      RowBox[{"(", 
       RowBox[{"yuscore2dollarskuscore2", "-", 
        RowBox[{"3", "*", 
         RowBox[{"nuscore2dollarskuscore2", "^", "2"}]}], "-", 
        RowBox[{"3", "*", "nuscore2dollarskuscore2"}], "-", "1"}], ")"}]}], 
     "\[Equal]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], 
      RowBox[{"(", 
       RowBox[{"zuscore2dollarskuscore2", "-", 
        RowBox[{"6", "*", "nuscore2dollarskuscore2"}], "-", "6"}], ")"}]}], 
     "\[Equal]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], 
      RowBox[{"(", 
       RowBox[{"zuscore2dollarskuscore2", "-", 
        RowBox[{"6", "*", "nuscore2dollarskuscore2"}], "-", "6"}], ")"}]}], 
     "\[NotEqual]", "0"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.753157478996976*^9, 3.753157502359015*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3293]:=",ExpressionUUID->"18dfe7f0-a27c-4a75-a513-001f2b74d274"],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{{3.753157489709587*^9, 3.753157502704921*^9}, {
   3.753157555589007*^9, 3.753157601090313*^9}, 3.753157788099812*^9, 
   3.753157879613304*^9, 3.753163148607194*^9, 3.7531655412225857`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3293]=",ExpressionUUID->"62a0a5bb-144e-4cbd-b0e3-b0946559e7cb"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Designed", " ", "to", " ", "actually", " ", "run", " ", "the", " ", 
    "first", " ", "and", " ", "second", " ", "set", " ", "of", " ", 
    "benchmarks"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"FormulaCallHeuristics", "[", "decisionProb_", "]"}], " ", ":=", 
    " ", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "evalList", ",", " ", "i", ",", " ", "evalListPolys", ",", " ", 
        "evalListSignAsgmts"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"FormulaConvert", "[", "decisionProb", "]"}], " ", 
          "\[Equal]", " ", "2"}], ",", " ", 
         RowBox[{"Return", "[", "2", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"FormulaConvert", "[", "decisionProb", "]"}], " ", 
          "\[Equal]", " ", "0"}], ",", " ", 
         RowBox[{"Return", "[", "0", "]"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"evalList", " ", "=", " ", 
        RowBox[{"FormulaConvert", "[", "decisionProb", "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"We", " ", 
          RowBox[{"can", "'"}], "t", " ", "run", " ", "our", " ", 
          "heuristics", " ", "if", " ", "we", " ", "had"}], " ", "\[Equal]", 
         " ", 
         RowBox[{"in", " ", "the", " ", "formula"}]}], " ", "*)"}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"evalList", " ", "\[Equal]", " ", "Null"}], ",", " ", 
         RowBox[{
          RowBox[{"Print", "[", "\"\<Had ==, terminating\>\"", "]"}], ";", 
          RowBox[{"Return", "[", "1", "]"}]}]}], "]"}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"Otherwise", ",", " ", 
         RowBox[{"keep", " ", 
          RowBox[{"going", "!"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"evalListPolys", " ", "=", " ", 
        RowBox[{"evalList", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"evalListSignAsgmts", " ", "=", " ", 
        RowBox[{"evalList", "[", 
         RowBox[{"[", "2", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"Because", " ", 
          RowBox[{"we", "'"}], "ve", " ", "split", " ", "the", " ", "CNF", 
          " ", "apart", " ", "by", " ", "the", " ", "ANDS"}], ",", " ", 
         RowBox[{
         "if", " ", "any", " ", "clause", " ", "returns", " ", "false"}], ",",
          " ", 
         RowBox[{"return", " ", "false"}]}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", 
          RowBox[{"Length", "[", "evalListPolys", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"AlgorithmSet", "[", 
              RowBox[{
               RowBox[{"evalListPolys", "[", 
                RowBox[{"[", "i", "]"}], "]"}], ",", " ", 
               RowBox[{"evalListSignAsgmts", "[", 
                RowBox[{"[", "i", "]"}], "]"}]}], "]"}], " ", "\[Equal]", " ",
              "0"}], ",", " ", 
            RowBox[{"Return", "[", "0", "]"}]}], "]"}], ";"}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "1", "]"}], ";"}]}], "]"}]}], ";"}]}]], "Input",\

 CellChangeTimes->{{3.7531552332676697`*^9, 3.7531553762834*^9}, {
  3.7531554392555933`*^9, 3.753155490455688*^9}, {3.753155536027236*^9, 
  3.753155660973139*^9}, {3.7531557158179483`*^9, 3.75315579860483*^9}, {
  3.7531569297045937`*^9, 3.753156957092078*^9}, {3.7531569915270033`*^9, 
  3.7531570195301867`*^9}, {3.753157110371502*^9, 3.753157117086235*^9}, {
  3.753157828814652*^9, 3.753157844207877*^9}, {3.753157886517272*^9, 
  3.753157891622991*^9}},
 Background->GrayLevel[0.85],
 CellLabel->
  "In[1695]:=",ExpressionUUID->"24e0e55c-0ba5-49fd-a3d7-175cc07da14a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FormulaCallHeuristics", "[", 
  RowBox[{"Not", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"nuscore2dollarskuscore2", "-", "N"}], "\[LessEqual]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], 
      RowBox[{"(", 
       RowBox[{"xuscore2dollarskuscore2", "-", 
        RowBox[{"nuscore2dollarskuscore2", "^", "3"}]}], ")"}]}], "\[Equal]", 
     "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], 
      RowBox[{"(", 
       RowBox[{"yuscore2dollarskuscore2", "-", 
        RowBox[{"3", "*", 
         RowBox[{"nuscore2dollarskuscore2", "^", "2"}]}], "-", 
        RowBox[{"3", "*", "nuscore2dollarskuscore2"}], "-", "1"}], ")"}]}], 
     "\[Equal]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], 
      RowBox[{"(", 
       RowBox[{"zuscore2dollarskuscore2", "-", 
        RowBox[{"6", "*", "nuscore2dollarskuscore2"}], "-", "6"}], ")"}]}], 
     "\[Equal]", "0"}], "&&", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], 
      RowBox[{"(", 
       RowBox[{"zuscore2dollarskuscore2", "-", 
        RowBox[{"6", "*", "nuscore2dollarskuscore2"}], "-", "6"}], ")"}]}], 
     "\[NotEqual]", "0"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.753157807302637*^9, 3.753157811181486*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3294]:=",ExpressionUUID->"228a3c90-2ff0-4ae0-8aad-1c273a0b4c22"],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{
  3.75315781194449*^9, {3.7531578944352217`*^9, 3.7531579045127153`*^9}, 
   3.7531655438470097`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3294]=",ExpressionUUID->"67de80dd-2941-4d9c-8ee0-5388f6f86cec"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{"Test", " ", "Case"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"FormulaCallHeuristics", "[", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"x", " ", ">", " ", "0"}], " ", "&&", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"y", "^", "2"}], " ", "+", " ", 
        RowBox[{"5", "*", "y"}]}], " ", ">", " ", "0"}]}], " ", ")"}], " ", "||",
     " ", 
    RowBox[{
     RowBox[{"z", "*", "x"}], " ", ">", " ", "0"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.753155686276144*^9, 3.753155690490864*^9}, {
  3.753155972176943*^9, 3.753155978011479*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3295]:=",ExpressionUUID->"2d043491-67b5-41ec-9590-e83254d3eba0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`x, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753163155523753*^9, 3.753165545496491*^9},
 CellLabel->
  "During evaluation of \
In[3295]:=",ExpressionUUID->"f14d6338-b0e6-4c82-ac98-7a4d5bdc9dc0"],

Cell[BoxData["0"], "Output",
 CellChangeTimes->{{3.753155692298376*^9, 3.753155800650962*^9}, 
   3.753155833859398*^9, {3.753157012388006*^9, 3.753157021423147*^9}, 
   3.753163155537714*^9, 3.7531655455176687`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3295]=",ExpressionUUID->"3ba3a6bb-cb22-4880-9d36-85dfc91238c8"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FormulaCallHeuristics", "[", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"x", " ", "==", " ", "0"}], "  ", "||", " ", 
    RowBox[{"x", " ", ">", " ", "0"}]}], ")"}], "]"}]], "Input",
 CellChangeTimes->{{3.7531569647143717`*^9, 3.753156982121789*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3296]:=",ExpressionUUID->"8e2bf6d8-d21c-428e-8c7e-ee3630c6f4a0"],

Cell[BoxData["\<\"Had ==, terminating\"\>"], "Print",
 CellChangeTimes->{3.7531571202891083`*^9, 3.7531631680735493`*^9, 
  3.75316554768113*^9},
 CellLabel->
  "During evaluation of \
In[3296]:=",ExpressionUUID->"fbe93493-f121-4af7-a783-2ba5a241047d"],

Cell[BoxData["1"], "Output",
 CellChangeTimes->{{3.753156982630251*^9, 3.753157022732419*^9}, 
   3.7531571203039703`*^9, 3.753163168092778*^9, 3.7531655476970987`*^9},
 CellLabel->
  "Out[3296]=",ExpressionUUID->"277ff67b-5344-4a06-93cc-de6aa43d2760"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Benchmark Generation and Testing", "Section",
 CellChangeTimes->{{3.753115586952291*^9, 3.753115591324052*^9}, {
  3.75315242612149*^9, 
  3.753152427329584*^9}},ExpressionUUID->"304874bb-f745-4256-941a-\
ca6fe7f33ef1"],

Cell[CellGroupData[{

Cell["\<\
We generate a set of benchmarks by generating polynomials in \
GenerateTestCases.\
\>", "Subsection",
 CellChangeTimes->{{3.7531524377063503`*^9, 
  3.753152488554247*^9}},ExpressionUUID->"2635a156-6810-41fc-97f4-\
8325ebb5c6fe"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "To", " ", "generate", " ", "the", " ", "third", " ", "set", " ", "of", 
    " ", "benchmarks"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"GenerateTestCases", "[", 
     RowBox[{
     "numPolysRange_", ",", " ", "degreeRange_", ",", " ", 
      "coefficientRange_", ",", "numTermsRange_", ",", " ", "varList_"}], 
     "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
       "polyList", ",", " ", "i", ",", "j", ",", " ", "k", ",", " ", "degree",
         ",", " ", "numPolys", ",", " ", "coeff", ",", " ", "newTerm", ",", 
        " ", "numVars", ",", " ", "randomPoly", ",", " ", "u", ",", " ", "v", 
        ",", " ", "w", ",", " ", "x", ",", " ", "y", ",", " ", "z", ",", " ", 
        "signAssignmentList"}], "}"}], ",", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"polyList", " ", "=", " ", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"signAssignmentList", " ", "=", " ", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"numPolys", " ", "=", " ", 
        RowBox[{"RandomInteger", "[", 
         RowBox[{"{", 
          RowBox[{"1", ",", " ", "numPolysRange"}], "}"}], "]"}]}], ";", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"For", " ", "these"}], ",", " ", 
         RowBox[{
          RowBox[{"we", "'"}], "ll", " ", "test", " ", "the", " ", "strict", 
          " ", "fragment"}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"For", "[", " ", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", "numPolys"}], ",", " ", 
         RowBox[{"i", "++"}], ",", " ", 
         RowBox[{
          RowBox[{"signAssignmentList", " ", "=", " ", 
           RowBox[{"Append", "[", 
            RowBox[{"signAssignmentList", ",", " ", "\"\<>\>\""}], "]"}]}], 
          ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"numVars", " ", "=", " ", 
        RowBox[{"Length", "[", "varList", "]"}]}], ";", "\[IndentingNewLine]",
        "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "<=", " ", "numPolys"}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"randomPoly", " ", "=", " ", "0"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"randomPoly", " ", "=", " ", "0"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"For", "[", 
           RowBox[{
            RowBox[{"j", " ", "=", " ", "1"}], ",", " ", 
            RowBox[{"j", " ", "\[LessEqual]", " ", "numTermsRange"}], ",", 
            " ", 
            RowBox[{"j", "++"}], ",", "\[IndentingNewLine]", "\t", 
            RowBox[{
             RowBox[{"coeff", " ", "=", " ", 
              RowBox[{"RandomInteger", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "coefficientRange"}], ",", " ", 
                 "coefficientRange"}], "}"}], "]"}]}], ";", 
             "\[IndentingNewLine]", "\t", 
             RowBox[{"newTerm", " ", "=", " ", "coeff"}], ";", 
             "\[IndentingNewLine]", "\t", 
             RowBox[{"For", "[", 
              RowBox[{
               RowBox[{"k", " ", "=", " ", "1"}], ",", " ", 
               RowBox[{"k", "\[LessEqual]", " ", "numVars"}], ",", " ", 
               RowBox[{"k", "++"}], ",", "\[IndentingNewLine]", "\t", 
               RowBox[{
                RowBox[{"degree", " ", "=", " ", 
                 RowBox[{"RandomInteger", "[", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "degreeRange"}], "}"}], "]"}]}], ";", 
                "\[IndentingNewLine]", "\t", 
                RowBox[{"newTerm", "*=", " ", 
                 RowBox[{
                  RowBox[{"varList", "[", 
                   RowBox[{"[", "k", "]"}], "]"}], "^", "degree"}]}]}]}], 
              "\[IndentingNewLine]", "\t", "]"}], ";", "\[IndentingNewLine]", 
             "\t", 
             RowBox[{"randomPoly", " ", "=", " ", 
              RowBox[{"randomPoly", " ", "+", "newTerm"}]}], ";"}]}], 
           "\[IndentingNewLine]", " ", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"polyList", " ", "=", " ", 
           RowBox[{"Append", "[", 
            RowBox[{"polyList", ",", " ", 
             RowBox[{"Expand", "[", 
              RowBox[{"Simplify", "[", "randomPoly", "]"}], "]"}]}], "]"}]}], 
          ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"Return", "[", 
        RowBox[{"{", 
         RowBox[{"polyList", ",", " ", "signAssignmentList"}], "}"}], "]"}], 
       ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{
  3.753115596648383*^9, {3.753120536729801*^9, 3.753120605930941*^9}, {
   3.75312063809168*^9, 3.753120644391837*^9}, {3.753120699278965*^9, 
   3.7531209020904627`*^9}, {3.7531209404199257`*^9, 3.753121001731052*^9}, {
   3.753121043739767*^9, 3.7531211118892717`*^9}, {3.753122222983156*^9, 
   3.753122233864346*^9}, {3.7531518298533573`*^9, 3.753151897494751*^9}},
 Background->GrayLevel[0.85],
 CellLabel->
  "In[328]:=",ExpressionUUID->"58231657-6491-4e73-a35a-56a1f0a7ca81"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "So", " ", "that", " ", "we", " ", "can", " ", "directly", " ", "compare", 
    " ", "the", " ", "timing", " ", "of", " ", "our", " ", "heuristics", " ", 
    "to", " ", "the", " ", "timing", " ", "of", " ", "Resolve"}], " ", "*)"}],
   "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ReformattingModule", "[", 
    RowBox[{"polyList_", ",", " ", "varList_"}], "]"}], " ", ":=", " ", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"BooleanFormula", ",", " ", "i"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"BooleanFormula", "  ", "=", " ", 
       RowBox[{
        RowBox[{"polyList", "[", 
         RowBox[{"[", "1", "]"}], "]"}], " ", ">", " ", "0"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"For", "[", 
       RowBox[{
        RowBox[{"i", " ", "=", " ", "2"}], ",", " ", 
        RowBox[{"i", " ", "\[LessEqual]", " ", 
         RowBox[{"Length", "[", "polyList", "]"}]}], ",", " ", 
        RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"BooleanFormula", " ", "=", " ", 
          RowBox[{"(", 
           RowBox[{"BooleanFormula", " ", "||", " ", 
            RowBox[{
             RowBox[{"polyList", "[", 
              RowBox[{"[", "i", "]"}], "]"}], " ", ">", " ", "0"}]}], ")"}]}],
          ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Return", "[", 
       RowBox[{"Timing", "[", 
        RowBox[{"Resolve", "[", 
         RowBox[{
          RowBox[{"ForAll", "[", 
           RowBox[{"varList", ",", " ", "BooleanFormula"}], "]"}], ",", " ", 
          "Reals"}], "]"}], "]"}], "]"}], ";"}]}], "\[IndentingNewLine]", 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.753152917520629*^9, 3.753153015062694*^9}, {
  3.7531530513035593`*^9, 3.753153090148897*^9}, {3.753153231542858*^9, 
  3.753153268478992*^9}, {3.753153317097604*^9, 3.753153322523498*^9}, {
  3.7531533611056137`*^9, 3.753153365442205*^9}, {3.753153407437244*^9, 
  3.753153433282089*^9}, {3.753153465904646*^9, 3.753153906590622*^9}},
 Background->GrayLevel[
  0.85],ExpressionUUID->"e26cc0b3-8264-48a6-8e4c-6b690dbfb1fc"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"Test", " ", "Case"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"ReformattingModule", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"-", "34"}], "*", "x"}], "+", 
       RowBox[{"117", "*", 
        RowBox[{"x", "^", "3"}]}], "-", 
       RowBox[{"15", "*", 
        RowBox[{"x", "^", "6"}]}], "+", 
       RowBox[{"28", "*", 
        RowBox[{"x", "^", "7"}]}]}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"-", "46"}], "*", "x"}], "+", 
       RowBox[{"77", "*", 
        RowBox[{"x", "^", "4"}]}], "-", 
       RowBox[{"14", "*", 
        RowBox[{"x", "^", "6"}]}], "+", 
       RowBox[{"69", "*", 
        RowBox[{"x", "^", "8"}]}]}]}], "}"}], ",", " ", 
    RowBox[{"{", "x", "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.7531532769811087`*^9, 3.75315330435681*^9}, {
  3.753153865883298*^9, 3.7531538677998123`*^9}, {3.753153916062562*^9, 
  3.753153920601324*^9}},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "In[3297]:=",ExpressionUUID->"6fb0c527-fb78-40b0-8abb-ea65ace83645"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.039292`", ",", "False"}], "}"}]], "Output",
 CellChangeTimes->{
  3.753153821353551*^9, {3.753153868210209*^9, 3.7531538828277693`*^9}, 
   3.753153932666819*^9, 3.7531655527461567`*^9},
 Background->RGBColor[0.94, 0.91, 0.88],
 CellLabel->
  "Out[3297]=",ExpressionUUID->"0b4fdb59-c223-4932-9f0a-625caf666929"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Parameters", " ", "for", " ", "GenerateTestCases", " ", "can", " ", "be", 
    " ", "tweaked", " ", "as", " ", "desired"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"TestingModule", " ", ":=", " ", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"testList", ",", " ", "i", ",", " ", "testElement"}], "}"}], 
      ",", " ", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"testList", " ", "=", " ", 
        RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", "10"}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"testList", " ", "=", " ", 
           RowBox[{"Append", "[", 
            RowBox[{"testList", ",", 
             RowBox[{"GenerateTestCases", "[", 
              RowBox[{"4", ",", " ", "8", ",", "100", ",", "6", ",", " ", 
               RowBox[{"{", "x", "}"}]}], "]"}]}], "]"}]}], ";"}]}], " ", 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", "10"}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"testList", " ", "=", " ", 
           RowBox[{"Append", "[", 
            RowBox[{"testList", ",", 
             RowBox[{"GenerateTestCases", "[", 
              RowBox[{"2", ",", " ", "3", ",", "10", ",", "3", ",", " ", 
               RowBox[{"{", 
                RowBox[{
                "v", ",", " ", "w", ",", " ", "x", ",", " ", "y", ",", " ", 
                 "z"}], "}"}]}], "]"}]}], "]"}]}], ";"}]}], " ", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", "10"}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"testList", " ", "=", " ", 
           RowBox[{"Append", "[", 
            RowBox[{"testList", ",", 
             RowBox[{"GenerateTestCases", "[", 
              RowBox[{"5", ",", " ", "12", ",", "10", ",", "6", ",", " ", 
               RowBox[{"{", 
                RowBox[{"x", ",", " ", "y"}], "}"}]}], "]"}]}], "]"}]}], 
          ";"}]}], " ", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", "10"}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"testList", " ", "=", " ", 
           RowBox[{"Append", "[", 
            RowBox[{"testList", ",", 
             RowBox[{"GenerateTestCases", "[", 
              RowBox[{"5", ",", " ", "120", ",", "100", ",", "6", ",", " ", 
               RowBox[{"{", 
                RowBox[{"x", ",", " ", "y"}], "}"}]}], "]"}]}], "]"}]}], 
          ";"}]}], " ", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"For", "[", 
        RowBox[{
         RowBox[{"i", " ", "=", " ", "1"}], ",", " ", 
         RowBox[{"i", " ", "\[LessEqual]", " ", 
          RowBox[{"Length", "[", "testList", "]"}]}], ",", " ", 
         RowBox[{"i", "++"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"testElement", " ", "=", " ", 
           RowBox[{"testList", "[", 
            RowBox[{"[", "i", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{"testList", "[", 
            RowBox[{"[", "i", "]"}], "]"}], "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{"Timing", "[", 
            RowBox[{"AlgorithmSet", "[", 
             RowBox[{
              RowBox[{"testElement", "[", 
               RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
              RowBox[{"testElement", "[", 
               RowBox[{"[", "2", "]"}], "]"}]}], "]"}], "]"}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{"ReformattingModule", "[", 
            RowBox[{
             RowBox[{"testElement", "[", 
              RowBox[{"[", "1", "]"}], "]"}], ",", " ", 
             RowBox[{"AllVariables", "[", 
              RowBox[{"testElement", "[", 
               RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "]"}], "]"}], ";"}]}],
         "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
     "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.753152099849312*^9, 3.753152258688139*^9}, {
   3.7531523293615723`*^9, 3.753152362412273*^9}, {3.753152526725523*^9, 
   3.75315255289675*^9}, {3.753152705397106*^9, 3.753152711753264*^9}, 
   3.7531530942980547`*^9, {3.753153951155779*^9, 3.7531539785873327`*^9}, {
   3.753154239816523*^9, 3.753154247742618*^9}, {3.75315479826681*^9, 
   3.753154808167397*^9}},
 Background->GrayLevel[
  0.85],ExpressionUUID->"2214e809-7e6b-433f-a2a7-37570e68ceb8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Output", " ", "should", " ", "be", " ", "read", " ", "in", " ", "groups", 
    " ", "of", " ", "3", " ", "lines", " ", "at", " ", "a", " ", 
    RowBox[{"time", ".", "  ", "First"}], " ", "line", " ", "is", " ", "the", 
    " ", "original", " ", 
    RowBox[{"problem", ".", "  ", "The"}], " ", "second", " ", "line", " ", 
    "is", " ", "the", " ", "timing", " ", "of", " ", "our", " ", "method", 
    " ", "and", " ", "what", " ", "result", " ", "it", " ", "produced", " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
       "where", " ", "0", " ", "is", " ", "\"\<definitely false\>\""}], ",", 
       " ", 
       RowBox[{"1", " ", "is", " ", "\"\<inconclusive\>\""}], ",", " ", 
       RowBox[{"and", " ", "2", " ", "is", " ", "\"\<definitely true\>\""}]}],
       ")"}], ".", "  ", "The"}], " ", "third", " ", "line", " ", "is", " ", 
    "the", " ", "timing", " ", "of", " ", 
    RowBox[{"Resolve", "[", 
     RowBox[{"ForAll", "[", 
      RowBox[{"variables", ",", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"f_", "1"}], " ", ">", " ", "0"}], " ", "||", " ", 
           RowBox[{
            RowBox[{"f_", "2"}], " ", ">", " ", "0"}], " ", "||"}], " ", 
          "..."}], " ", "||", " ", 
         RowBox[{"f_k", " ", ">", " ", "0"}]}], ")"}]}], "]"}], "]"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", "TestingModule"}]], "Input",
 CellChangeTimes->{{3.753153109360194*^9, 3.753153110547308*^9}, {
  3.753154672539364*^9, 3.753154768910049*^9}},
 Background->RGBColor[0.94, 0.88, 0.94],
 CellLabel->
  "In[3298]:=",ExpressionUUID->"d66b0b03-1e55-4de2-8077-e493204218a6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"42", "+", 
      RowBox[{"73", " ", 
       SuperscriptBox["x", "5"]}], "-", 
      RowBox[{"13", " ", 
       SuperscriptBox["x", "7"]}]}], ",", 
     RowBox[{
      RowBox[{"-", "59"}], "-", 
      RowBox[{"32", " ", "x"}], "-", 
      RowBox[{"10", " ", 
       SuperscriptBox["x", "3"]}], "+", 
      RowBox[{"94", " ", 
       SuperscriptBox["x", "4"]}], "-", 
      RowBox[{"46", " ", 
       SuperscriptBox["x", "6"]}], "-", 
      RowBox[{"37", " ", 
       SuperscriptBox["x", "7"]}]}], ",", 
     RowBox[{"98", "+", 
      RowBox[{"63", " ", "x"}], "+", 
      RowBox[{"25", " ", 
       SuperscriptBox["x", "4"]}], "-", 
      RowBox[{"28", " ", 
       SuperscriptBox["x", "5"]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["x", "7"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], 
  "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165557917738*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"887a5ceb-27b4-4137-adf8-3df350c624b8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.014901`", ",", "1"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655579358063`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"d19d680f-bd60-47da-af79-230a40dde629"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.013506`", ",", "True"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165557951704*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"cb6a27ba-e83e-4993-91e8-910e1a74d162"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"1", "+", 
      RowBox[{"5", " ", 
       SuperscriptBox["x", "2"]}], "-", 
      RowBox[{"20", " ", 
       SuperscriptBox["x", "4"]}], "+", 
      RowBox[{"37", " ", 
       SuperscriptBox["x", "5"]}], "+", 
      RowBox[{"47", " ", 
       SuperscriptBox["x", "8"]}]}], ",", 
     RowBox[{"96", "-", 
      RowBox[{"61", " ", "x"}], "-", 
      RowBox[{"3", " ", 
       SuperscriptBox["x", "2"]}], "+", 
      RowBox[{"42", " ", 
       SuperscriptBox["x", "4"]}], "+", 
      RowBox[{"130", " ", 
       SuperscriptBox["x", "7"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "95"}], " ", 
       SuperscriptBox["x", "2"]}], "+", 
      RowBox[{"39", " ", 
       SuperscriptBox["x", "6"]}], "+", 
      RowBox[{"121", " ", 
       SuperscriptBox["x", "7"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "32"}], " ", "x"}], "+", 
      SuperscriptBox["x", "2"], "+", 
      RowBox[{"59", " ", 
       SuperscriptBox["x", "7"]}], "+", 
      RowBox[{"71", " ", 
       SuperscriptBox["x", "8"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>", 
     ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165557960075*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"bbca9102-ea7a-4473-8e53-c867be2fe180"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.019975`", ",", "1"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165557971251*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"48fc16f1-f82c-477b-aac7-fc50990299cf"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.011396`", ",", "True"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655579787817`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"ee24afc6-47a4-4082-867d-a21209066f97"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "45"}], "-", 
     RowBox[{"88", " ", 
      SuperscriptBox["x", "7"]}], "-", 
     RowBox[{"24", " ", 
      SuperscriptBox["x", "8"]}]}], "}"}], ",", 
   RowBox[{"{", "\<\">\"\>", "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165557985153*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"945c4ab7-2786-4318-baec-d9402bafcf03"],

Cell[BoxData["\<\"Witness: All variables are infty (i.e. set all variables \
equal and sufficiently large)\"\>"], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165557992639*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"092f7d7b-a5f7-4b42-b84c-f368ffdc648d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.002531`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558001912*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"9bd0cb5d-7dc6-460a-b66e-c2183a0e201a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.002989`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655580088177`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"320751eb-4a97-435c-ba5e-49bf69eedffe"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"10", "-", 
      RowBox[{"78", " ", "x"}], "-", 
      RowBox[{"10", " ", 
       SuperscriptBox["x", "3"]}], "-", 
      RowBox[{"98", " ", 
       SuperscriptBox["x", "6"]}], "+", 
      RowBox[{"5", " ", 
       SuperscriptBox["x", "8"]}]}], ",", 
     RowBox[{
      RowBox[{"-", "16"}], "+", 
      RowBox[{"13", " ", 
       SuperscriptBox["x", "2"]}], "-", 
      RowBox[{"97", " ", 
       SuperscriptBox["x", "3"]}], "-", 
      RowBox[{"24", " ", 
       SuperscriptBox["x", "5"]}], "-", 
      RowBox[{"40", " ", 
       SuperscriptBox["x", "6"]}], "-", 
      RowBox[{"60", " ", 
       SuperscriptBox["x", "8"]}]}], ",", 
     RowBox[{
      RowBox[{"-", "25"}], "+", 
      RowBox[{"43", " ", 
       SuperscriptBox["x", "2"]}], "+", 
      RowBox[{"24", " ", 
       SuperscriptBox["x", "4"]}], "-", 
      RowBox[{"62", " ", 
       SuperscriptBox["x", "6"]}], "-", 
      RowBox[{"29", " ", 
       SuperscriptBox["x", "7"]}], "+", 
      RowBox[{"87", " ", 
       SuperscriptBox["x", "8"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], 
  "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558016961*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"f4656869-e808-43b5-95a4-8ee2e00862a2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.017612`", ",", "1"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558024767*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"a77b1d8b-a19e-4967-a5e4-ba2c6bbdc093"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.009953`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655580302677`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"ee3a307b-459d-4e20-a378-177d959eea84"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"11", " ", "x"}], "-", 
      RowBox[{"44", " ", 
       SuperscriptBox["x", "3"]}], "-", 
      RowBox[{"23", " ", 
       SuperscriptBox["x", "4"]}]}], ",", 
     RowBox[{
      RowBox[{"-", "22"}], "+", 
      RowBox[{"40", " ", "x"}], "+", 
      RowBox[{"75", " ", 
       SuperscriptBox["x", "3"]}], "-", 
      RowBox[{"36", " ", 
       SuperscriptBox["x", "7"]}]}], ",", 
     RowBox[{
      RowBox[{"100", " ", "x"}], "-", 
      RowBox[{"22", " ", 
       SuperscriptBox["x", "3"]}], "+", 
      RowBox[{"60", " ", 
       SuperscriptBox["x", "4"]}], "+", 
      RowBox[{"65", " ", 
       SuperscriptBox["x", "6"]}], "-", 
      RowBox[{"64", " ", 
       SuperscriptBox["x", "7"]}], "+", 
      RowBox[{"75", " ", 
       SuperscriptBox["x", "8"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], 
  "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558035666*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"b2726c72-8ff3-4bb9-b2e0-dc96cf71c0a5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`x, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655580422993`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"5dc96bf1-a73e-4a20-8792-0e7e63a4c96f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.016233`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558047659*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"55638bbb-2d7f-446a-b619-357d77be1adf"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.010989`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655580526943`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"9a3cbdb7-e1c8-4847-9312-d1244509b19c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"99", " ", "x"}], "-", 
      RowBox[{"41", " ", 
       SuperscriptBox["x", "3"]}], "+", 
      RowBox[{"38", " ", 
       SuperscriptBox["x", "4"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "64"}], " ", "x"}], "+", 
      RowBox[{"70", " ", 
       SuperscriptBox["x", "2"]}], "+", 
      RowBox[{"88", " ", 
       SuperscriptBox["x", "3"]}], "-", 
      RowBox[{"90", " ", 
       SuperscriptBox["x", "6"]}], "-", 
      RowBox[{"10", " ", 
       SuperscriptBox["x", "8"]}]}], ",", 
     RowBox[{"94", "-", 
      RowBox[{"6", " ", "x"}], "+", 
      RowBox[{"48", " ", 
       SuperscriptBox["x", "3"]}], "+", 
      RowBox[{"14", " ", 
       SuperscriptBox["x", "4"]}], "-", 
      RowBox[{"69", " ", 
       SuperscriptBox["x", "7"]}], "-", 
      RowBox[{"19", " ", 
       SuperscriptBox["x", "8"]}]}], ",", 
     RowBox[{
      RowBox[{"38", " ", "x"}], "-", 
      RowBox[{"50", " ", 
       SuperscriptBox["x", "3"]}], "+", 
      RowBox[{"37", " ", 
       SuperscriptBox["x", "6"]}], "-", 
      RowBox[{"96", " ", 
       SuperscriptBox["x", "8"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>", 
     ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558058333*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"7419de11-cbae-4aed-ab62-4fa1f32d9124"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.021076`", ",", "1"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558065112*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"f62f19ed-5566-4fea-ba34-c608dfef14ae"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.016247`", ",", "True"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558069996*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"b188f2d9-ddbb-410c-86bc-c6f77a863cbb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"10", "-", 
      RowBox[{"83", " ", "x"}], "-", 
      RowBox[{"12", " ", 
       SuperscriptBox["x", "4"]}], "+", 
      RowBox[{"78", " ", 
       SuperscriptBox["x", "5"]}], "-", 
      RowBox[{"30", " ", 
       SuperscriptBox["x", "7"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "26"}], " ", "x"}], "-", 
      RowBox[{"63", " ", 
       SuperscriptBox["x", "2"]}], "+", 
      RowBox[{"72", " ", 
       SuperscriptBox["x", "3"]}], "+", 
      RowBox[{"17", " ", 
       SuperscriptBox["x", "4"]}], "-", 
      RowBox[{"47", " ", 
       SuperscriptBox["x", "5"]}], "+", 
      RowBox[{"32", " ", 
       SuperscriptBox["x", "6"]}]}], ",", 
     RowBox[{"10", "+", 
      RowBox[{"90", " ", "x"}], "-", 
      RowBox[{"88", " ", 
       SuperscriptBox["x", "2"]}], "+", 
      RowBox[{"35", " ", 
       SuperscriptBox["x", "4"]}], "-", 
      RowBox[{"94", " ", 
       SuperscriptBox["x", "7"]}]}], ",", 
     RowBox[{
      RowBox[{"-", "23"}], "+", 
      RowBox[{"41", " ", 
       SuperscriptBox["x", "2"]}], "-", 
      RowBox[{"28", " ", 
       SuperscriptBox["x", "3"]}], "-", 
      RowBox[{"73", " ", 
       SuperscriptBox["x", "4"]}], "+", 
      RowBox[{"11", " ", 
       SuperscriptBox["x", "6"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>", 
     ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558075684*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"27832121-d69f-4142-b814-5650205ecb5e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.020034`", ",", "1"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558080756*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"c5ed6fc6-e8ff-41ae-a8eb-b930db8f000a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.011569`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.75316555819867*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"cf1f30fb-96a5-4534-99a9-0caac69eaa43"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "45"}], " ", "x"}], "+", 
      RowBox[{"11", " ", 
       SuperscriptBox["x", "2"]}], "+", 
      RowBox[{"20", " ", 
       SuperscriptBox["x", "3"]}], "+", 
      RowBox[{"7", " ", 
       SuperscriptBox["x", "4"]}], "+", 
      RowBox[{"100", " ", 
       SuperscriptBox["x", "5"]}], "+", 
      RowBox[{"30", " ", 
       SuperscriptBox["x", "8"]}]}], ",", 
     RowBox[{
      RowBox[{"-", "40"}], "-", 
      RowBox[{"31", " ", "x"}], "-", 
      RowBox[{"95", " ", 
       SuperscriptBox["x", "3"]}], "+", 
      RowBox[{"45", " ", 
       SuperscriptBox["x", "4"]}], "+", 
      RowBox[{"19", " ", 
       SuperscriptBox["x", "7"]}]}], ",", 
     RowBox[{
      RowBox[{"30", " ", 
       SuperscriptBox["x", "2"]}], "+", 
      RowBox[{"34", " ", 
       SuperscriptBox["x", "3"]}], "+", 
      RowBox[{"40", " ", 
       SuperscriptBox["x", "6"]}], "+", 
      RowBox[{"63", " ", 
       SuperscriptBox["x", "8"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], 
  "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558222686*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"7e6549ba-cc41-45fd-94bb-5b07ed805266"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`x, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.75316555822806*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"cda8e9ba-cc98-4081-ab88-17e73b988819"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.012252`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558233275*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"86d6738b-eb5c-4273-acb4-1b24f37ea0f4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.010712`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558238254*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"82ae89bd-7b9b-485b-b5c3-b74893e6e482"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "44"}], "-", 
      RowBox[{"22", " ", 
       SuperscriptBox["x", "2"]}], "+", 
      RowBox[{"54", " ", 
       SuperscriptBox["x", "4"]}], "+", 
      RowBox[{"33", " ", 
       SuperscriptBox["x", "8"]}]}], ",", 
     RowBox[{
      RowBox[{"87", " ", "x"}], "+", 
      RowBox[{"61", " ", 
       SuperscriptBox["x", "3"]}], "-", 
      RowBox[{"99", " ", 
       SuperscriptBox["x", "4"]}], "+", 
      RowBox[{"30", " ", 
       SuperscriptBox["x", "7"]}], "+", 
      RowBox[{"35", " ", 
       SuperscriptBox["x", "8"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655582428207`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"89f486ca-171a-4f7b-b0d4-208e9a831ab1"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`x, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558247571*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"ec62528e-a4b5-4a85-88cc-e1702241ecb5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.008243`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558252673*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"f446b149-ecf9-4e71-8077-bb04a8905525"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.004265`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655582574463`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"ad0d1d33-33fa-4645-9850-c695ad2eb323"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"29", " ", 
       SuperscriptBox["x", "2"]}], "-", 
      RowBox[{"77", " ", 
       SuperscriptBox["x", "3"]}], "+", 
      RowBox[{"128", " ", 
       SuperscriptBox["x", "6"]}]}], ",", 
     RowBox[{
      RowBox[{"-", "93"}], "+", 
      RowBox[{"9", " ", 
       SuperscriptBox["x", "3"]}], "-", 
      RowBox[{"42", " ", 
       SuperscriptBox["x", "4"]}], "+", 
      RowBox[{"185", " ", 
       SuperscriptBox["x", "6"]}], "+", 
      RowBox[{"22", " ", 
       SuperscriptBox["x", "7"]}]}], ",", 
     RowBox[{
      RowBox[{"25", " ", 
       SuperscriptBox["x", "2"]}], "+", 
      RowBox[{"78", " ", 
       SuperscriptBox["x", "5"]}], "-", 
      RowBox[{"9", " ", 
       SuperscriptBox["x", "6"]}], "+", 
      RowBox[{"73", " ", 
       SuperscriptBox["x", "7"]}], "-", 
      RowBox[{"56", " ", 
       SuperscriptBox["x", "8"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "26"}], " ", "x"}], "+", 
      RowBox[{"47", " ", 
       SuperscriptBox["x", "2"]}], "-", 
      RowBox[{"67", " ", 
       SuperscriptBox["x", "4"]}], "-", 
      RowBox[{"74", " ", 
       SuperscriptBox["x", "6"]}], "+", 
      RowBox[{"56", " ", 
       SuperscriptBox["x", "7"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["x", "8"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>", 
     ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558263504*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"68445f61-efac-4210-8804-f9c0b9efee8b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`x, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558270433*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"620fa93c-31c9-4936-8ba0-eef767bdc023"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.015375`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558275873*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"6ebfae7b-8133-4415-9926-34f55f7a21bd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.013022`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558280458*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"4846f7d3-74e6-4229-b32f-f15608c54bd0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "3"}], " ", "v", " ", 
       SuperscriptBox["w", "3"], " ", "y", " ", "z"}], "-", 
      RowBox[{
       SuperscriptBox["v", "2"], " ", 
       SuperscriptBox["w", "3"], " ", "x", " ", 
       SuperscriptBox["y", "3"], " ", 
       SuperscriptBox["z", "2"]}], "-", 
      RowBox[{"10", " ", "v", " ", 
       SuperscriptBox["w", "3"], " ", 
       SuperscriptBox["x", "2"], " ", "y", " ", 
       SuperscriptBox["z", "3"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "8"}], " ", 
       SuperscriptBox["v", "3"], " ", 
       SuperscriptBox["w", "3"], " ", 
       SuperscriptBox["x", "2"]}], "-", 
      RowBox[{
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "3"], " ", "z"}], "+", 
      RowBox[{"5", " ", 
       SuperscriptBox["y", "2"], " ", 
       SuperscriptBox["z", "2"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558285345*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"9357978c-29e5-43b9-b1fd-116095d0ae67"],

Cell[BoxData["\<\"Witness: All variables are infty (i.e. set all variables \
equal and sufficiently large)\"\>"], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558291072*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"6556ce15-a9d6-42d8-a0d2-d5495f918a2b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.007244`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558298184*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"c60d537e-83e4-4223-b662-d3601d5a48ea"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.02224`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655583054867`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"c5a8a20f-179c-47ff-b663-78eef270fe71"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "6"}], " ", 
       SuperscriptBox["x", "2"], " ", "y"}], "+", 
      RowBox[{"8", " ", 
       SuperscriptBox["v", "2"], " ", "w", " ", 
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["z", "3"]}], "-", 
      RowBox[{"10", " ", "v", " ", "x", " ", "y", " ", 
       SuperscriptBox["z", "3"]}]}], ",", 
     RowBox[{
      RowBox[{"2", " ", 
       SuperscriptBox["v", "3"], " ", 
       SuperscriptBox["w", "3"], " ", 
       SuperscriptBox["y", "2"], " ", "z"}], "-", 
      RowBox[{"10", " ", 
       SuperscriptBox["v", "2"], " ", 
       SuperscriptBox["w", "3"], " ", "x", " ", 
       SuperscriptBox["z", "2"]}], "-", 
      RowBox[{"9", " ", "w", " ", 
       SuperscriptBox["x", "2"], " ", "y", " ", 
       SuperscriptBox["z", "3"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655583125887`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"0e716f6b-637c-4183-9d73-db7cb6576ab4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "z", 
   "\[InvisibleSpace]", "\<\" is infty, all other vars 1\"\>"}],
  SequenceForm["Witness: ", $CellContext`z, " is infty, all other vars 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655583206778`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"35c93ecb-5397-49c2-8527-42bcf5593eab"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.022242`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558328271*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"8b9caea3-b0b6-4b9c-ab82-53d21f44088d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.041849`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655583352757`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"3079568e-db86-450c-9829-d687abea110e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       SuperscriptBox["v", "3"], " ", "w", " ", 
       SuperscriptBox["x", "3"], " ", "y"}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["v", "2"], " ", 
       SuperscriptBox["w", "3"], " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["z", "2"]}], "+", 
      RowBox[{"5", " ", 
       SuperscriptBox["v", "3"], " ", 
       SuperscriptBox["w", "3"], " ", 
       SuperscriptBox["z", "3"]}]}], ",", 
     RowBox[{
      RowBox[{"9", " ", 
       SuperscriptBox["v", "3"], " ", 
       SuperscriptBox["w", "3"], " ", "x", " ", 
       SuperscriptBox["y", "2"]}], "+", 
      RowBox[{"5", " ", 
       SuperscriptBox["v", "3"], " ", 
       SuperscriptBox["w", "2"], " ", "x", " ", "z"}], "+", 
      RowBox[{"9", " ", 
       SuperscriptBox["v", "3"], " ", 
       SuperscriptBox["w", "3"], " ", "x", " ", 
       SuperscriptBox["y", "3"], " ", 
       SuperscriptBox["z", "3"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558342157*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"cdff7f83-8a68-443c-be15-de4629f07a4c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "v", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`v, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558349195*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"d079d66d-a5c6-44a7-93f6-9e4975790f83"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.02006`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558355777*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"158452ee-da99-4a79-ac56-2c8a39c7e0d5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.01711`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558360491*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"4b234e61-33bb-4966-bc77-026b8953f60b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "7"}], " ", 
      SuperscriptBox["v", "2"], " ", 
      SuperscriptBox["w", "2"], " ", "x", " ", 
      SuperscriptBox["y", "2"]}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox["v", "2"], " ", 
      SuperscriptBox["y", "3"]}], "+", 
     RowBox[{"5", " ", 
      SuperscriptBox["w", "3"], " ", "x", " ", 
      SuperscriptBox["y", "2"], " ", "z"}]}], "}"}], ",", 
   RowBox[{"{", "\<\">\"\>", "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655583662767`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"88653ec9-e880-40ae-921f-b58034f0652d"],

Cell[BoxData["\<\"Witness: All variables are infty (i.e. set all variables \
equal and sufficiently large)\"\>"], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655583724117`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"4f19ff0b-18fa-4c25-a8c5-ac2d9ac4214d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.00247`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558377635*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"a63664c9-a447-4c2a-9475-398a88440a36"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.005797`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.75316555838317*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"ff1bc654-929e-44dd-aa0c-220aaada1dec"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       SuperscriptBox["v", "2"], " ", "w", " ", 
       SuperscriptBox["x", "2"], " ", "y"}], "-", 
      RowBox[{"6", " ", 
       SuperscriptBox["v", "3"], " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "3"], " ", 
       SuperscriptBox["z", "2"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", "v", " ", 
       SuperscriptBox["w", "3"], " ", 
       SuperscriptBox["x", "2"], " ", "y", " ", 
       SuperscriptBox["z", "2"]}], "-", 
      RowBox[{"3", " ", "v", " ", 
       SuperscriptBox["w", "2"], " ", 
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["y", "3"], " ", 
       SuperscriptBox["z", "3"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558389642*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"562e73df-6ea8-45e4-bf58-a74b763ff192"],

Cell[BoxData["\<\"Witness: All variables are infty (i.e. set all variables \
equal and sufficiently large)\"\>"], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558394685*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"9de5962b-6d52-4b0f-b3a6-f3224eccc6a1"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.006224`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558399686*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"479e3a4d-d86f-40e3-bcf5-dd6b45900ae3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.009513`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655584067297`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"dbe5ba42-57f7-4ad7-8f2e-d98609c28d8a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "6"}], " ", "v", " ", 
       SuperscriptBox["w", "3"], " ", 
       SuperscriptBox["x", "2"]}], "+", 
      RowBox[{"8", " ", 
       SuperscriptBox["v", "2"], " ", 
       SuperscriptBox["w", "3"], " ", "x", " ", 
       SuperscriptBox["y", "3"], " ", "z"}], "-", 
      RowBox[{"3", " ", "w", " ", "x", " ", 
       SuperscriptBox["y", "3"], " ", 
       SuperscriptBox["z", "3"]}]}], ",", 
     RowBox[{
      RowBox[{"5", " ", 
       SuperscriptBox["v", "2"], " ", 
       SuperscriptBox["w", "2"], " ", "y"}], "-", 
      RowBox[{"6", " ", 
       SuperscriptBox["v", "3"], " ", "x", " ", 
       SuperscriptBox["y", "2"], " ", 
       SuperscriptBox["z", "2"]}], "-", 
      RowBox[{"3", " ", "v", " ", 
       SuperscriptBox["w", "3"], " ", 
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["y", "2"], " ", 
       SuperscriptBox["z", "2"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558411899*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"2ad06014-1c2d-4823-93ee-1c242dbc6ae5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\" is infty, all other vars 1\"\>"}],
  SequenceForm["Witness: ", $CellContext`x, " is infty, all other vars 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558417733*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"72741426-6df9-4335-818b-ca59b517e169"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.020261`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.75316555842239*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"44e01ffd-6589-45f0-9afc-bff5a9afc26a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.062788`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558427537*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"9d1e2a8c-9553-423e-a61a-e8d219f956f3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"9", " ", 
      SuperscriptBox["v", "3"], " ", "w", " ", "x", " ", 
      SuperscriptBox["y", "2"]}], "-", 
     RowBox[{"3", " ", 
      SuperscriptBox["w", "3"], " ", 
      SuperscriptBox["y", "3"], " ", "z"}], "+", 
     RowBox[{"10", " ", 
      SuperscriptBox["v", "2"], " ", 
      SuperscriptBox["w", "3"], " ", 
      SuperscriptBox["y", "3"], " ", 
      SuperscriptBox["z", "2"]}]}], "}"}], ",", 
   RowBox[{"{", "\<\">\"\>", "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558432706*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"7fda7cf1-6956-4f1a-a39e-fd3632e2310f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "v", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`v, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558438044*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"38fe62c5-ae2e-4998-b4ac-e8573e5d9fe9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.011161`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558442981*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"1111f9a1-03a6-4a38-98c9-1a123e82acc6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.004401`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558447756*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"6e59007f-b0dd-4999-bc80-e9e4627d22b4"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "6"}], " ", 
       SuperscriptBox["v", "2"], " ", "y"}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["v", "3"], " ", "w", " ", 
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["y", "2"], " ", "z"}], "+", 
      RowBox[{"8", " ", 
       SuperscriptBox["v", "2"], " ", 
       SuperscriptBox["w", "3"], " ", "x", " ", 
       SuperscriptBox["y", "3"], " ", 
       SuperscriptBox["z", "3"]}]}], ",", 
     RowBox[{
      RowBox[{"10", " ", 
       SuperscriptBox["w", "3"], " ", 
       SuperscriptBox["x", "3"]}], "-", 
      RowBox[{"5", " ", 
       SuperscriptBox["v", "2"], " ", 
       SuperscriptBox["w", "3"], " ", 
       SuperscriptBox["x", "2"], " ", "y", " ", "z"}], "-", 
      RowBox[{"10", " ", "w", " ", 
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["y", "3"], " ", 
       SuperscriptBox["z", "3"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558452825*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"a4bbc343-5647-4905-9252-5935902583a3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "v", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`v, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558458148*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"afaf9c0c-194b-4004-a55d-4e3f5687fb42"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.028018`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165558462946*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"384db1fb-1aae-48af-96d3-8358e3a29c85"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"23.309858`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165582347796*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"8f96f1f4-ed36-4e3d-a6b8-bdcebfe6f7f6"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"2", " ", "v", " ", 
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["y", "2"]}], "+", 
      RowBox[{"8", " ", 
       SuperscriptBox["v", "3"], " ", "z"}], "+", 
      RowBox[{"9", " ", 
       SuperscriptBox["v", "3"], " ", "w", " ", "x", " ", 
       SuperscriptBox["z", "2"]}]}], ",", 
     RowBox[{
      RowBox[{"6", " ", 
       SuperscriptBox["v", "3"], " ", "x", " ", 
       SuperscriptBox["y", "2"], " ", "z"}], "-", 
      RowBox[{"6", " ", "v", " ", "x", " ", 
       SuperscriptBox["y", "3"], " ", 
       SuperscriptBox["z", "2"]}], "-", 
      RowBox[{"9", " ", 
       SuperscriptBox["v", "2"], " ", "w", " ", 
       SuperscriptBox["z", "3"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165582353237*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"73cc07e5-39ea-43e7-86d4-342f7114fb4c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "v", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`v, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165582378454*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"d0f64788-cec1-4563-a886-329542ddc0fd"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.018191`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165582402639*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"4c70fd2d-ebd0-4920-921b-8d3dbe1ed5f7"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.014513`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165582407625*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"8ad37c23-3a3e-4a4f-a4f8-f6d63368328c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       SuperscriptBox["v", "3"], " ", 
       SuperscriptBox["w", "2"], " ", 
       SuperscriptBox["y", "2"], " ", "z"}], "+", 
      RowBox[{"3", " ", "w", " ", "y", " ", 
       SuperscriptBox["z", "2"]}], "+", 
      RowBox[{
       SuperscriptBox["v", "2"], " ", 
       SuperscriptBox["w", "2"], " ", "x", " ", 
       SuperscriptBox["y", "3"], " ", 
       SuperscriptBox["z", "2"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "10"}], " ", 
       SuperscriptBox["v", "2"], " ", "w", " ", 
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["y", "2"], " ", 
       SuperscriptBox["z", "2"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["v", "2"], " ", "x", " ", 
       SuperscriptBox["y", "3"], " ", 
       SuperscriptBox["z", "2"]}], "+", 
      RowBox[{"6", " ", "v", " ", 
       SuperscriptBox["w", "3"], " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "3"], " ", 
       SuperscriptBox["z", "3"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165582413186*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"d367ff59-f768-4c87-8282-131d54877d5b"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "v", 
   "\[InvisibleSpace]", "\<\" is infty, all other vars 1\"\>"}],
  SequenceForm["Witness: ", $CellContext`v, " is infty, all other vars 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655824187183`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"f940bacc-baa3-4730-a793-75037c318ff2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.006863`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.75316558242402*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"e4a59ede-f49f-4c66-b8de-437f0371b478"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.017702`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165582428837*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"9c08a6f3-b60b-4703-af34-bc75ae4c9b74"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"4", "+", 
      RowBox[{
       SuperscriptBox["x", "4"], " ", "y"}], "+", 
      RowBox[{"7", " ", 
       SuperscriptBox["x", "6"], " ", 
       SuperscriptBox["y", "4"]}], "+", 
      RowBox[{"5", " ", 
       SuperscriptBox["x", "4"], " ", 
       SuperscriptBox["y", "5"]}], "+", 
      RowBox[{"10", " ", 
       SuperscriptBox["x", "12"], " ", 
       SuperscriptBox["y", "6"]}], "+", 
      RowBox[{"6", " ", 
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["y", "9"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "3"}], " ", 
       SuperscriptBox["x", "8"], " ", 
       SuperscriptBox["y", "3"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["x", "9"], " ", 
       SuperscriptBox["y", "3"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["x", "10"], " ", 
       SuperscriptBox["y", "6"]}], "-", 
      RowBox[{"6", " ", "x", " ", 
       SuperscriptBox["y", "9"]}], "-", 
      RowBox[{"9", " ", 
       SuperscriptBox["x", "8"], " ", 
       SuperscriptBox["y", "9"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["x", "5"], " ", 
       SuperscriptBox["y", "10"]}]}], ",", 
     RowBox[{
      RowBox[{"7", " ", 
       SuperscriptBox["x", "7"], " ", "y"}], "+", 
      RowBox[{
       SuperscriptBox["x", "8"], " ", 
       SuperscriptBox["y", "3"]}], "+", 
      RowBox[{"6", " ", 
       SuperscriptBox["x", "11"], " ", 
       SuperscriptBox["y", "4"]}], "+", 
      RowBox[{
       SuperscriptBox["x", "4"], " ", 
       SuperscriptBox["y", "11"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "4"}], " ", 
       SuperscriptBox["x", "8"], " ", 
       SuperscriptBox["y", "2"]}], "-", 
      RowBox[{"10", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "5"]}], "+", 
      RowBox[{"9", " ", 
       SuperscriptBox["x", "11"], " ", 
       SuperscriptBox["y", "8"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["y", "11"]}], "-", 
      RowBox[{
       SuperscriptBox["x", "10"], " ", 
       SuperscriptBox["y", "11"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>", 
     ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165582434412*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"24099161-a349-4430-98c5-06a31402d0c9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.049008`", ",", "1"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165582460266*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"034feb47-8173-40ee-a35b-ea652723db71"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.130119`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655836051407`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"60cec45f-6eb3-46bd-adf8-2d815f719177"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["x", "4"], " ", 
       SuperscriptBox["y", "3"]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "4"]}], "-", 
      RowBox[{"10", " ", 
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["y", "6"]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "10"]}], "-", 
      RowBox[{"5", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "11"]}], "-", 
      RowBox[{"8", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "12"]}]}], ",", 
     RowBox[{
      RowBox[{"5", " ", 
       SuperscriptBox["x", "3"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["y", "2"]}], "-", 
      RowBox[{"6", " ", 
       SuperscriptBox["x", "5"], " ", 
       SuperscriptBox["y", "6"]}], "-", 
      RowBox[{"9", " ", 
       SuperscriptBox["x", "12"], " ", 
       SuperscriptBox["y", "6"]}], "+", 
      RowBox[{"2", " ", "x", " ", 
       SuperscriptBox["y", "11"]}]}], ",", 
     RowBox[{
      RowBox[{"9", " ", 
       SuperscriptBox["x", "9"], " ", 
       SuperscriptBox["y", "2"]}], "-", 
      RowBox[{
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "5"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["x", "12"], " ", 
       SuperscriptBox["y", "5"]}], "+", 
      RowBox[{
       SuperscriptBox["x", "11"], " ", 
       SuperscriptBox["y", "9"]}], "-", 
      RowBox[{
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["y", "10"]}], "-", 
      RowBox[{"5", " ", 
       SuperscriptBox["x", "4"], " ", 
       SuperscriptBox["y", "10"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], 
  "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655836112823`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"b725b191-b4f2-4231-be0e-3a9f95eb80db"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`x, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165583634371*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"962245da-e53a-41b8-8504-e71c58f5e934"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.03322`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165583639382*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"6ed2bfd7-4e29-4e5e-8353-ba1d938209b8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.696504`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165584349043*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"eb3a9556-103f-4791-b357-7d01c0d993ca"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "4"}], " ", 
       SuperscriptBox["x", "8"], " ", "y"}], "+", 
      RowBox[{
       SuperscriptBox["x", "4"], " ", 
       SuperscriptBox["y", "6"]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["x", "9"], " ", 
       SuperscriptBox["y", "6"]}], "+", 
      RowBox[{"5", " ", 
       SuperscriptBox["y", "10"]}], "+", 
      RowBox[{"9", " ", 
       SuperscriptBox["x", "12"], " ", 
       SuperscriptBox["y", "12"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "2"}], " ", 
       SuperscriptBox["x", "10"], " ", 
       SuperscriptBox["y", "4"]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["y", "5"]}], "+", 
      RowBox[{"10", " ", 
       SuperscriptBox["x", "9"], " ", 
       SuperscriptBox["y", "7"]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["y", "10"]}], "-", 
      RowBox[{"3", " ", 
       SuperscriptBox["x", "9"], " ", 
       SuperscriptBox["y", "10"]}], "-", 
      RowBox[{"7", " ", 
       SuperscriptBox["y", "12"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165584355317*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"c944b1c6-1458-4e09-9e7e-e8f4df591ffd"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "y", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`y, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165584374896*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"27ee0249-c4ec-4d42-993a-95368ce00f37"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.026622`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655843925667`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"77e73bd1-9bb5-4004-8ceb-3bf779885e16"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.604673`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165584999116*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"2bc8e35e-d7e5-448a-9855-86ddca5c1427"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"8", " ", "x"}], "+", 
      RowBox[{"9", " ", 
       SuperscriptBox["x", "2"]}], "-", 
      RowBox[{"4", " ", "x", " ", "y"}], "-", 
      RowBox[{"7", " ", 
       SuperscriptBox["x", "3"], " ", "y"}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["y", "2"]}], "+", 
      RowBox[{"3", " ", "x", " ", 
       SuperscriptBox["y", "12"]}]}], ",", 
     RowBox[{"9", "-", 
      RowBox[{
       SuperscriptBox["x", "11"], " ", 
       SuperscriptBox["y", "5"]}], "-", 
      RowBox[{"5", " ", 
       SuperscriptBox["x", "12"], " ", 
       SuperscriptBox["y", "7"]}], "-", 
      RowBox[{"8", " ", 
       SuperscriptBox["x", "5"], " ", 
       SuperscriptBox["y", "11"]}], "-", 
      RowBox[{"6", " ", 
       SuperscriptBox["x", "12"], " ", 
       SuperscriptBox["y", "11"]}], "+", 
      RowBox[{"9", " ", 
       SuperscriptBox["x", "10"], " ", 
       SuperscriptBox["y", "12"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "10"}], " ", 
       SuperscriptBox["x", "5"]}], "-", 
      RowBox[{"7", " ", 
       SuperscriptBox["y", "5"]}], "+", 
      RowBox[{"6", " ", 
       SuperscriptBox["x", "10"], " ", 
       SuperscriptBox["y", "6"]}], "+", 
      RowBox[{"5", " ", 
       SuperscriptBox["x", "4"], " ", 
       SuperscriptBox["y", "8"]}], "-", 
      RowBox[{"x", " ", 
       SuperscriptBox["y", "9"]}], "+", 
      RowBox[{"8", " ", 
       SuperscriptBox["x", "5"], " ", 
       SuperscriptBox["y", "9"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>"}], "}"}]}], 
  "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655850050583`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"2989e6ba-0f9a-4986-9672-d92d326ada75"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.033655`", ",", "1"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655850282383`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"52653194-083b-4112-81ec-3a17e6d384f8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.088914`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165586131497*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"8cf1e545-8fe7-4de9-b5a0-e06233d85e06"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"8", " ", 
       SuperscriptBox["x", "5"], " ", "y"}], "-", 
      RowBox[{"4", " ", "x", " ", 
       SuperscriptBox["y", "2"]}], "-", 
      RowBox[{"2", " ", "x", " ", 
       SuperscriptBox["y", "4"]}], "-", 
      RowBox[{"9", " ", 
       SuperscriptBox["x", "7"], " ", 
       SuperscriptBox["y", "6"]}], "-", 
      RowBox[{
       SuperscriptBox["x", "11"], " ", 
       SuperscriptBox["y", "10"]}]}], ",", 
     RowBox[{
      RowBox[{"6", " ", 
       SuperscriptBox["x", "7"], " ", 
       SuperscriptBox["y", "2"]}], "+", 
      RowBox[{"5", " ", 
       SuperscriptBox["y", "4"]}], "+", 
      RowBox[{"6", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "5"]}], "+", 
      RowBox[{"9", " ", 
       SuperscriptBox["x", "4"], " ", 
       SuperscriptBox["y", "7"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["x", "7"], " ", 
       SuperscriptBox["y", "8"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["x", "8"], " ", 
       SuperscriptBox["y", "11"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "3"}], " ", 
       SuperscriptBox["y", "2"]}], "-", 
      RowBox[{"7", " ", 
       SuperscriptBox["x", "4"], " ", 
       SuperscriptBox["y", "2"]}], "-", 
      RowBox[{"14", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "6"]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["x", "10"], " ", 
       SuperscriptBox["y", "9"]}]}], ",", 
     RowBox[{
      RowBox[{"2", " ", 
       SuperscriptBox["x", "6"]}], "-", 
      RowBox[{"7", " ", 
       SuperscriptBox["x", "11"], " ", 
       SuperscriptBox["y", "2"]}], "+", 
      RowBox[{"x", " ", 
       SuperscriptBox["y", "3"]}], "+", 
      RowBox[{"5", " ", 
       SuperscriptBox["x", "6"], " ", 
       SuperscriptBox["y", "9"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["x", "4"], " ", 
       SuperscriptBox["y", "10"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["x", "10"], " ", 
       SuperscriptBox["y", "12"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>", 
     ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655861379547`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"5459e07c-7243-4bd0-b6fa-3037af1fa912"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.051439`", ",", "1"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655862408133`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"6d4dde24-7c57-4323-b2bb-b4a60ec8cadb"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.084196`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165587380568*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"790b0d3f-dc12-4b80-aec4-3a9536a3e05a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"4", " ", 
      SuperscriptBox["x", "9"], " ", 
      SuperscriptBox["y", "5"]}], "-", 
     RowBox[{"8", " ", 
      SuperscriptBox["x", "9"], " ", 
      SuperscriptBox["y", "7"]}], "-", 
     RowBox[{"6", " ", 
      SuperscriptBox["x", "10"], " ", 
      SuperscriptBox["y", "8"]}], "-", 
     RowBox[{"2", " ", "x", " ", 
      SuperscriptBox["y", "10"]}], "+", 
     RowBox[{"7", " ", 
      SuperscriptBox["x", "3"], " ", 
      SuperscriptBox["y", "11"]}], "-", 
     RowBox[{
      SuperscriptBox["x", "11"], " ", 
      SuperscriptBox["y", "11"]}]}], "}"}], ",", 
   RowBox[{"{", "\<\">\"\>", "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165587401043*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"25ad7ad7-1916-4625-93b4-44bfbde1d9f3"],

Cell[BoxData["\<\"Witness: All variables are infty (i.e. set all variables \
equal and sufficiently large)\"\>"], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165587406972*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"b6456ba6-396e-485f-a216-e7b35031a196"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.006446`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165587460251*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"5bb53bd7-bd66-46e2-a95c-59599871e961"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.083265`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655874656153`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"346c3adf-fe05-4846-8c42-f788ff38de98"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "3"}], " ", 
       SuperscriptBox["x", "5"]}], "-", 
      RowBox[{"8", " ", "x", " ", 
       SuperscriptBox["y", "3"]}], "+", 
      RowBox[{"7", " ", 
       SuperscriptBox["y", "7"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["y", "8"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["x", "10"], " ", 
       SuperscriptBox["y", "9"]}], "+", 
      RowBox[{"5", " ", 
       SuperscriptBox["x", "11"], " ", 
       SuperscriptBox["y", "12"]}]}], ",", 
     RowBox[{
      RowBox[{"2", " ", 
       SuperscriptBox["x", "2"]}], "+", 
      RowBox[{"6", " ", 
       SuperscriptBox["x", "7"], " ", 
       SuperscriptBox["y", "4"]}], "-", 
      RowBox[{"9", " ", 
       SuperscriptBox["x", "7"], " ", 
       SuperscriptBox["y", "8"]}], "+", 
      RowBox[{
       SuperscriptBox["x", "6"], " ", 
       SuperscriptBox["y", "10"]}], "-", 
      RowBox[{"9", " ", 
       SuperscriptBox["x", "5"], " ", 
       SuperscriptBox["y", "12"]}], "+", 
      RowBox[{"3", " ", 
       SuperscriptBox["x", "8"], " ", 
       SuperscriptBox["y", "12"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "6"}], " ", 
       SuperscriptBox["x", "12"]}], "-", 
      RowBox[{"9", " ", "y"}], "+", 
      RowBox[{"8", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "5"]}], "+", 
      RowBox[{"8", " ", "x", " ", 
       SuperscriptBox["y", "9"]}], "-", 
      RowBox[{"4", " ", "x", " ", 
       SuperscriptBox["y", "10"]}], "-", 
      RowBox[{"3", " ", 
       SuperscriptBox["x", "5"], " ", 
       SuperscriptBox["y", "11"]}]}], ",", 
     RowBox[{
      RowBox[{"10", " ", 
       SuperscriptBox["x", "10"]}], "+", 
      RowBox[{"8", " ", 
       SuperscriptBox["x", "12"], " ", 
       SuperscriptBox["y", "3"]}], "-", 
      RowBox[{"4", " ", 
       SuperscriptBox["x", "11"], " ", 
       SuperscriptBox["y", "6"]}], "-", 
      RowBox[{"6", " ", 
       SuperscriptBox["x", "12"], " ", 
       SuperscriptBox["y", "6"]}], "-", 
      RowBox[{
       SuperscriptBox["x", "10"], " ", 
       SuperscriptBox["y", "8"]}], "-", 
      RowBox[{"8", " ", 
       SuperscriptBox["x", "10"], " ", 
       SuperscriptBox["y", "11"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>", 
     ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.75316558747307*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"73f20447-865b-4dde-bb2e-a5f7d49c1848"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.046413`", ",", "1"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165587479134*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"8d9ca05e-528a-4d27-9488-6285f9c63d87"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.23824`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165589757539*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"49a6b54a-5b72-4a67-9934-015261374de2"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "6"}], " ", 
       SuperscriptBox["x", "4"]}], "-", 
      RowBox[{"6", " ", "y"}], "-", 
      RowBox[{"10", " ", 
       SuperscriptBox["x", "9"], " ", 
       SuperscriptBox["y", "7"]}], "-", 
      RowBox[{"2", " ", "x", " ", 
       SuperscriptBox["y", "12"]}], "-", 
      RowBox[{"5", " ", 
       SuperscriptBox["x", "8"], " ", 
       SuperscriptBox["y", "12"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "x"}], " ", 
       SuperscriptBox["y", "3"]}], "+", 
      RowBox[{"10", " ", 
       SuperscriptBox["x", "6"], " ", 
       SuperscriptBox["y", "3"]}], "+", 
      RowBox[{"2", " ", 
       SuperscriptBox["x", "2"], " ", 
       SuperscriptBox["y", "7"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["x", "8"], " ", 
       SuperscriptBox["y", "10"]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["x", "12"], " ", 
       SuperscriptBox["y", "11"]}], "+", 
      RowBox[{"4", " ", 
       SuperscriptBox["x", "9"], " ", 
       SuperscriptBox["y", "12"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "6"}], " ", 
       SuperscriptBox["x", "12"]}], "-", 
      RowBox[{"10", " ", 
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["y", "2"]}], "-", 
      RowBox[{"2", " ", 
       SuperscriptBox["y", "4"]}], "-", 
      RowBox[{"7", " ", 
       SuperscriptBox["x", "8"], " ", 
       SuperscriptBox["y", "7"]}], "+", 
      RowBox[{"10", " ", 
       SuperscriptBox["x", "3"], " ", 
       SuperscriptBox["y", "9"]}], "-", 
      RowBox[{"9", " ", 
       SuperscriptBox["x", "8"], " ", 
       SuperscriptBox["y", "11"]}]}], ",", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "8"}], " ", "x"}], "-", 
      RowBox[{"9", " ", 
       SuperscriptBox["x", "8"], " ", "y"}], "+", 
      RowBox[{"6", " ", 
       SuperscriptBox["x", "10"], " ", "y"}], "-", 
      RowBox[{"7", " ", 
       SuperscriptBox["x", "12"], " ", "y"}], "+", 
      RowBox[{"5", " ", 
       SuperscriptBox["x", "9"], " ", 
       SuperscriptBox["y", "7"]}], "-", 
      RowBox[{"7", " ", 
       SuperscriptBox["x", "10"], " ", 
       SuperscriptBox["y", "10"]}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\<\">\"\>", ",", "\<\">\"\>", ",", "\<\">\"\>", 
     ",", "\<\">\"\>"}], "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165589775897*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"e49641a4-07e5-4586-8a15-c2e925c53026"],

Cell[BoxData["\<\"Witness: All variables are infty (i.e. set all variables \
equal and sufficiently large)\"\>"], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655897817707`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"e9b44ed5-3658-4964-be0e-108b45612110"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.022066`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165589786858*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"842c0ab7-889f-43bf-a776-abca41bdccf8"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.523777`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655922969933`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"30880007-93e1-489b-bb8c-c5ca00d82e8d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "7"}], " ", 
      SuperscriptBox["x", "12"], " ", 
      SuperscriptBox["y", "6"]}], "+", 
     RowBox[{"8", " ", 
      SuperscriptBox["x", "5"], " ", 
      SuperscriptBox["y", "9"]}], "+", 
     RowBox[{"7", " ", 
      SuperscriptBox["x", "6"], " ", 
      SuperscriptBox["y", "11"]}], "+", 
     RowBox[{"3", " ", 
      SuperscriptBox["x", "7"], " ", 
      SuperscriptBox["y", "11"]}], "-", 
     RowBox[{"6", " ", 
      SuperscriptBox["x", "10"], " ", 
      SuperscriptBox["y", "12"]}]}], "}"}], ",", 
   RowBox[{"{", "\<\">\"\>", "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165592304591*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"46d26b2e-e373-45b5-8921-eb285eb50a54"],

Cell[BoxData["\<\"Witness: All variables are infty (i.e. set all variables \
equal and sufficiently large)\"\>"], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165592309408*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"271e0098-fe1d-4673-a957-17159cc2ec2d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.004203`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655923139963`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"dd0e669d-09db-47e3-abeb-06aa80b4d754"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.021177`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655923806667`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"b0963398-208b-42d9-90f2-081c931ec78b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "2"}], " ", 
      SuperscriptBox["x", "10"]}], "+", 
     RowBox[{"2", " ", 
      SuperscriptBox["x", "5"], " ", "y"}], "-", 
     RowBox[{"6", " ", "x", " ", 
      SuperscriptBox["y", "2"]}], "-", 
     RowBox[{"2", " ", 
      SuperscriptBox["x", "8"], " ", 
      SuperscriptBox["y", "3"]}], "-", 
     RowBox[{"8", " ", 
      SuperscriptBox["x", "12"], " ", 
      SuperscriptBox["y", "3"]}], "-", 
     RowBox[{"3", " ", 
      SuperscriptBox["x", "6"], " ", 
      SuperscriptBox["y", "10"]}]}], "}"}], ",", 
   RowBox[{"{", "\<\">\"\>", "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.7531655923976917`*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"4901d833-7156-4a5e-9dd9-a683e8275f85"],

Cell[BoxData["\<\"Witness: All variables are infty (i.e. set all variables \
equal and sufficiently large)\"\>"], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165592402372*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"a7e4a88c-fffd-441b-b6f8-3db5e4cabf30"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.006187`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165592407641*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"5ec445f6-bb63-40c8-9de2-10726e70e6ea"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.129251`", ",", "False"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165592460104*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"bc3d2a09-46ef-42bb-918a-095319cf11be"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"18", " ", 
      SuperscriptBox["x", "14"], " ", 
      SuperscriptBox["y", "41"]}], "+", 
     RowBox[{"43", " ", 
      SuperscriptBox["x", "56"], " ", 
      SuperscriptBox["y", "54"]}], "-", 
     RowBox[{"66", " ", 
      SuperscriptBox["x", "43"], " ", 
      SuperscriptBox["y", "63"]}], "+", 
     RowBox[{"90", " ", 
      SuperscriptBox["x", "40"], " ", 
      SuperscriptBox["y", "74"]}], "-", 
     RowBox[{"9", " ", 
      SuperscriptBox["x", "12"], " ", 
      SuperscriptBox["y", "76"]}], "+", 
     RowBox[{"18", " ", 
      SuperscriptBox["x", "54"], " ", 
      SuperscriptBox["y", "84"]}]}], "}"}], ",", 
   RowBox[{"{", "\<\">\"\>", "}"}]}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.75316559246532*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"3900818a-20e4-430e-9c0b-9033645a8592"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Witness: \"\>", "\[InvisibleSpace]", "x", 
   "\[InvisibleSpace]", "\<\" is 0, all other variables are 1\"\>"}],
  SequenceForm[
  "Witness: ", $CellContext`x, " is 0, all other variables are 1"],
  Editable->False]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.75316559248175*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"aa4b6b7d-f88c-4c9c-b5e9-059d275ca458"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.026055`", ",", "0"}], "}"}]], "Print",
 CellChangeTimes->{3.753164796695846*^9, 3.753165592487236*^9},
 CellLabel->
  "During evaluation of \
In[3298]:=",ExpressionUUID->"192249d8-d5a2-4cc5-91e9-9c9730d0978c"]
}, Open  ]],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{3.753154395313081*^9, 3.753154793451322*^9, 
  3.753163239245624*^9, 3.7531639207078257`*^9, 3.753164817133078*^9, 
  3.7531655947745323`*^9},
 CellLabel->
  "Out[3298]=",ExpressionUUID->"e63e5716-6053-4a7f-9444-0769a4af423d"]
}, Open  ]]
}, Open  ]],

Cell["\<\
To run the algorithms on queries from the first benchmark set, please use the \
code in \[OpenCurlyDoubleQuote]TarskiParse_FormulasForHeuristics.txt\
\[CloseCurlyDoubleQuote].  To compare Mathematica\[CloseCurlyQuote]s timing, \
please use the code in \[OpenCurlyDoubleQuote]TarskiParse_Formulas.txt\
\[CloseCurlyDoubleQuote].\
\>", "Subsection",
 CellChangeTimes->{{3.753165914864953*^9, 
  3.753165917108694*^9}},ExpressionUUID->"d5404c2d-46ad-4d92-b609-\
50663258df91"],

Cell["\<\
To run the algorithms on queries from the first benchmark set, please use the \
code in \[OpenCurlyDoubleQuote]TarskiParseEngland_FormulasForHeuristics.txt\
\[CloseCurlyDoubleQuote].  To compare Mathematica\[CloseCurlyQuote]s timing, \
please use the code in \[OpenCurlyDoubleQuote]TarskiParseEngland_Formulas.txt\
\[CloseCurlyDoubleQuote].\
\>", "Subsection",
 CellChangeTimes->{
  3.753165929632217*^9},ExpressionUUID->"0f8fe134-75ba-435f-85dc-\
3da05eaa36ab"]
}, Open  ]]
},
WindowSize->{808, 710},
WindowMargins->{{40, Automatic}, {Automatic, 0}},
FrontEndVersion->"11.3 for Mac OS X x86 (32-bit, 64-bit Kernel) (March 5, \
2018)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 1487, 24, 30, "Input",ExpressionUUID->"c6c9569f-523c-4502-aab1-b5e17bd4af93"],
Cell[CellGroupData[{
Cell[2070, 48, 169, 3, 67, "Section",ExpressionUUID->"73da1ffb-786b-4873-ae85-aa93422db4d5"],
Cell[2242, 53, 5128, 121, 593, "Input",ExpressionUUID->"42234e34-4281-4e5f-942b-2eea32f77a2b"],
Cell[7373, 176, 5453, 132, 467, "Input",ExpressionUUID->"f0e9f1b9-bd8f-4c9b-803f-7f5a8a153e67"],
Cell[12829, 310, 1013, 19, 110, "Input",ExpressionUUID->"b37b6d27-a336-4a0e-be93-bd0da57c1a8d"],
Cell[CellGroupData[{
Cell[13867, 333, 786, 19, 46, "Input",ExpressionUUID->"dfe71456-fe1a-4542-b985-677931b99d54"],
Cell[14656, 354, 641, 10, 50, "Output",ExpressionUUID->"9496bc22-3621-4a46-b4df-ee4f914b2d39"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15334, 369, 565, 15, 46, "Input",ExpressionUUID->"7f7789dd-e6f8-40d6-b043-cf31549c0cfc"],
Cell[15902, 386, 221, 3, 50, "Output",ExpressionUUID->"74748014-22e1-45e8-b48b-71099b03ccfd"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16160, 394, 1028, 26, 131, "Input",ExpressionUUID->"c03d8c25-be73-4169-aa1b-b92d876ba8b6"],
Cell[17191, 422, 282, 4, 50, "Output",ExpressionUUID->"784b97f3-40cd-40c7-b8d5-6ad8cdc1b799"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[17522, 432, 168, 3, 67, "Section",ExpressionUUID->"91303c72-3ec8-4974-83ad-4128180fff4e"],
Cell[CellGroupData[{
Cell[17715, 439, 548, 10, 135, "Subsection",ExpressionUUID->"e18eb558-c750-457e-9749-bb85041d23ed"],
Cell[CellGroupData[{
Cell[18288, 453, 162, 3, 45, "Subsubsection",ExpressionUUID->"4a0d087b-cc5b-41f5-aab7-55107a8c9666"],
Cell[18453, 458, 786, 21, 89, "Input",ExpressionUUID->"17029327-a032-43c5-ad2d-6f424510f684"],
Cell[CellGroupData[{
Cell[19264, 483, 1039, 27, 110, "Input",ExpressionUUID->"ec290281-6991-47a2-bef4-d1ae1abaaab1"],
Cell[20306, 512, 250, 5, 50, "Output",ExpressionUUID->"663bee42-97ef-4373-abe4-0ea16d1ad498"],
Cell[20559, 519, 218, 4, 50, "Output",ExpressionUUID->"b9e8ca0b-c4d7-49c7-8fca-e4089d42b0cd"],
Cell[20780, 525, 273, 6, 50, "Output",ExpressionUUID->"ecbb4092-fb97-44d1-b1ec-66beca3a31ba"]
}, Open  ]],
Cell[21068, 534, 1311, 33, 173, "Input",ExpressionUUID->"e5d6f4e0-102f-43b7-8d6b-3c6fadef507e"],
Cell[CellGroupData[{
Cell[22404, 571, 428, 11, 46, "Input",ExpressionUUID->"f348e3bc-b0f3-411d-81b1-24bf47c0072b"],
Cell[22835, 584, 271, 6, 50, "Output",ExpressionUUID->"7a52755b-88ab-4207-bed2-a165c0b37ff7"]
}, Open  ]],
Cell[23121, 593, 4165, 94, 509, "Input",ExpressionUUID->"8b91fa4a-2c2b-462b-be5d-c60a3980157d"],
Cell[CellGroupData[{
Cell[27311, 691, 792, 21, 68, "Input",ExpressionUUID->"0a11d514-4a1c-4f44-a4a8-0d72c952592a"],
Cell[28106, 714, 320, 6, 50, "Output",ExpressionUUID->"79c6b550-fa5e-40a8-b66d-415e32da3c7a"]
}, Open  ]],
Cell[CellGroupData[{
Cell[28463, 725, 654, 18, 46, "Input",ExpressionUUID->"9f68365c-7ef4-44a6-ade1-62c99acc3e2c"],
Cell[29120, 745, 218, 4, 50, "Output",ExpressionUUID->"e292524b-8f62-471e-a7a2-e153f53b5c9e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[29375, 754, 680, 19, 46, "Input",ExpressionUUID->"6a5629e4-6048-423a-be95-632c4b6334f1"],
Cell[30058, 775, 246, 5, 50, "Output",ExpressionUUID->"4a1161aa-a8f3-47b1-a664-9b858831904e"]
}, Open  ]],
Cell[30319, 783, 7703, 159, 719, "Input",ExpressionUUID->"e483c76d-4ef6-4c23-a0c3-86d4c5ada03e"],
Cell[CellGroupData[{
Cell[38047, 946, 730, 20, 68, "Input",ExpressionUUID->"5f2ed719-ac0d-4d5b-8e19-564399c8d621"],
Cell[38780, 968, 562, 12, 24, "Print",ExpressionUUID->"e7dc5b04-0014-4f3b-891c-ba9fbebe8aab"],
Cell[39345, 982, 464, 8, 50, "Output",ExpressionUUID->"bb6e0fcd-578c-4098-80ec-bb26b4da06b8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[39846, 995, 561, 16, 46, "Input",ExpressionUUID->"c2fba67a-7bdf-4ba2-8f2b-a3ae081140ec"],
Cell[40410, 1013, 531, 11, 24, "Print",ExpressionUUID->"e2a50457-0d38-41cb-aba6-c64baaaa1bc2"],
Cell[40944, 1026, 420, 8, 50, "Output",ExpressionUUID->"3aa0a350-b3bb-48dd-8328-32e9c9167f8d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[41401, 1039, 561, 16, 46, "Input",ExpressionUUID->"2d610d19-1613-45eb-922a-4a12fb8fc04e"],
Cell[41965, 1057, 527, 11, 24, "Print",ExpressionUUID->"6bf39099-ff89-4ce4-bd66-28d5dede9751"],
Cell[42495, 1070, 357, 6, 50, "Output",ExpressionUUID->"da0771ef-72e9-4df8-b422-f29582882b8c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[42889, 1081, 604, 18, 46, "Input",ExpressionUUID->"d09c631f-1bef-4630-adba-8b0c250aced1"],
Cell[43496, 1101, 195, 4, 50, "Output",ExpressionUUID->"2c2e3eda-3c3e-4506-aff5-955226487378"]
}, Open  ]],
Cell[CellGroupData[{
Cell[43728, 1110, 647, 20, 46, "Input",ExpressionUUID->"654cf777-94b7-43b4-9b5e-3a2143245a62"],
Cell[44378, 1132, 455, 10, 24, "Print",ExpressionUUID->"2dcfff8c-0d3c-4627-8de1-011c8cfc9290"],
Cell[44836, 1144, 219, 4, 50, "Output",ExpressionUUID->"74dd6a84-9d25-4715-bac3-85128e73246e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[45092, 1153, 644, 18, 46, "Input",ExpressionUUID->"472001e1-360d-4238-ab6b-d30c8c031ef5"],
Cell[45739, 1173, 363, 7, 50, "Output",ExpressionUUID->"ec6bf211-f42a-404a-90f4-50587ca8a078"]
}, Open  ]],
Cell[CellGroupData[{
Cell[46139, 1185, 1052, 26, 68, "Input",ExpressionUUID->"052a07e9-ad70-4a44-9262-60556ba67560"],
Cell[47194, 1213, 562, 9, 50, "Output",ExpressionUUID->"cd09b692-9d42-403d-b6c3-090861dc94cc"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47793, 1227, 1436, 38, 110, "Input",ExpressionUUID->"7d4b7f62-15e5-493a-a0ff-bd645a1c72fe"],
Cell[49232, 1267, 264, 5, 50, "Output",ExpressionUUID->"2ba30283-dfaa-4c91-bc02-0af6ba3e0551"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[49545, 1278, 159, 3, 45, "Subsubsection",ExpressionUUID->"860ecf3f-126c-4242-b0a0-a43539d30056"],
Cell[49707, 1283, 1932, 45, 236, "Input",ExpressionUUID->"93b204ca-4e4c-4a2e-ba0b-2ac46e1c29bc"],
Cell[CellGroupData[{
Cell[51664, 1332, 703, 17, 68, "Input",ExpressionUUID->"762982a6-4495-44df-a9b7-2241abbd5e97"],
Cell[52370, 1351, 458, 10, 50, "Output",ExpressionUUID->"daa01937-22dd-45f6-8713-9a41f7286038"]
}, Open  ]],
Cell[52843, 1364, 3978, 88, 362, "Input",ExpressionUUID->"8a4990e6-7b16-4404-839b-cd0eef7fe16b"],
Cell[CellGroupData[{
Cell[56846, 1456, 401, 10, 46, "Input",ExpressionUUID->"71b91590-dc4b-4b7f-90cd-0b560168978e"],
Cell[57250, 1468, 266, 5, 50, "Output",ExpressionUUID->"d550fea5-dc95-445f-88d7-002d6e8d3ada"]
}, Open  ]],
Cell[CellGroupData[{
Cell[57553, 1478, 366, 9, 46, "Input",ExpressionUUID->"cd262e54-f586-415d-85b7-84867466dbe8"],
Cell[57922, 1489, 288, 5, 50, "Output",ExpressionUUID->"2c77722b-3f26-4608-979e-efbeab6ecb06"]
}, Open  ]],
Cell[58225, 1497, 3209, 68, 278, "Input",ExpressionUUID->"a50f631a-f109-4c7d-ac2f-31f1d76e94a6"],
Cell[CellGroupData[{
Cell[61459, 1569, 401, 10, 46, "Input",ExpressionUUID->"89e31cdc-02ea-48ef-8286-20bb5b682d86"],
Cell[61863, 1581, 472, 11, 24, "Print",ExpressionUUID->"172f5acb-637c-4bfa-991d-9b3bc258d1fd"],
Cell[62338, 1594, 472, 8, 50, "Output",ExpressionUUID->"3e27ad04-7391-4f4a-b553-8bceb4ca6e33"]
}, Open  ]],
Cell[CellGroupData[{
Cell[62847, 1607, 449, 11, 46, "Input",ExpressionUUID->"85b1a89a-1b9c-4081-8f6f-1d3a3768563b"],
Cell[63299, 1620, 293, 5, 50, "Output",ExpressionUUID->"c7bfa07d-5b3d-4ae7-b0f0-a2f4df8c580c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[63629, 1630, 577, 16, 46, "Input",ExpressionUUID->"da6ccecd-1ccb-4d2b-9089-2161dd059aca"],
Cell[64209, 1648, 448, 10, 24, "Print",ExpressionUUID->"a20a5599-0df7-4685-8947-ad6a17647950"],
Cell[64660, 1660, 345, 6, 50, "Output",ExpressionUUID->"4c695fdf-3813-4216-99e4-d800d017d691"]
}, Open  ]],
Cell[CellGroupData[{
Cell[65042, 1671, 428, 11, 46, "Input",ExpressionUUID->"373b4774-e5d9-429b-8643-d3ff7b17ed71"],
Cell[65473, 1684, 472, 11, 24, "Print",ExpressionUUID->"38863f96-80c2-457e-a014-0ab6b61ce362"],
Cell[65948, 1697, 265, 5, 50, "Output",ExpressionUUID->"97676747-c329-490f-a4b7-d533941debcf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[66250, 1707, 610, 16, 46, "Input",ExpressionUUID->"55f9687f-9a66-45b4-a589-3a0903b19e58"],
Cell[66863, 1725, 295, 5, 50, "Output",ExpressionUUID->"f2d7c2d4-ffee-418d-b346-31419c8467c0"]
}, Open  ]],
Cell[CellGroupData[{
Cell[67195, 1735, 734, 19, 46, "Input",ExpressionUUID->"488559eb-3ae1-45ff-8044-0c2f5a84fe96"],
Cell[67932, 1756, 473, 11, 24, "Print",ExpressionUUID->"a43e2be4-84eb-4126-99ab-c21cdfd44fbe"],
Cell[68408, 1769, 347, 6, 50, "Output",ExpressionUUID->"f9bb61d2-9379-44b1-8645-4ffd189c2558"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[68804, 1781, 164, 3, 45, "Subsubsection",ExpressionUUID->"01b4bb29-53a2-4119-9569-29e2d947f1da"],
Cell[68971, 1786, 4778, 111, 551, "Input",ExpressionUUID->"ae6d1712-9449-4af9-8ff0-701e5d9c6cf4"],
Cell[CellGroupData[{
Cell[73774, 1901, 664, 16, 68, "Input",ExpressionUUID->"e80b25bf-be87-46e4-8d6b-f2805c2fc3ca"],
Cell[74441, 1919, 344, 6, 24, "Print",ExpressionUUID->"43e50b40-636d-4a62-8679-fb818e06df3c"],
Cell[74788, 1927, 387, 7, 50, "Output",ExpressionUUID->"2f97db09-887e-4e0a-b602-5bd94c5e86aa"]
}, Open  ]],
Cell[CellGroupData[{
Cell[75212, 1939, 533, 13, 46, "Input",ExpressionUUID->"ba39d844-12fa-4cc5-bfd8-7e88db5a3871"],
Cell[75748, 1954, 341, 6, 24, "Print",ExpressionUUID->"88013eff-5401-4729-b1b5-074a9fe2b59f"],
Cell[76092, 1962, 319, 6, 50, "Output",ExpressionUUID->"24967988-7847-4607-8738-c94784426738"]
}, Open  ]],
Cell[CellGroupData[{
Cell[76448, 1973, 526, 13, 46, "Input",ExpressionUUID->"fa875534-47fd-4938-8502-0db2e68e8019"],
Cell[76977, 1988, 340, 6, 24, "Print",ExpressionUUID->"d1137427-ea64-481a-8679-5357c52e380f"],
Cell[77320, 1996, 317, 6, 50, "Output",ExpressionUUID->"3d927edf-0988-44f3-8b63-2ce05b99b2c4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[77674, 2007, 540, 13, 46, "Input",ExpressionUUID->"cde14fed-c855-4c3c-8659-fa14e0cd7254"],
Cell[78217, 2022, 268, 5, 50, "Output",ExpressionUUID->"cc6088b7-16f9-4115-842e-70ebaec0337f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[78522, 2032, 655, 18, 30, "Input",ExpressionUUID->"c1b2f530-637b-4cb5-b512-e0e33eec058f"],
Cell[79180, 2052, 394, 7, 24, "Print",ExpressionUUID->"252a63dd-7b29-4ae1-92fa-c17dd9d84e05"],
Cell[79577, 2061, 276, 5, 34, "Output",ExpressionUUID->"5b5d726f-5b87-4e8b-8d76-027997efa9e9"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[79902, 2072, 164, 3, 45, "Subsubsection",ExpressionUUID->"ac3a1b25-ce81-4e99-b017-0fa0ade60710"],
Cell[80069, 2077, 2890, 69, 299, "Input",ExpressionUUID->"840f6230-eb7c-4297-8945-8ef6bc3c5858"],
Cell[CellGroupData[{
Cell[82984, 2150, 525, 13, 68, "Input",ExpressionUUID->"86311cc8-305f-4a9b-b46d-a57903540653"],
Cell[83512, 2165, 363, 6, 50, "Output",ExpressionUUID->"203d2aa0-93bc-452b-b5ee-e89177dee268"]
}, Open  ]],
Cell[CellGroupData[{
Cell[83912, 2176, 365, 10, 46, "Input",ExpressionUUID->"e000156b-7381-4eca-bc4a-4533e6974666"],
Cell[84280, 2188, 284, 5, 50, "Output",ExpressionUUID->"8a32fa8f-0acf-4bde-bba7-54994bee5014"]
}, Open  ]],
Cell[CellGroupData[{
Cell[84601, 2198, 389, 10, 46, "Input",ExpressionUUID->"ef6caa89-e97d-4d4c-aff0-ba0005abce38"],
Cell[84993, 2210, 288, 5, 50, "Output",ExpressionUUID->"ebf6321c-9ba0-411c-8102-d730d981dc78"]
}, Open  ]],
Cell[CellGroupData[{
Cell[85318, 2220, 389, 10, 46, "Input",ExpressionUUID->"42637ec6-b32b-4abb-8b14-b5d367189808"],
Cell[85710, 2232, 266, 5, 50, "Output",ExpressionUUID->"86268a56-c88e-4c2e-905d-6c411d09cd81"]
}, Open  ]],
Cell[CellGroupData[{
Cell[86013, 2242, 367, 9, 46, "Input",ExpressionUUID->"4e76d178-352b-4b8c-852f-f0e7eadc4fac"],
Cell[86383, 2253, 244, 5, 50, "Output",ExpressionUUID->"c30d5d52-1748-475e-b5b3-2e665bdfa015"]
}, Open  ]],
Cell[86642, 2261, 4423, 96, 509, "Input",ExpressionUUID->"e6bbddd7-dab9-407a-98bb-2aaa7ca37c27"],
Cell[CellGroupData[{
Cell[91090, 2361, 838, 23, 68, "Input",ExpressionUUID->"c76ac05c-cb4a-4ae2-b68b-dcec709cc620"],
Cell[91931, 2386, 287, 5, 50, "Output",ExpressionUUID->"0d4b20bc-d566-4a21-b866-faad66ba1dd7"]
}, Open  ]],
Cell[CellGroupData[{
Cell[92255, 2396, 714, 20, 46, "Input",ExpressionUUID->"512c0921-0b48-4b8b-8919-fc031f078b76"],
Cell[92972, 2418, 288, 5, 50, "Output",ExpressionUUID->"0d6cd77c-eb11-496b-aa70-3103e48ac319"]
}, Open  ]],
Cell[CellGroupData[{
Cell[93297, 2428, 711, 20, 46, "Input",ExpressionUUID->"807d530d-caa8-4b2e-b423-ac36781ca8c3"],
Cell[94011, 2450, 458, 10, 24, "Print",ExpressionUUID->"891177dd-0158-4e5e-bf91-5b85ed6f4685"],
Cell[94472, 2462, 346, 7, 50, "Output",ExpressionUUID->"9461b274-c8e6-444c-af2c-3557a96ba2b2"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[94867, 2475, 211, 4, 45, "Subsubsection",ExpressionUUID->"52d75978-1899-4bfc-9e0e-4e52e654a5e2"],
Cell[95081, 2481, 2652, 59, 320, "Input",ExpressionUUID->"6b8636c2-27c5-466f-804a-879e9efa61ea"],
Cell[CellGroupData[{
Cell[97758, 2544, 612, 15, 68, "Input",ExpressionUUID->"e41e80f8-1c02-4c2c-bd50-82878f827e01"],
Cell[98373, 2561, 294, 6, 50, "Output",ExpressionUUID->"e7a8989a-5e71-49bf-8525-4b9222a602a4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[98704, 2572, 475, 12, 46, "Input",ExpressionUUID->"378771e8-ce9e-4563-9887-d332ab879a9b"],
Cell[99182, 2586, 244, 5, 50, "Output",ExpressionUUID->"6083aa3d-20a2-4e04-93a8-78b322c1399d"]
}, Open  ]],
Cell[99441, 2594, 4788, 107, 488, "Input",ExpressionUUID->"2c842c0b-83aa-46cd-9933-5bf73fe15b3b"],
Cell[104232, 2703, 217, 5, 30, "Input",ExpressionUUID->"b84c9e77-7fb6-4bdf-b04d-94d2fd1cbe48"],
Cell[CellGroupData[{
Cell[104474, 2712, 646, 17, 46, "Input",ExpressionUUID->"330d843c-93e9-40d5-8e18-7d7ebd23fdcf"],
Cell[105123, 2731, 244, 5, 50, "Output",ExpressionUUID->"81ee5013-0772-44b8-b3ac-b0c84121bbe1"]
}, Open  ]],
Cell[CellGroupData[{
Cell[105404, 2741, 619, 17, 46, "Input",ExpressionUUID->"ae2864c2-c8e1-42d3-9c13-93ed9aede99f"],
Cell[106026, 2760, 244, 5, 50, "Output",ExpressionUUID->"deeb6d05-8971-407d-9051-ac6e0ee4bf99"]
}, Open  ]],
Cell[CellGroupData[{
Cell[106307, 2770, 661, 17, 46, "Input",ExpressionUUID->"87ec2677-c3b4-4176-a32f-0da6291f5d51"],
Cell[106971, 2789, 219, 4, 50, "Output",ExpressionUUID->"1e8b756c-0e08-4c92-9e21-9209f0e89403"]
}, Open  ]],
Cell[CellGroupData[{
Cell[107227, 2798, 814, 21, 68, "Input",ExpressionUUID->"122004cc-e8c6-461c-9577-e79553c57395"],
Cell[108044, 2821, 249, 5, 50, "Output",ExpressionUUID->"d4a8e041-bd77-4011-8e30-5ba78aa2d59a"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[108354, 2833, 201, 3, 54, "Subsection",ExpressionUUID->"64cceb59-ca82-4714-9dba-51f525342c58"],
Cell[108558, 2838, 4416, 106, 425, "Input",ExpressionUUID->"98bdc290-09c0-4cd1-b681-2f4e6aac0108"]
}, Open  ]],
Cell[CellGroupData[{
Cell[113011, 2949, 253, 6, 81, "Subsection",ExpressionUUID->"63c6846a-3146-499b-a679-dd0e03554f91"],
Cell[113267, 2957, 23030, 454, 2042, "Input",ExpressionUUID->"ccafa8d0-6bf2-4c60-9f6a-608a9f17b69b"],
Cell[CellGroupData[{
Cell[136322, 3415, 1301, 35, 89, "Input",ExpressionUUID->"076596a0-bf76-4d42-bacf-85e506d0537a"],
Cell[137626, 3452, 1584, 30, 53, "Output",ExpressionUUID->"4d34cd75-a0e2-4f4a-949d-cd70c22874c7"],
Cell[139213, 3484, 1870, 40, 50, "Output",ExpressionUUID->"01a2739d-c3f4-4844-a5b3-f344fb65d173"]
}, Open  ]],
Cell[CellGroupData[{
Cell[141120, 3529, 1498, 41, 152, "Input",ExpressionUUID->"dc90296a-565b-42fb-8a9f-e9c88abe70f1"],
Cell[142621, 3572, 1380, 32, 72, "Output",ExpressionUUID->"4ea4a444-837b-4337-aff8-957a0ccf6de4"],
Cell[144004, 3606, 1886, 45, 72, "Output",ExpressionUUID->"67411bca-9af4-4fd3-ab72-96f5eacd4d0d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[145927, 3656, 1038, 30, 68, "Input",ExpressionUUID->"a4d8e181-29c5-4f0f-a75f-2669d6a5c9b8"],
Cell[146968, 3688, 501, 15, 53, "Output",ExpressionUUID->"a5b185e5-1464-4406-a79a-d9b124913113"]
}, Open  ]],
Cell[CellGroupData[{
Cell[147506, 3708, 1390, 39, 173, "Input",ExpressionUUID->"18dfe7f0-a27c-4a75-a513-001f2b74d274"],
Cell[148899, 3749, 363, 6, 50, "Output",ExpressionUUID->"62a0a5bb-144e-4cbd-b0e3-b0946559e7cb"]
}, Open  ]],
Cell[149277, 3758, 4370, 100, 425, "Input",ExpressionUUID->"24e0e55c-0ba5-49fd-a3d7-175cc07da14a"],
Cell[CellGroupData[{
Cell[153672, 3862, 1397, 39, 173, "Input",ExpressionUUID->"228a3c90-2ff0-4ae0-8aad-1c273a0b4c22"],
Cell[155072, 3903, 275, 6, 50, "Output",ExpressionUUID->"67de80dd-2941-4d9c-8ee0-5388f6f86cec"]
}, Open  ]],
Cell[CellGroupData[{
Cell[155384, 3914, 753, 20, 68, "Input",ExpressionUUID->"2d043491-67b5-41ec-9590-e83254d3eba0"],
Cell[156140, 3936, 446, 10, 24, "Print",ExpressionUUID->"f14d6338-b0e6-4c82-ac98-7a4d5bdc9dc0"],
Cell[156589, 3948, 341, 6, 50, "Output",ExpressionUUID->"3ba3a6bb-cb22-4880-9d36-85dfc91238c8"]
}, Open  ]],
Cell[CellGroupData[{
Cell[156967, 3959, 397, 9, 46, "Input",ExpressionUUID->"8e2bf6d8-d21c-428e-8c7e-ee3630c6f4a0"],
Cell[157367, 3970, 252, 5, 24, "Print",ExpressionUUID->"fbe93493-f121-4af7-a783-2ba5a241047d"],
Cell[157622, 3977, 252, 4, 34, "Output",ExpressionUUID->"277ff67b-5344-4a06-93cc-de6aa43d2760"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[157935, 3988, 225, 4, 67, "Section",ExpressionUUID->"304874bb-f745-4256-941a-ca6fe7f33ef1"],
Cell[CellGroupData[{
Cell[158185, 3996, 239, 6, 54, "Subsection",ExpressionUUID->"2635a156-6810-41fc-97f4-8325ebb5c6fe"],
Cell[158427, 4004, 5515, 117, 719, "Input",ExpressionUUID->"58231657-6491-4e73-a35a-56a1f0a7ca81"],
Cell[163945, 4123, 2208, 50, 215, "Input",ExpressionUUID->"e26cc0b3-8264-48a6-8e4c-6b690dbfb1fc"],
Cell[CellGroupData[{
Cell[166178, 4177, 1123, 32, 89, "Input",ExpressionUUID->"6fb0c527-fb78-40b0-8abb-ea65ace83645"],
Cell[167304, 4211, 353, 8, 50, "Output",ExpressionUUID->"0b4fdb59-c223-4932-9f0a-625caf666929"]
}, Open  ]],
Cell[167672, 4222, 5172, 114, 425, "Input",ExpressionUUID->"2214e809-7e6b-433f-a2a7-37570e68ceb8"],
Cell[CellGroupData[{
Cell[172869, 4340, 1741, 39, 173, "Input",ExpressionUUID->"d66b0b03-1e55-4de2-8077-e493204218a6"],
Cell[CellGroupData[{
Cell[174635, 4383, 1139, 35, 27, "Print",ExpressionUUID->"887a5ceb-27b4-4137-adf8-3df350c624b8"],
Cell[175777, 4420, 253, 6, 24, "Print",ExpressionUUID->"d19d680f-bd60-47da-af79-230a40dde629"],
Cell[176033, 4428, 254, 6, 24, "Print",ExpressionUUID->"cb6a27ba-e83e-4993-91e8-910e1a74d162"],
Cell[176290, 4436, 1428, 44, 49, "Print",ExpressionUUID->"bbca9102-ea7a-4473-8e53-c867be2fe180"],
Cell[177721, 4482, 251, 6, 24, "Print",ExpressionUUID->"48fc16f1-f82c-477b-aac7-fc50990299cf"],
Cell[177975, 4490, 256, 6, 24, "Print",ExpressionUUID->"ee24afc6-47a4-4082-867d-a21209066f97"],
Cell[178234, 4498, 466, 14, 27, "Print",ExpressionUUID->"945c4ab7-2786-4318-baec-d9402bafcf03"],
Cell[178703, 4514, 293, 5, 24, "Print",ExpressionUUID->"092f7d7b-a5f7-4b42-b84c-f368ffdc648d"],
Cell[178999, 4521, 251, 6, 24, "Print",ExpressionUUID->"9bd0cb5d-7dc6-460a-b66e-c2183a0e201a"],
Cell[179253, 4529, 257, 6, 24, "Print",ExpressionUUID->"320751eb-4a97-435c-ba5e-49bf69eedffe"],
Cell[179513, 4537, 1391, 43, 49, "Print",ExpressionUUID->"f4656869-e808-43b5-95a4-8ee2e00862a2"],
Cell[180907, 4582, 251, 6, 24, "Print",ExpressionUUID->"a77b1d8b-a19e-4967-a5e4-ba2c6bbdc093"],
Cell[181161, 4590, 257, 6, 24, "Print",ExpressionUUID->"ee3a307b-459d-4e20-a378-177d959eea84"],
Cell[181421, 4598, 1157, 36, 27, "Print",ExpressionUUID->"b2726c72-8ff3-4bb9-b2e0-dc96cf71c0a5"],
Cell[182581, 4636, 448, 10, 24, "Print",ExpressionUUID->"5dc96bf1-a73e-4a20-8792-0e7e63a4c96f"],
Cell[183032, 4648, 251, 6, 24, "Print",ExpressionUUID->"55638bbb-2d7f-446a-b619-357d77be1adf"],
Cell[183286, 4656, 257, 6, 24, "Print",ExpressionUUID->"9a3cbdb7-e1c8-4847-9312-d1244509b19c"],
Cell[183546, 4664, 1499, 46, 49, "Print",ExpressionUUID->"7419de11-cbae-4aed-ab62-4fa1f32d9124"],
Cell[185048, 4712, 251, 6, 24, "Print",ExpressionUUID->"f62f19ed-5566-4fea-ba34-c608dfef14ae"],
Cell[185302, 4720, 254, 6, 24, "Print",ExpressionUUID->"b188f2d9-ddbb-410c-86bc-c6f77a863cbb"],
Cell[185559, 4728, 1640, 50, 49, "Print",ExpressionUUID->"27832121-d69f-4142-b814-5650205ecb5e"],
Cell[187202, 4780, 251, 6, 24, "Print",ExpressionUUID->"c5ed6fc6-e8ff-41ae-a8eb-b930db8f000a"],
Cell[187456, 4788, 254, 6, 24, "Print",ExpressionUUID->"cf1f30fb-96a5-4534-99a9-0caac69eaa43"],
Cell[187713, 4796, 1342, 42, 49, "Print",ExpressionUUID->"7e6549ba-cc41-45fd-94bb-5b07ed805266"],
Cell[189058, 4840, 445, 10, 24, "Print",ExpressionUUID->"cda8e9ba-cc98-4081-ab88-17e73b988819"],
Cell[189506, 4852, 251, 6, 24, "Print",ExpressionUUID->"86d6738b-eb5c-4273-acb4-1b24f37ea0f4"],
Cell[189760, 4860, 255, 6, 24, "Print",ExpressionUUID->"82ae89bd-7b9b-485b-b5c3-b74893e6e482"],
Cell[190018, 4868, 911, 28, 27, "Print",ExpressionUUID->"89f486ca-171a-4f7b-b0d4-208e9a831ab1"],
Cell[190932, 4898, 446, 10, 24, "Print",ExpressionUUID->"ec62528e-a4b5-4a85-88cc-e1702241ecb5"],
Cell[191381, 4910, 251, 6, 24, "Print",ExpressionUUID->"f446b149-ecf9-4e71-8077-bb04a8905525"],
Cell[191635, 4918, 257, 6, 24, "Print",ExpressionUUID->"ad0d1d33-33fa-4645-9850-c695ad2eb323"],
Cell[191895, 4926, 1675, 52, 49, "Print",ExpressionUUID->"68445f61-efac-4210-8804-f9c0b9efee8b"],
Cell[193573, 4980, 446, 10, 24, "Print",ExpressionUUID->"620fa93c-31c9-4936-8ba0-eef767bdc023"],
Cell[194022, 4992, 251, 6, 24, "Print",ExpressionUUID->"6ebfae7b-8133-4415-9926-34f55f7a21bd"],
Cell[194276, 5000, 255, 6, 24, "Print",ExpressionUUID->"4846f7d3-74e6-4229-b32f-f15608c54bd0"],
Cell[194534, 5008, 1213, 35, 27, "Print",ExpressionUUID->"9357978c-29e5-43b9-b1fd-116095d0ae67"],
Cell[195750, 5045, 293, 5, 24, "Print",ExpressionUUID->"6556ce15-a9d6-42d8-a0d2-d5495f918a2b"],
Cell[196046, 5052, 251, 6, 24, "Print",ExpressionUUID->"c60d537e-83e4-4223-b662-d3601d5a48ea"],
Cell[196300, 5060, 256, 6, 24, "Print",ExpressionUUID->"c5a8a20f-179c-47ff-b663-78eef270fe71"],
Cell[196559, 5068, 1155, 32, 27, "Print",ExpressionUUID->"0e716f6b-637c-4183-9d73-db7cb6576ab4"],
Cell[197717, 5102, 435, 9, 24, "Print",ExpressionUUID->"35c93ecb-5397-49c2-8527-42bcf5593eab"],
Cell[198155, 5113, 251, 6, 24, "Print",ExpressionUUID->"8b9caea3-b0b6-4b9c-ab82-53d21f44088d"],
Cell[198409, 5121, 257, 6, 24, "Print",ExpressionUUID->"3079568e-db86-450c-9829-d687abea110e"],
Cell[198669, 5129, 1316, 37, 27, "Print",ExpressionUUID->"cdff7f83-8a68-443c-be15-de4629f07a4c"],
Cell[199988, 5168, 446, 10, 24, "Print",ExpressionUUID->"d079d66d-a5c6-44a7-93f6-9e4975790f83"],
Cell[200437, 5180, 250, 6, 24, "Print",ExpressionUUID->"158452ee-da99-4a79-ac56-2c8a39c7e0d5"],
Cell[200690, 5188, 254, 6, 24, "Print",ExpressionUUID->"4b234e61-33bb-4966-bc77-026b8953f60b"],
Cell[200947, 5196, 702, 20, 27, "Print",ExpressionUUID->"88653ec9-e880-40ae-921f-b58034f0652d"],
Cell[201652, 5218, 295, 5, 24, "Print",ExpressionUUID->"4f19ff0b-18fa-4c25-a8c5-ac2d9ac4214d"],
Cell[201950, 5225, 250, 6, 24, "Print",ExpressionUUID->"a63664c9-a447-4c2a-9475-398a88440a36"],
Cell[202203, 5233, 254, 6, 24, "Print",ExpressionUUID->"ff1bc654-929e-44dd-aa0c-220aaada1dec"],
Cell[202460, 5241, 1080, 31, 27, "Print",ExpressionUUID->"562e73df-6ea8-45e4-bf58-a74b763ff192"],
Cell[203543, 5274, 293, 5, 24, "Print",ExpressionUUID->"9de5962b-6d52-4b0f-b3a6-f3224eccc6a1"],
Cell[203839, 5281, 251, 6, 24, "Print",ExpressionUUID->"479e3a4d-d86f-40e3-bcf5-dd6b45900ae3"],
Cell[204093, 5289, 257, 6, 24, "Print",ExpressionUUID->"dbe5ba42-57f7-4ad7-8f2e-d98609c28d8a"],
Cell[204353, 5297, 1258, 35, 27, "Print",ExpressionUUID->"2ad06014-1c2d-4823-93ee-1c242dbc6ae5"],
Cell[205614, 5334, 433, 9, 24, "Print",ExpressionUUID->"72741426-6df9-4335-818b-ca59b517e169"],
Cell[206050, 5345, 250, 6, 24, "Print",ExpressionUUID->"44e01ffd-6589-45f0-9afc-bff5a9afc26a"],
Cell[206303, 5353, 255, 6, 24, "Print",ExpressionUUID->"9d1e2a8c-9553-423e-a61a-e8d219f956f3"],
Cell[206561, 5361, 717, 20, 27, "Print",ExpressionUUID->"7fda7cf1-6956-4f1a-a39e-fd3632e2310f"],
Cell[207281, 5383, 446, 10, 24, "Print",ExpressionUUID->"38fe62c5-ae2e-4998-b4ac-e8573e5d9fe9"],
Cell[207730, 5395, 251, 6, 24, "Print",ExpressionUUID->"1111f9a1-03a6-4a38-98c9-1a123e82acc6"],
Cell[207984, 5403, 255, 6, 24, "Print",ExpressionUUID->"6e59007f-b0dd-4999-bc80-e9e4627d22b4"],
Cell[208242, 5411, 1250, 35, 27, "Print",ExpressionUUID->"a4bbc343-5647-4905-9252-5935902583a3"],
Cell[209495, 5448, 446, 10, 24, "Print",ExpressionUUID->"afaf9c0c-194b-4004-a55d-4e3f5687fb42"],
Cell[209944, 5460, 251, 6, 24, "Print",ExpressionUUID->"384db1fb-1aae-48af-96d3-8358e3a29c85"],
Cell[210198, 5468, 256, 6, 24, "Print",ExpressionUUID->"8f96f1f4-ed36-4e3d-a6b8-bdcebfe6f7f6"],
Cell[210457, 5476, 1050, 29, 27, "Print",ExpressionUUID->"73cc07e5-39ea-43e7-86d4-342f7114fb4c"],
Cell[211510, 5507, 446, 10, 24, "Print",ExpressionUUID->"d0f64788-cec1-4563-a886-329542ddc0fd"],
Cell[211959, 5519, 251, 6, 24, "Print",ExpressionUUID->"4c70fd2d-ebd0-4920-921b-8d3dbe1ed5f7"],
Cell[212213, 5527, 255, 6, 24, "Print",ExpressionUUID->"8ad37c23-3a3e-4a4f-a4f8-f6d63368328c"],
Cell[212471, 5535, 1379, 39, 27, "Print",ExpressionUUID->"d367ff59-f768-4c87-8282-131d54877d5b"],
Cell[213853, 5576, 435, 9, 24, "Print",ExpressionUUID->"f940bacc-baa3-4730-a793-75037c318ff2"],
Cell[214291, 5587, 250, 6, 24, "Print",ExpressionUUID->"e4a59ede-f49f-4c66-b8de-437f0371b478"],
Cell[214544, 5595, 255, 6, 24, "Print",ExpressionUUID->"9c08a6f3-b60b-4703-af34-bc75ae4c9b74"],
Cell[214802, 5603, 2483, 74, 49, "Print",ExpressionUUID->"24099161-a349-4430-98c5-06a31402d0c9"],
Cell[217288, 5679, 251, 6, 24, "Print",ExpressionUUID->"034feb47-8173-40ee-a35b-ea652723db71"],
Cell[217542, 5687, 257, 6, 24, "Print",ExpressionUUID->"60cec45f-6eb3-46bd-adf8-2d815f719177"],
Cell[217802, 5695, 2095, 63, 49, "Print",ExpressionUUID->"b725b191-b4f2-4231-be0e-3a9f95eb80db"],
Cell[219900, 5760, 446, 10, 24, "Print",ExpressionUUID->"962245da-e53a-41b8-8504-e71c58f5e934"],
Cell[220349, 5772, 250, 6, 24, "Print",ExpressionUUID->"6ed2bfd7-4e29-4e5e-8353-ba1d938209b8"],
Cell[220602, 5780, 255, 6, 24, "Print",ExpressionUUID->"eb3a9556-103f-4791-b357-7d01c0d993ca"],
Cell[220860, 5788, 1383, 42, 27, "Print",ExpressionUUID->"c944b1c6-1458-4e09-9e7e-e8f4df591ffd"],
Cell[222246, 5832, 446, 10, 24, "Print",ExpressionUUID->"27ee0249-c4ec-4d42-993a-95368ce00f37"],
Cell[222695, 5844, 253, 6, 24, "Print",ExpressionUUID->"77e73bd1-9bb5-4004-8ceb-3bf779885e16"],
Cell[222951, 5852, 255, 6, 24, "Print",ExpressionUUID->"2bc8e35e-d7e5-448a-9855-86ddca5c1427"],
Cell[223209, 5860, 1847, 55, 49, "Print",ExpressionUUID->"2989e6ba-0f9a-4986-9672-d92d326ada75"],
Cell[225059, 5917, 253, 6, 24, "Print",ExpressionUUID->"52653194-083b-4112-81ec-3a17e6d384f8"],
Cell[225315, 5925, 255, 6, 24, "Print",ExpressionUUID->"8cf1e545-8fe7-4de9-b5a0-e06233d85e06"],
Cell[225573, 5933, 2429, 72, 49, "Print",ExpressionUUID->"5459e07c-7243-4bd0-b6fa-3037af1fa912"],
Cell[228005, 6007, 253, 6, 24, "Print",ExpressionUUID->"6d4dde24-7c57-4323-b2bb-b4a60ec8cadb"],
Cell[228261, 6015, 255, 6, 24, "Print",ExpressionUUID->"790b0d3f-dc12-4b80-aec4-3a9536a3e05a"],
Cell[228519, 6023, 883, 26, 27, "Print",ExpressionUUID->"25ad7ad7-1916-4625-93b4-44bfbde1d9f3"],
Cell[229405, 6051, 293, 5, 24, "Print",ExpressionUUID->"b6456ba6-396e-485f-a216-e7b35031a196"],
Cell[229701, 6058, 251, 6, 24, "Print",ExpressionUUID->"5bb53bd7-bd66-46e2-a95c-59599871e961"],
Cell[229955, 6066, 257, 6, 24, "Print",ExpressionUUID->"346c3adf-fe05-4846-8c42-f788ff38de98"],
Cell[230215, 6074, 2655, 79, 69, "Print",ExpressionUUID->"73f20447-865b-4dde-bb2e-a5f7d49c1848"],
Cell[232873, 6155, 251, 6, 24, "Print",ExpressionUUID->"8d9ca05e-528a-4d27-9488-6285f9c63d87"],
Cell[233127, 6163, 254, 6, 24, "Print",ExpressionUUID->"49a6b54a-5b72-4a67-9934-015261374de2"],
Cell[233384, 6171, 2558, 76, 69, "Print",ExpressionUUID->"e49641a4-07e5-4586-8a15-c2e925c53026"],
Cell[235945, 6249, 295, 5, 24, "Print",ExpressionUUID->"e9b44ed5-3658-4964-be0e-108b45612110"],
Cell[236243, 6256, 251, 6, 24, "Print",ExpressionUUID->"842c0ab7-889f-43bf-a776-abca41bdccf8"],
Cell[236497, 6264, 257, 6, 24, "Print",ExpressionUUID->"30880007-93e1-489b-bb8c-c5ca00d82e8d"],
Cell[236757, 6272, 841, 25, 27, "Print",ExpressionUUID->"46d26b2e-e373-45b5-8921-eb285eb50a54"],
Cell[237601, 6299, 293, 5, 24, "Print",ExpressionUUID->"271e0098-fe1d-4673-a957-17159cc2ec2d"],
Cell[237897, 6306, 253, 6, 24, "Print",ExpressionUUID->"dd0e669d-09db-47e3-abeb-06aa80b4d754"],
Cell[238153, 6314, 257, 6, 24, "Print",ExpressionUUID->"b0963398-208b-42d9-90f2-081c931ec78b"],
Cell[238413, 6322, 849, 25, 27, "Print",ExpressionUUID->"4901d833-7156-4a5e-9dd9-a683e8275f85"],
Cell[239265, 6349, 293, 5, 24, "Print",ExpressionUUID->"a7e4a88c-fffd-441b-b6f8-3db5e4cabf30"],
Cell[239561, 6356, 251, 6, 24, "Print",ExpressionUUID->"5ec445f6-bb63-40c8-9de2-10726e70e6ea"],
Cell[239815, 6364, 255, 6, 24, "Print",ExpressionUUID->"bc3d2a09-46ef-42bb-918a-095319cf11be"],
Cell[240073, 6372, 932, 27, 27, "Print",ExpressionUUID->"3900818a-20e4-430e-9c0b-9033645a8592"],
Cell[241008, 6401, 445, 10, 24, "Print",ExpressionUUID->"aa4b6b7d-f88c-4c9c-b5e9-059d275ca458"],
Cell[241456, 6413, 251, 6, 24, "Print",ExpressionUUID->"192249d8-d5a2-4cc5-91e9-9c9730d0978c"]
}, Open  ]],
Cell[241722, 6422, 281, 5, 34, "Output",ExpressionUUID->"e63e5716-6053-4a7f-9444-0769a4af423d"]
}, Open  ]]
}, Open  ]],
Cell[242030, 6431, 482, 9, 108, "Subsection",ExpressionUUID->"d5404c2d-46ad-4d92-b609-50663258df91"],
Cell[242515, 6442, 472, 9, 92, "Subsection",ExpressionUUID->"0f8fe134-75ba-435f-85dc-3da05eaa36ab"]
}, Open  ]]
}
]
*)

